/*
2019/10/14 - 11:29:47
*/
var StateMachine = function (states, startAs) {
    this.states = states;
    this.currentState = startAs;
};
StateMachine.prototype = {
    currentState: null,
    states: null,
    trigger: function (eventType, eventData) {
        var state = this.states[this.currentState];
        GM.console.log('StateMachine: ' + eventType + ' = ' + this.currentState + ' >> ' + state.events[eventType] + ' (' + JSON.stringify(eventData) + ')');
        if (state.eventHandler && state.eventHandler.call(this, eventType, eventData) === false) {
            return;
        }
        if (state.events[eventType]) {
            if (state.exit) state.exit.call(this, eventType, eventData);
            this.currentState = state.events[eventType];
            state = this.states[this.currentState];
            if (state.enter) state.enter.call(this, eventType, eventData);
        }
    }
};
var GM = GM || {};
GM.console = {
    log: function () {
        if (GM.data.userData.mode === 'development') {
            if (window.console && window.console.log) {
                console.log.apply(console, Array.prototype.slice.call(arguments));
            }
        }
    }
};
if ($.pointy_tips) {
    $.pointy_tips.game_links = function (selector) {
        var tip_links = (selector ? $(selector) : $('.pointy_tips').find('a'));
        $(tip_links).each(function (i) {
            var link_title = ($.ct($(this).attr('title_holder')) ? $(this).attr('title_holder') : $(this).attr('title'));
            if ($.ct(link_title) && (link_title.indexOf('--') > -1)) {
                $(this).attr('title_holder', link_title).removeAttr('title');
            }
        });
        $(tip_links).hoverIntent(function (event) {
            var cur_link = $(this);
            var data_att = $(this).attr('data-gtip');
            if (!$.ct(data_att)) {
                return;
            }
            var use_previous = (data_att === 'prev');
            var link_title = false;
            if (use_previous) {
                var prev_link = false;
                var specsel = 'a:not([data-gtip="prev"])';
                var leads = [$(cur_link).siblings(specsel), $(cur_link).parent().prev(specsel), $(cur_link).parent().prev().find(specsel), $(cur_link).parent().parent().find(specsel)];
                $.each(leads, function (k, v) {
                    if (v.length > 0) {
                        prev_link = v;
                        return false;
                    }
                });
                leads = null;
                if (!prev_link) {
                    return;
                }
                cur_link = prev_link;
                data_att = $(cur_link).attr('data-gtip');
                if (!$.ct(data_att)) {
                    return;
                }
            }
            link_title = $(cur_link).attr('title_holder');
            if (!$.ct(link_title) || (link_title.indexOf('--') < 0)) {
                return;
            }
            var gtip_data = $.parseJSON(data_att);
            var img_use_local = ($.ct(gtip_data.img_base) && (gtip_data.img_base === 'gurl'));
            var img_height = (img_use_local ? 94 : 150);
            var gtip_img = '';
            if ($.ct(gtip_data.img)) {
                if (img_use_local) {
                    gtip_img = gtip_data.img;
                } else {
                    var image_parts = gtip_data.img.split('_');
                    gtip_img = gtip_data.img + '/' + gtip_data.img.replace(image_parts[0] + '_', '') + '_subfeature.jpg';
                }
            }
            if (gtip_data.img === 'reuse') {
                var current_img = $(cur_link).find('img').attr('src');
                if ($.ct(current_img)) {
                    var img_parts = current_img.split('_');
                    img_parts.pop();
                    var img_beg = ((img_parts.length > 1) ? img_parts.join('_') : img_parts[0]);
                    gtip_img = (img_beg + '_subfeature.jpg');
                }
            }
            var tip_parts = link_title.split('--');
            var tip_fill = '<div id="ptip_game"><h4>' + tip_parts[0] + '</h4><div>';
            if (gtip_img) {
                tip_fill += '<img src="' + gtip_img + '" height="' + String(img_height) + '" width="175" />';
            }
            tip_fill += tip_parts[1] + '</div>';
            if (tip_parts.length > 2) {
                tip_fill += '<h5><span class="ptip_game_genre">' + tip_parts[2] + '</span></h5>';
            }
            tip_fill += '</div>';
            $.pointy_tips.show_tip(tip_fill, event, {
                png_alpha: true
            });
        }, function (event) {
            $.pointy_tips.hide_tip();
        });
    };
}
$(function () {
    $.pointy_tips.game_links();
});
var GM = GM || {};
GM.content_header = {
    _key_map: {
        queue_download: GM.text.queue_games,
        queue_update: GM.text.queue_updates,
        gyb_page: GM.text.gyb,
        recent_game: GM.text.recent_activity,
        recent_error: GM.text.recent_activity,
        purchase_history_page: GM.text.purchase_history
    },
    _tip_map: {
        queue_update: GM.text.update_q_tooltip,
        gyb_page: GM.text.gyb_tooltip
    },
    _h2_map: {
        game_name: {
            recent_game: GM.text.recent_h2,
            recent_error: GM.text.recent_error_h2
        },
        gyb_page: GM.text.gyb_h2
    },
    _default_icon: 'felix',
    _icon_map: {
        queue_download: 'download',
        queue_update: 'updates',
        gyb_page: 'felix_balloons',
        recent_game: 'arrow',
        recent_error: 'alert'
    },
    _lowercase_headers: ['15', '16', '17', '19'],
    draw_header: function (key) {
        if (!key) {
            key = GM.data.userData.sort.page;
        }
        $('#content_header').replaceWith($('#tmpl_content_header').tmpl(GM.content_header._make_tmpl_object(key)));
        GM.content_header._draw_game_row_sort();
    },
    _draw_game_row_sort: function () {
        $('#game_row_sort').html($('#tmpl_game_row_sort').tmpl({
            active: GM.data.userData.sort.sort,
            title: GM.text.game_title,
            installed: GM.text.date_installed,
            played: GM.text.recently_played,
            status: GM.text.activation_status,
            sortBy: GM.text.sort_by_selector
        }));
    },
    _draw_purchase_sort: function () {
        $('#game_row_sort').html($('#tmpl_purchase_sort').tmpl({
            active: GM.data.userData.sort.sort,
            game_title: GM.text.game_title,
            order_date: GM.text.order_date,
            activation_status: GM.text.activation_status,
            sortBy: GM.text.sort_by_selector
        }));
    },
    _make_tmpl_object: function (key) {
        var tmpl = {
            icon_type: this._default_icon,
            title: ''
        };
        if (key) {
            if (key === 'recent_game' && ((GM.data.installedGames[GM.data.recent] && GM.data.installedGames[GM.data.recent].gameState.errorCode && GM.data.installedGames[GM.data.recent].gameState.errorCode > 0) || !GM.data.installedGames[GM.data.recent])) {
                key = 'recent_error';
            }
            if (this._key_map[key]) {
                tmpl.title = this._key_map[key];
            } else if (key.search(/ucgs_/) >= 0) {
                tmpl.title = GM.text.instant_games;
            } else {
                tmpl.title = GM.text.my_games_by;
            }
            if (this._tip_map[key]) {
                tmpl.whats_this = GM.text.whats_this;
                tmpl.tooltip = this._tip_map[key];
            }
            if (this._h2_map.game_name[key]) {
                tmpl.h2 = GM.render.str_replace('[GAME_NAME]', GM.game_rows.get_recently_played_game_info().name, this._h2_map.game_name[key]);
            } else if (this._h2_map[key]) {
                tmpl.h2 = this._h2_map[key];
            }
            if (this._icon_map[key]) {
                tmpl.icon_type = this._icon_map[key];
            }
            if (key === 'recent_error') {
                tmpl.error = true;
            }
            if (GM.data.userData.sort.page === 'sort_az') {
                tmpl.game_row_sort = true;
            } else {
                tmpl.game_row_sort = false;
            }
            if (key === 'purchase_history_page') {
                tmpl.game_row_sort = true;
                tmpl.sign_up_free = false;
                tmpl.purchase_refresh = true;
                tmpl.search_bar = false;
            }
            if ((GM.data.userData.sort.page === 'sort_search')) {
                tmpl.search_bar = true;
                tmpl.icon_type = '';
                tmpl.title = (GM.data.userData.siteID == 1) ? "PC Games" : "Mac Games";
            } else {
                tmpl.search_bar = false;
            }
            if ((GM.data.userData.sort.page === 'ucgs_') && !GM.data.userData.isLoggedIn) {
                tmpl.sign_up_free = true;
                tmpl.sign_up_free_text = GM.text.sign_up_free;
            } else {
                tmpl.sign_up_free = false;
            }
        }
        return tmpl;
    }
};
var GM = GM || {};
GM.game_rows = {
    game_rows: {},
    total_games: 0,
    download_err: 0,
    active_download: false,
    _uac_timeouts: {},
    _all_wrappingIDs: [],
    sorted: {
        'sort_az': [],
        'sort_installed': [],
        'sort_played': [],
        'sort_activation': []
    },
    downloading: [],
    convert: function (wrappingID) {
        GM.profiler.start_timer('Convert (' + wrappingID + ')');
        if (GM.data && GM.data.installedGames) {
            if (wrappingID && wrappingID !== 'all') {
                if (!this.game_rows[wrappingID]) {
                    this.total_games++;
                    this._all_wrappingIDs.push(wrappingID);
                }
                this.game_rows[wrappingID] = $('#tmpl_game_rows').tmpl(GM.game_rows.get_row(GM.data.installedGames[wrappingID], "convert-onerow"));
            } else {
                this.total_games = 0;
                this.game_rows = {};
                this.downloading = [];
                this.download_err = 0;
                $.each(GM.data.installedGames, function (i, obj) {
                    GM.game_rows.game_rows[obj.wrappingID] = $('#tmpl_game_rows').tmpl(GM.game_rows.get_row(obj, "convert-allrows"));
                    GM.game_rows._all_wrappingIDs.push(obj.wrappingID);
                    GM.game_rows.total_games++;
                    if ($.inArray(obj.gameState.state, [5, 17, 21]) === -1) {
                        GM.game_rows.downloading.push(obj.wrappingID);
                    }
                    if ($.inArray(obj.gameState.state, [7, 8, 9, 13, 17, 21]) > -1) {
                        GM.game_rows.download_err++;
                    }
                });
            }
        }
        GM.profiler.end_timer('Convert (' + wrappingID + ')');
        return true;
    },
    set_games: function (installedGames) {
        GM.data.installedGames = {};
        GM.data.installedGamesCount = 0;
        $.each(installedGames, function (i, obj) {
            if (GM.tools.isWrappingIDInToolRange(obj.wrappingID)) {
                GM.data.installedTools[obj.wrappingID] = obj;
            } else {
                GM.data.installedGames[obj.wrappingID] = obj;
                GM.data.installedGamesCount++;
            }
        });
        GM.pseudoGameUtils.retrieveMetadata();
        this.convert('all');
    },
    update_data_by_wrapID: function (wrappingID, gameData) {
        var redraw = false;
        if (GM.data.installedGamesCount == 0) {
            $('.dl_q_none').hide();
        }
        if (GM.data.installedGames[wrappingID]) {
            var ginfo = GM.data.installedGames[wrappingID];
            GM.data.installedGames[wrappingID] = $.extend(true, {}, GM.data.installedGames[wrappingID], gameData);
            if (gameData.gameState && ginfo.gameState.state !== gameData.gameState.state) {
                redraw = true;
            }
            if (gameData.name !== ginfo.name) {
                this.sorted.sort_az = [];
            }
            if (gameData.lastActionTime && gameData.lastActionTime !== ginfo.lastActionTime && this.sorted.sort_played.length > 0) {
                this.sorted.sort_played = [];
            }
            this.sorted.sort_activation = [];
            var is_err = ($.inArray(GM.data.installedGames[wrappingID].gameState.state, [7, 8, 9, 13, 17, 21]) === -1);
            var was_err = ($.inArray(ginfo.gameState.state, [7, 8, 9, 13, 17, 21]) === -1);
            if (is_err && !was_err) {
                this.download_err++;
            } else if (was_err && !is_err) {
                this.download_err--;
            }
            if ((GM.data.installedGames[wrappingID].gameState.state == 9) && (ginfo.gameState.state != 9)) {
                if (GM.tracking) {
                    var boolIsUpdate = false;
                    if (GM.data.updates[wrappingID]) {
                        boolIsUpdate = true;
                    }
                    GM.tracking.sendGameInstallEvent(wrappingID, boolIsUpdate);
                }
            }
            if ((GM.data.installedGames[wrappingID].gameState.state == 7) && (ginfo.gameState.state != 7)) {
                if (GM.tracking) {
                    GM.tracking.sendGameDownloadEvent(wrappingID);
                }
            }
        } else {
            if (GM.tools.isWrappingIDInToolRange(wrappingID)) {
                GM.data.installedTools[wrappingID] = $.extend(true, {}, GM.data.installedTools[wrappingID], gameData);;
                $('#content').trigger("ToolInstallUpdate", gameData);
                return;
            } else {
                GM.data.installedGames[wrappingID] = gameData;
                GM.data.installedGamesCount++;
                this.sorted.sort_az = [];
                if (this.sorted.sort_installed.length > 0) {
                    this.sorted.sort_installed.unshift(wrappingID);
                }
                if (this.sorted.sort_played.length > 0) {
                    this.sorted.sort_played.push(wrappingID);
                }
                this.sorted.sort_activation = [];
                if ($.inArray(gameData.gameState.state, [7, 8, 9, 13, 17, 21]) > -1) {
                    GM.game_rows.download_err++;
                }
                redraw = true;
            }
        }
        var is_downloading = ($.inArray(GM.data.installedGames[wrappingID].gameState.state, [5, 17, 21]) === -1);
        var is_in_queue = ($.inArray(wrappingID, this.downloading) > -1);
        if (is_downloading && !is_in_queue) {
            this.downloading.push(wrappingID);
        } else if (is_in_queue && !is_downloading) {
            var tmp = [];
            $.each(this.downloading, function (i, wrapID) {
                if (wrapID !== wrappingID) {
                    tmp.push(wrapID);
                }
            });
            this.downloading = tmp;
        }
        if (!GM.data.installedGames[wrappingID].installTime) {
            GM.data.installedGames[wrappingID].installTime = Math.round(new Date().getTime() / 1000);
        }
        if (!GM.data.installedGames[wrappingID].name) {
            $.each(GM.data.upsell, function (i, obj) {
                if (obj.wrappingID === wrappingID) {
                    GM.data.installedGames[wrappingID].name = obj.gameName;
                    GM.data.installedGames[wrappingID].isCollectors = obj.isCollectors;
                    GM.data.installedGames[wrappingID].siteID = obj.siteID;
                    GM.data.installedGames[wrappingID].langID = obj.languageID;
                    redraw = true;
                }
            });
        }
        this.convert(wrappingID);
        if (redraw) {
            GM.render.draw_left_nav();
        }
    },
    remove_game: function (wrappingID) {
        GM.overlay.close();
        if (typeof GM.data.installedGames[wrappingID] != 'undefined' && $.inArray(GM.data.installedGames[wrappingID].gameState.state, [7, 8, 9, 13, 17, 21]) > -1) {
            GM.game_rows.download_err--;
        }
        delete GM.data.installedGames[wrappingID];
        delete this.game_rows[wrappingID];
        $('#' + wrappingID.replace(/ /g, '')).slideUp();
        var tmp = [];
        $.each(this._all_wrappingIDs, function (i, wrapID) {
            if (wrapID !== wrappingID) {
                tmp.push(wrapID);
            }
        });
        this._all_wrappingIDs = tmp;
        tmp = [];
        $.each(this.downloading, function (i, wrapID) {
            if (wrapID !== wrappingID) {
                tmp.push(wrapID);
            }
        });
        this.downloading = tmp;
        GM.render.draw_left_nav();
    },
    reset_sorted_lists: function () {
        this.sorted = {
            'sort_az': [],
            'sort_installed': [],
            'sort_played': [],
            'sort_activation': []
        };
    },
    get_recently_played_game_info: function () {
        var ginfo = {};
        if (GM.data.recent) {
            if (GM.data.installedGames[GM.data.recent]) {
                ginfo = GM.data.installedGames[GM.data.recent];
            } else {
                $.each(GM.data.upsell, function (i, obj) {
                    if (obj.wrappingID === GM.data.recent) {
                        ginfo = obj;
                        ginfo.name = obj.gameName;
                        GM.gyb.cancel_buy(obj.wrappingID);
                        return false;
                    }
                    return true;
                });
            }
        }
        return ginfo;
    },
    get_dl_queue: function (wrapID) {
        this.active_download = false;
        var dl_q = [];
        $.each(this.downloading, function (i, wrappingID) {
            var obj = GM.game_rows.get_row(GM.data.installedGames[wrappingID], "DOWNLOADQUEUE");
            var is_error = false;
            obj.is_paused = ($.inArray(obj.stateID, [0, 2, 3, 10, 12, 20]) > -1);
            obj.progress = (obj.stateID === 4 ? GM.data.installedGames[obj.wrappingID].installProgress : Math.round(GM.data.installedGames[obj.wrappingID].downloadProgress / GM.data.installedGames[obj.wrappingID].downloadSize * 100));
            if ($.inArray(obj.stateID, [4, 6, 18]) === -1) {
                obj.dl_q = true;
                obj.btn_class = (obj.is_paused ? 'btn_resume resume_download' : 'btn_pause');
                if (obj.stateID === 3) {
                    obj.btn_class = 'btn_resume install_game';
                } else if (obj.stateID === 20) {
                    obj.btn_class = 'btn_spacer';
                } else {
                    obj.progress_text = GM.game_rows._get_progress_text(obj.wrappingID);
                }
            }
            if ($.inArray(obj.stateID, [7, 8, 9, 13, 20]) > -1) {
                is_error = true;
                var text = GM.text.download;
                var type = 'download ';
                switch (obj.stateID) {
                    case 7:
                    case 13:
                        type += 'resume_download';
                        break;
                    case 9:
                        text = GM.text.install;
                        type += 'install_game';
                        break;
                    case 8:
                    case 20:
                        text = GM.text.activate;
                        type += 'reactivate';
                        break;
                }
                obj.error_button = {
                    size: 'sm',
                    color: 'blue',
                    text: text,
                    type: type,
                    wrapID: obj.wrappingID
                };
            }
            if ($.inArray(obj.stateID, [0, 1, 2, 3, 4, 6, 7, 9, 10, 12, 13, 16, 17, 19, 21]) > -1) {
                obj.trash_txt = GM.text.remove;
                obj.trash_class = (GM.data.installedGames[obj.wrappingID].demoToFull ? 'btn_remove btn_sample' : 'btn_remove');
            }
            if (!is_error && !obj.is_paused) {
                GM.game_rows.active_download = true;
            }
            if (!wrapID) {
                dl_q.push(obj);
            } else if (wrapID === obj.wrappingID) {
                dl_q.push(obj);
            }
        });
        return dl_q;
    },
    get_game_count: function () {
        return this.total_games;
    },
    sort_games: function (sort_by) {
        sort_by = sort_by || GM.data.userData.sort.sort;
        sort_by = sort_by || 'sort_az';
        if (sort_by && $.inArray(sort_by, ['sort_az', 'sort_played', 'sort_activation', 'sort_installed']) > -1) {
            GM.data.userData.sort.sort = sort_by;
        }
        if (!this.sorted[sort_by] || this.sorted[sort_by].length > 0) {
            return;
        }
        GM.profiler.start_timer('Sorting games ' + sort_by);
        this.sorted[sort_by] = this._all_wrappingIDs.slice(0);
        if (this.sorted[sort_by].length < 2) {
            return;
        }
        switch (sort_by) {
            case 'sort_installed':
                this.sorted[sort_by].sort(this._sort_install_time);
                break;
            case 'sort_played':
                this.sorted[sort_by].sort(this._sort_played);
                break;
            case 'sort_activation':
                this.sorted[sort_by].sort(this._sort_az);
                var buckets = {
                    time_left: [],
                    expired: [],
                    activated: [],
                    other: []
                };
                $.each(this.sorted[sort_by], function (i, wrappingID) {
                    var game = GM.data.installedGames[wrappingID];
                    var stateID = game.gameState.state
                    if (stateID === 5) {
                        if (!game.activated) {
                            if (game.timeLeft && game.timeLeft > 0) {
                                buckets.time_left.push(wrappingID);
                            } else {
                                buckets.expired.push(wrappingID);
                            }
                        } else {
                            buckets.activated.push(wrappingID);
                        }
                    } else {
                        buckets.other.push(wrappingID);
                    }
                });
                buckets.time_left.sort(this._sort_time_left);
                var tmp = [];
                $.each(buckets.time_left, function (i, obj) {
                    tmp.push(obj);
                });
                $.each(buckets.expired, function (i, obj) {
                    tmp.push(obj);
                });
                $.each(buckets.activated, function (i, obj) {
                    tmp.push(obj);
                });
                $.each(buckets.other, function (i, obj) {
                    tmp.push(obj);
                });
                this.sorted[sort_by] = tmp;
                break;
            default:
                this.sorted[sort_by].sort(this._sort_az);
        }
        GM.profiler.end_timer('Sorting games ' + sort_by);
        return;
    },
    _sort_install_time: function (a, b) {
        return (GM.data.installedGames[a].installTime > GM.data.installedGames[b].installTime ? -1 : 1);
    },
    _sort_played: function (a, b) {
        var time = {
            x: GM.data.installedGames[a].lastActionTime,
            y: GM.data.installedGames[b].lastActionTime
        };
        if (time.x === time.y) {
            return (GM.data.installedGames[a].name < GM.data.installedGames[b].name ? -1 : 1);
        }
        return (time.x > time.y ? -1 : 1);
    },
    _sort_time_left: function (a, b) {
        return (GM.data.installedGames[a].timeLeft > GM.data.installedGames[b].timeLeft ? -1 : 1);
    },
    _sort_az: function (a, b) {
        return (GM.data.installedGames[a].name < GM.data.installedGames[b].name ? -1 : 1);
    },
    get_row: function (gm_data, ROWSOURCE) {
        var row = {
            stateID: gm_data.gameState.state,
            state: 'gm_state_default',
            id: gm_data.wrappingID.replace(/ /g, ''),
            wrappingID: gm_data.wrappingID,
            install_time: gm_data.installTime,
            timestamp: gm_data.lastActionTime,
            img: (gm_data.icon ? gm_data.icon : '../images/m/game_rows/missing_60x40.jpg'),
            pseudoGame: (gm_data.pseudoGame ? true : false),
            title: gm_data.name,
            has_update: ($.ct(GM.data.updates[gm_data.wrappingID], 'object') && GM.data.updates[gm_data.wrappingID].displayable ? true : false),
            update_txt: GM.text.update_available,
            status: GM.text.activated,
            activated: (gm_data.isLegacy ? true : gm_data.activated),
            buttons: [],
            installed: true,
            is_dl_err: false,
            trash_txt: GM.text.uninstall,
            trash_class: 'btn_trash',
            dl_txt: GM.text.go_to_queue,
            is_downloading: true
        };
        if (gm_data.installProgress > 0) {
            row.progress = gm_data.installProgress;
        } else if (gm_data.downloadProgress > 0 && gm_data.downloadSize > 0) {
            row.progress = Math.round(gm_data.downloadProgress / gm_data.downloadSize * 100);
        }
        var time_left = gm_data.timeLeft;
        switch (gm_data.gameState.state) {
            case 0:
            case 1:
            case 2:
            case 3:
            case 4:
            case 6:
            case 10:
            case 11:
            case 12:
            case 16:
            case 18:
            case 19:
            case 20:
                row.state = 'gm_state_downloading';
                row.status = GM.render.str_replace('[PCT]', '<span class="gm_progress_number"></span>', GM.text['gm_state_' + gm_data.gameState.state]);
                row.installed = false;
                break;
            case 5:
                row.buttons.push(this._get_button('sm', 'play', gm_data.wrappingID, false, ROWSOURCE));
                if (!row.activated) {
                    row.time_left = time_left;
                    if (row.time_left === 0) {
                        row.state = 'gm_state_expired';
                        row.status = GM.text.expired;
                        row.buttons = [(this._get_button('sm', 'play', gm_data.wrappingID, true, ROWSOURCE))];
                    } else if ((row.time_left > 121) || (gm_data.IGPGame)) {
                        row.status = GM.text.IGPGame_text;
                    } else {
                        row.status = GM.render.str_replace('[TIME]', gm_data.timeLeft, (gm_data.timeLeftUnits === 'day' ? (time_left > 1 ? GM.text.days_left : GM.text.day_left) : (time_left > 1 ? GM.text.minutes_left : GM.text.minute_left)));
                    }
                    row.buttons.push(this._get_button('sm', 'buy', gm_data.wrappingID, (!GM.data.userData.isAdmin), ROWSOURCE));
                }
                row.is_downloading = false;
                break;
            case 7:
            case 8:
            case 9:
            case 13:
            case 17:
            case 21:
                row.state = 'gm_state_error';
                row.status = GM.text['gm_row_error_' + gm_data.gameState.state];
                row.is_downloading = ($.inArray(gm_data.gameState.state, [17, 20, 21]) === -1);
                row.more_info = GM.text.gm_row_error_info;
                row.is_dl_err = true;
                break;
            default:
                return false;
        }
        if (gm_data.isLegacy) {
            row.status = GM.text.legacy;
            row.status_tip = GM.render.str_replace('[PLAY]', GM.text.play, GM.text.legacy_tip);
        }
        if (row.is_downloading) {
            if ($.inArray(row.stateID, [0, 1, 4, 6, 11, 16, 18, 19]) > -1) {
                GM.game_rows.active_download = true;
            }
        }
        if (row.pseudoGame) {
            row.buttons = [];
            row.buttons.push({
                size: 'sm',
                color: 'blue',
                type: 'pseudoPlay',
                text: GM.text.play,
                wrapID: gm_data.wrappingID,
                launchClass: gm_data.launchClass
            });
            row.trash_class = 'btn_pseudoTrash';
        }
        return row;
    },
    set_uac_timeout: function (wrappingID) {
        if (GM.data.userData.platform === 'windows' && GM.data.installedGames[wrappingID]) {
            this._uac_timeouts[wrappingID] = setTimeout(function () {
                GM.overlay.open('uac_notification', {
                    "overlayID": "uac_notification",
                    "wrappingID": wrappingID
                });
            }, 60000);
        }
    },
    _clear_uac_timeout: function (wrappingID) {
        if (this._uac_timeouts[wrappingID]) {
            clearTimeout(this._uac_timeouts[wrappingID]);
            delete this._uac_timeouts[wrappingID];
        }
    },
    _get_progress_text: function (wrappingID) {
        if (GM.data.installedGames[wrappingID]) {
            var g = GM.data.installedGames[wrappingID];
        } else {
            return null;
        }
        if (!g.downloadSize) {
            return null;
        }
        var progress_text = GM.render.str_replace('[BYTES]', GM.game_rows._convert_bytes(g.downloadProgress), GM.text.progress_text);
        progress_text = progress_text.replace('[TOTAL]', GM.game_rows._convert_bytes(g.downloadSize));
        return progress_text;
    },
    _convert_bytes: function (bytes) {
        var labels = ['B', 'KB', 'MB', 'GB', 'TB', 'PB'];
        var divisions = 0;
        while (bytes >= 1024) {
            divisions++;
            bytes /= 1024;
        }
        return (Math.round(bytes * 10, 1) / 10) + labels[divisions];
    },
    _get_button: function (size, type, wrapID, is_disabled, source) {
        var button = {
            size: size,
            color: (is_disabled ? 'disabled' : (type === 'play' ? 'blue' : 'green')),
            type: type,
            text: (type === 'play' ? GM.text.play : GM.text.buy),
            wrapID: wrapID
        };
        if (source) {
            button.sourceOfButton = source;
        }
        return button;
    },
    draw_progress: function (wrapID) {
        GM.profiler.start_timer('Draw progress (' + (wrapID || 'all') + ')');
        if (wrapID) {
            this._draw_progress($('#' + wrapID));
        } else {
            $('.gm_state_downloading').each(function (i, obj) {
                GM.game_rows._draw_progress(obj);
            });
        }
        GM.profiler.end_timer('Draw progress (' + (wrapID || 'all') + ')');
    },
    _draw_progress: function (obj) {
        var prog = parseInt($(obj).attr('data-progress'), 0);
        if (!prog) {
            prog = 0;
        }
        if (prog > 100) {
            prog = 100;
        }
        var bar = $(obj).find('.gm_progress_bar');
        $(obj).find('.gm_progress_number').html(prog);
        $(bar).css('width', prog + '%');
    },
    update_progress: function (wrapID, progress, downloadSize, is_install) {
        if (progress === -1) {
            return false;
        }
        if (GM.data.installedGames[wrapID]) {
            if (is_install) {
                if (progress > 0) {
                    this._clear_uac_timeout(wrapID);
                }
                GM.data.installedGames[wrapID].installProgress = progress;
                if ((progress == 100) && !GM.data.installedGames[wrapID].installEventSent) {
                    GM.data.installedGames[wrapID].installEventSent = true;
                    if (GM.tracking) {
                        var boolIsUpdate = false;
                        if (GM.data.updates[wrapID]) {
                            boolIsUpdate = true;
                        }
                        GM.tracking.sendGameInstallEvent(wrapID, boolIsUpdate);
                    }
                }
            } else {
                GM.data.installedGames[wrapID].downloadProgress = progress;
                GM.data.installedGames[wrapID].downloadSize = downloadSize;
                if (downloadSize > 0) {
                    progress = Math.round(progress / downloadSize * 100);
                }
                if (progress === 100) {
                    $('#' + wrapID + ' .gm_status .middle_align_2').html(GM.text.validating);
                }
                if (progress > 100) {
                    progress = 100;
                }
                GM.controller.event_to_qa('update_download_progress', {
                    download_progress: progress,
                    total_size: downloadSize
                });
            }
        } else if (GM.data.installedTools[wrapID]) {
            if (is_install) {
                GM.data.installedTools[wrapID].installProgress = progress;
            } else {
                GM.data.installedTools[wrapID].downloadProgress = Math.round(progress / downloadSize * 100);
                GM.data.installedTools[wrapID].downloadSize = downloadSize;
            }
            $('#content').trigger("ToolInstallUpdate", GM.data.installedTools[wrapID]);
        }
        if ($('#' + wrapID).size() > 0) {
            $('#' + wrapID).attr('data-progress', progress);
            $('#' + wrapID + ' .gm_progress_text').html(this._get_progress_text(wrapID));
            this.draw_progress(wrapID);
        }
        return true;
    }
};
var GM = GM || {};
GM.navigation = {
    _inited: false,
    _isDirty: false,
    _groups: {},
    _buildGroups: {},
    _buildChildren: {},
    setActive: function (page, sort) {
        var defaults = {
            page: '',
            sort: ''
        },
            data;
        if (typeof page === 'object' && sort === undefined) {
            data = $.extend({}, defaults, page);
            page = data.page;
            sort = data.sort;
        }
        GM.data.userData.sort.page = page;
        if (sort) {
            GM.data.userData.sort.sort = sort;
        }
    },
    init: function () {
        if (GM.data.userData.siteID == 1 && GM.data.userData.platform == 'windows') {
            GM.navigation.addGroup('store', {
                category_title: "store",
                sort_order: "1",
                category_text: "Find New Games",
                state: "open",
                after: '',
                listClasses: ""
            });
            GM.navigation.addChild('store', 'sort_search', {
                icon: "",
                item_text: (GM.data.userData.platform == 'windows') ? "PC Games <span class='icon_new hide_retail' style='margin-right:-6px'>" + GM.text['new'] + "</span>" : "Mac Games <span class='icon_new hide_retail' style='margin-right:-6px'>" + GM.text['new'] + "</span>",
                classes: " sort_search ",
                id: "sort_search",
                extra_icons: "",
            });
        }
        GM.navigation.addGroup('downloads', {
            category_title: "downloads",
            sort_order: (GM.data.userData.siteID == 1) ? "1" : "2",
            category_text: GM.text.left_nav.download.title,
            state: "open",
            after: '',
            listClasses: ""
        });
        GM.navigation.addChild('downloads', 'my_games', {
            icon: "",
            item_text: GM.text.left_nav.download.my_games,
            classes: "sort_games sort_az",
            id: "sort_az",
            extra_icons: ""
        });
        GM.navigation.addChild('downloads', 'queue', {
            icon: "",
            item_text: GM.text.left_nav.download.queue,
            classes: "sort_games queue_download hide_non_admin",
            id: "queue_download",
            current_downloads: 0,
            extra_icons: "",
            build: function (self) {
                var downloading = GM.game_rows.downloading.length;
                self.current_downloads = downloading;
                self.extra_icons = leftnav_addIconWithText("icon_queue", downloading);
                if (GM.game_rows.active_download) {
                    if (GM.game_rows.download_err > 0 && GM.game_rows.download_err === downloading) {
                        self.extra_icons += leftnav_addIconWithText("icon_alert");
                    } else if (downloading > 0) {
                        self.extra_icons += leftnav_addIconWithText("icon_downloading");
                    }
                }
                return self;
            },
            exclude: function (self) {
                return false;
            }
        });
        GM.navigation.addChild('downloads', 'updates', {
            icon: "",
            item_text: GM.text.updates,
            classes: "sort_games queue_update hide_non_admin",
            id: "queue_update",
            extra_icons: "",
            current_updates: 0,
            build: function (self) {
                var update_size = GM.updates.get_update_count();
                self.current_updates = update_size;
                self.extra_icons = leftnav_addIconWithText("updates_icon", update_size);
                return self;
            },
            exclude: function (self) {
                return 0 === self.current_updates;
            }
        });
        GM.navigation.addChild('downloads', 'gyl', {
            icon: "",
            item_text: GM.text.left_nav.download.gyb,
            classes: "sort_games gyb_page hide_non_admin hide_retail",
            id: "gyb_page",
            extra_icons: ""
        });
        GM.navigation.addChild('downloads', 'purchase_page', {
            icon: "",
            item_text: GM.text.purchase_history,
            classes: "sort_games purchase_page hide_non_admin ignore_sort hide_retail",
            id: "purchase_history_page",
            extra_icons: ""
        });
        GM.navigation.addChild('downloads', 'recent_header', {
            icon: "",
            item_text: GM.text.left_nav.download.recent_activity,
            classes: "plain-header",
            id: "",
            extra_icons: "",
            exclude: function (self) {
                return !GM.data.recent;
            }
        });
        GM.navigation.addChild('downloads', 'recent_activity', {
            icon: "icon_arrow",
            item_text: "",
            classes: "sort_games indent-more recent_game",
            id: "recent_game",
            extra_icons: "",
            build: function (self) {
                var rows = GM.game_rows.game_rows,
                    recent = GM.data.recent,
                    gameData = rows[recent];
                self.item_text = "";
                if (recent && GM.data.installedGames[recent] && GM.data.installedGames[recent].name) {
                    self.item_text = GM.util.truncate(GM.data.installedGames[recent].name, 36, true);
                }
                return self;
            },
            exclude: function (self) {
                return !(GM.data.recent && self.item_text);
            }
        });
        if (GM.data.userData.siteID == 1) {
            GM.navigation.initFTP();
        }
		GM.navigation._inited = true;
    },
    initFTP: function () {
        if (GM.data.userData.siteID == 1) {
            GM.navigation.addGroup('f2p', {
                category_title: "f2p",
                sort_order: (GM.data.userData.platform == 'windows') ? "3" : "2",
                category_text: "New Ways To Play!",
                state: "open",
                after: '',
                listClasses: ""
            });
    
  			GM.navigation.addChild('f2p', 'casino', {
                icon: "",
                item_text: "Big Fish Casino",
                classes: "sort_casino casino_launcher",
                id: "f2p_casino",
                extra_icons: "",
                exclude: function (self) {
                    var excludeCasino = GM.pseudoGameUtils.isGameInUninstallList(GM.extendedFunctions.casinoID);
                    if (excludeCasino && GM.data.userData.platform == 'mac') {
                        setTimeout("$('#left_nav_header_f2p').hide();", 1);
                        GM.navigation.removeGroup('f2p');
                    }
                    return excludeCasino;
                }
			});	
		
 			/*if (GM.data.userData.platform == 'windows') {
                GM.navigation.addChild('f2p', 'ftp_page', {
                    icon: "",
                    item_text: "Free to Play Games",
                    classes: "sort_f2p",
                    id: "f2p_page",
                    extra_icons: "",
                });
			}*/

        	var countOfVisibleSubMenus = 0;
            for (var child in GM.navigation._groups["f2p"].children) {
                var childObj = GM.navigation._groups["f2p"].children[child];
                if (!childObj.exclude || !childObj.exclude()) {
                    countOfVisibleSubMenus += 1;
                    break;
                }
            }
            
   			if (countOfVisibleSubMenus <= 0) {
                GM.navigation.removeGroup('f2p');
            }
        }
    },
    build: function () {
        if (!GM.navigation._inited) {
            GM.navigation.init();
        }
        var categories = $.extend(true, {}, GM.navigation._groups);
        var sorter = [];
        for (var item in categories) {
            sorter.push({
                "key": item,
                "order": categories[item].sort_order
            });
        }
        sorter.sort(function (a, b) {
            return a.order.localeCompare(b.order);
        });
        var tmp = {};
        for (var newItem in sorter) {
            tmp[sorter[newItem].key] = categories[sorter[newItem].key];
        }
        categories = tmp;
        categories = GM.navigation.buildGroups(categories);
        for (var key in GM.navigation._buildChildren) {
            var target = GM.navigation._buildChildren[key],
                original = categories[target.group].children[target.child],
                built = {};
            built = original.build(original);
            categories[target.group].children[target.child] = built;
        }
        categories = GM.navigation.markActive(GM.data.userData.sort.page, categories);
        categories = GM.navigation.removeExcluded(categories);
        GM.navigation._built = categories;
        return categories;
    },
    buildGroups: function (categories) {
        for (var key in GM.navigation._buildGroups) {
            var original = categories[key],
                built = {};
            built = original.build(original);
            built.children = original.children;
            categories[key] = built;
        }
        return categories;
    },
    addGroup: function (groupName, metadata) {
        metadata.sort_order = metadata.sort_order + '';
        if (!metadata.sort_order) {
            metadata.sort_order = 0;
            for (var key in GM.navigation._groups) {
                metadata.sort_order = GM.navigation._groups[key].sort_order.substring(0, 1);
            }
            metadata.sort_order = (parseInt(metadata.sort_order, 10) + 1) + '';
        }
        GM.navigation._isDirty = true;
        metadata.children = {};
        GM.navigation._groups[groupName] = metadata;
        if (typeof metadata.build === 'function') {
            GM.navigation._buildGroups[groupName] = {
                'group': groupName
            };
        }
    },
    removeGroup: function (groupName) {
        GM.navigation._isDirty = true;
        if (GM.navigation._groups[groupName]) {
            delete GM.navigation._groups[groupName];
            for (var key in GM.navigation._buildChildren) {
                var child = GM.navigation._buildChildren[key];
                if (child.group == groupName) {
                    delete GM.navigation._buildChildren[key];
                }
            }
        }
        if (GM.navigation._buildGroups[groupName]) {
            delete GM.navigation._buildGroups[groupName];
        }
    },
    addChild: function (groupName, childName, metadata) {
        GM.navigation._isDirty = true;
        GM.navigation._groups[groupName].children[childName] = metadata;
        if (typeof metadata.build === 'function') {
            GM.navigation._buildChildren[groupName + '_' + childName] = {
                'group': groupName,
                'child': childName
            };
        }
    },
    removeChild: function (groupName, childName) {
        GM.navigation._isDirty = true;
        var childExists = GM.navigation._groups[groupName] && GM.navigation._groups[groupName].children;
        childExists = childExists && GM.navigation._groups[groupName].children[childName];
        if (childExists) {
            delete GM.navigation._groups[groupName].children[childName];
        }
        if (typeof GM.navigation._buildChildren[groupName + '_' + childName] !== 'undefined') {
            delete GM.navigation._buildChildren[groupName + '_' + childName];
        }
    },
    markActive: function (current, categories) {
        for (var key in categories) {
            for (var item in categories[key].children) {
                if (categories[key].children[item].id == current) {
                    categories[key].children[item].active = 'sort_active';
                    categories[key].state = 'open';
                } else {
                    categories[key].children[item].active = '';
                }
            }
        }
        return categories;
    },
    removeExcluded: function (categories) {
        var child;
        for (var key in categories) {
            for (var item in categories[key].children) {
                child = categories[key].children[item];
                if (typeof child.exclude === 'function' && child.exclude(child)) {
                    delete categories[key].children[item];
                }
            }
        }
        return categories;
    }
};
var GM = GM || {};
GM.updates = {
    _selected_count: 0,
    _update_count: 0,
    set_game_updates: function (updates) {
        var n = 0;
        GM.data.updates = {};
        $.each(updates, function (i, obj) {
            if (obj.wrappingID && GM.data.installedGames[obj.wrappingID]) {
                GM.data.updates[obj.wrappingID] = obj;
                if (obj.displayable) {
                    GM.game_rows.convert(obj.wrappingID);
                    GM.render.draw_games(GM.data.userData.sort.sort, obj.wrappingID);
                    n++;
                }
            }
        });
        GM.render.draw_left_nav();
    },
    set_single_game_update: function (wrappingID, obj) {
        if (GM.data.updates[wrappingID]) {
            GM.data.updates[wrappingID] = $.extend({}, GM.data.updates[wrappingID], obj);
        } else if (obj.displayable && GM.data.installedGames[wrappingID]) {
            GM.game_rows.convert(wrappingID);
            GM.render.draw_games(GM.data.userData.sort.sort, obj.wrappingID);
        }
        GM.data.updates[wrappingID] = obj;
        GM.render.draw_left_nav();
    },
    remove_game_update: function (wrappingID) {
        if (GM.data.updates[wrappingID]) {
            if (GM.data.updates[wrappingID].displayable) {
                GM.game_rows.convert(wrappingID);
                GM.render.draw_left_nav();
            }
            delete GM.data.updates[wrappingID];
        }
    },
    get_update_count: function () {
        var n = 0;
        $.each(GM.data.updates, function (i, obj) {
            if (GM.data.installedGames[obj.wrappingID] && obj.displayable) {
                n++;
            }
        });
        this._update_count = n;
        return this._update_count;
    },
    draw_updates: function () {
        $('#content').html($('#tmpl_update_queue').tmpl(this._get_tmpl_obj()));
    },
    _get_tmpl_obj: function () {
        var up_q = GM.data.updates;
        var selected = 0;
        var up = [];
        $.each(up_q, function (i, obj) {
            if (obj.displayable && GM.data.installedGames[obj.wrappingID]) {
                var row = GM.game_rows.get_row(GM.data.installedGames[obj.wrappingID]);
                var q = {
                    wrappingID: obj.wrappingID,
                    will_lose: obj.willLoseData,
                    lose: GM.text.lose_progress,
                    img: row.img,
                    title: row.title,
                    txt_status: GM.text.status,
                    status: row.status,
                    txt_details: GM.text.details,
                    details: obj.description,
                    close: GM.text.close,
                    is_checked: (obj.state === 1)
                };
                if (q.is_checked) {
                    selected++;
                }
                up.push(q);
            }
        });
        this._get_btn(up_q);
        var tmpl = {
            title: GM.text.select_updates,
            up_q: up,
            btn: this._get_btn(selected),
            no_updates: GM.text.no_updates,
            close: GM.text.close,
            btn_play: {
                size: 'med',
                color: 'blue',
                type: 'plain sort_games sort_az',
                text: GM.text.play_my_games
            }
        };
        return tmpl;
    },
    update_btn: function (obj) {
        var wrapID = $(obj).closest('.gm_row').attr('id');
        if (wrapID) {
            GM.data.updates[wrapID].state = ($(obj).hasClass('checked') ? 1 : 0);
        }
        var selected = $('#update_queue .update_checkbox .checked').size();
        $('#update_install').html($('#tmpl_button').tmpl(this._get_btn(selected)));
    },
    remove_update: function (btn) {
        var id = $(btn).closest('.gm_state_update').attr('id');
        GM.controller.event_to_native('ignoreUpdate', {
            wrappingID: id
        });
        GM.game_rows.convert(id);
        $('#' + id).slideUp(function () {
            $(this).remove();
            GM.updates.update_btn();
        });
        this._check_remaining_count();
    },
    install: function () {
        if (this._selected_count > 0) {
            var wrapIDs = [];
            $('.update_checkbox .checked').each(function (i, obj) {
                var wrapID = $(obj).closest('.gm_state_update').attr('id');
                if (wrapID) {
                    GM.tracking.sendGameDownloadInitEvent(wrapID, "GameUpgradeInGM");
                    wrapIDs.push(wrapID);
                    $('#' + wrapID).slideUp(function () {
                        $(this).remove();
                    });
                }
            });
            if (wrapIDs.length > 0) {
                GM.controller.event_to_native('installUpdates', {
                    wrappingIDs: wrapIDs
                });
            }
            var txt = GM.render.str_replace('[NUMBER]', this._selected_count, GM.text[(this._selected_count > 1 ? 'updates_added' : 'update_added')]);
            $('#update_game_added').html(txt);
            $('#update_added').slideDown();
            $('#update_install').html($('#tmpl_button').tmpl(this._get_btn(0)));
        }
        this._check_remaining_count();
    },
    _get_btn: function (selected_count) {
        this._selected_count = selected_count;
        var btn = {
            size: 'med',
            color: (selected_count > 0 ? 'blue' : 'disabled'),
            text: (selected_count > 1 ? GM.render.str_replace('[NUMBER]', selected_count, GM.text.install_updates) : (selected_count === 1 ? GM.render.str_replace('[NUMBER]', selected_count, GM.text.install_update) : GM.text.install_updates_unknown))
        };
        return btn;
    },
    _check_remaining_count: function () {
        var count = this.get_update_count();
        if (count === 0) {
            $('#update_install').hide();
            $('#update_no_more').show();
        }
        $('#left_nav .queue_update .icon_queue').html(count);
    }
};
var GM = GM || {};
GM.gyb = {
    _max_gyb: 12,
    _replace_index: null,
    _empty_index: 1,
    _pending_buy: null,
    draw_gyb_page: function () {
        var tmpl = {
            is_online: GM.data.userData.isOnline,
            gyb: this.get_gyb(),
            offline: GM.text.you_are_offline
        };
        GM.content_header.draw_header('gyb_page');
        $('#content').html($('#tmpl_gyb_page').tmpl(tmpl));
        this.text_overflow();
        if (GM.tracking) {
            GM.tracking.sendPageViewEvent({
                "page": "GYL"
            });
        }
    },
    remove_game: function (elem_id) {
        var wrapID = elem_id.replace(/gyb_/, '');
        GM.controller.event_to_native('removeUpsell', {
            wrappingID: wrapID
        });
        this._remove_game_from_object(wrapID);
        $('#' + elem_id).fadeOut('slow', GM.gyb._fade_callback);
    },
    try_game: function (wrapID, el, is_trial) {
        if (is_trial) {
            GM.controller.event_to_native('tryUpsell', {
                wrappingID: wrapID,
                npi: GM.urls.get_tracking_page()
            });
        } else {
            this._pending_buy = wrapID;
        }
        $.each(GM.data.upsell, function (i, obj) {
            if (obj.wrappingID === wrapID) {
                GM.data.upsell[i].upsold = true;
                return false;
            }
            return true;
        });
        if (el && $(el).closest('.gyb').size() > 0) {
            var btn = $(el).closest('.gyb').find(is_trial ? '.btn_buy' : '.btn_download');
            var gyb = {
                try_it: true,
                added: GM.text.game_added,
                my_games: GM.render.str_replace('<a>', '<a class="sort_games ' + GM.data.userData.sort.sort + ' sort_change" data-wrapID="' + wrapID + '">', GM.text.go_to_my_games)
            };
            $($('#tmpl_gyb').tmpl(gyb)).insertBefore(el);
            $(el).hide();
            if ($(btn).size() > 0) {
                $(btn).removeClass('btn_buy btn_download').addClass('btn_disabled');
            }
        }
    },
    cancel_buy: function (wrappingID) {
        if (!wrappingID || (this._pending_buy == wrappingID)) {
            $.each(GM.data.upsell, function (i, obj) {
                if (obj.wrappingID === GM.gyb._pending_buy) {
                    delete GM.data.upsell[i].upsold;
                    var btn = $('.gyb .btn[data-wrapID="' + obj.wrappingID + '"]:visible');
                    if (btn) {
                        var container = $(btn).closest('.gyb');
                        $(btn).removeClass('btn_disabled').addClass('btn_download');
                        $(container).find('.gyb_added').hide();
                        $(container).find('.btn').show();
                    }
                    GM.gyb._pending_buy = null;
                }
            });
        }
    },
    get_gyb_count: function () {
        this.clean_gyb();
        return GM.data.upsell.length;
    },
    _fade_callback: function () {
        if (GM.gyb._replace_index > 0) {
            var gyb = [];
            if (GM.data.upsell.length >= GM.gyb._max_gyb) {
                gyb = (GM.gyb.get_gyb(GM.gyb._replace_index, true, true));
            } else {
                gyb.push(GM.gyb._get_empty_gyb(true));
            }
            if (gyb.length > 0) {
                $(this).replaceWith($('#tmpl_gyb').tmpl(gyb));
                $('#gyb_' + gyb[0].wrapID).show();
                GM.render.game_tips();
            }
        }
    },
    _get_empty_gyb: function (hide) {
        var gyb = {
            show_text: (this._empty_index === 1),
            wrapID: 'gyb_no_more_' + this._empty_index,
            hide: hide,
            blank: true,
            no_more: GM.text.no_more_recs,
            see_more: GM.render.str_replace('<a>', '<a href="' + GM.urls.get_url('gyb') + '" target="_blank">', GM.text.see_more_gyb)
        };
        this._empty_index++;
        return gyb;
    },
    clean_gyb: function () {
        var upsells = [];
        $.each(GM.data.upsell, function (i, obj) {
            if (!obj.upsold && !GM.data.installedGames[obj.wrappingID]) {
                upsells.push(obj);
            }
        });
        GM.data.upsell = upsells;
    },
    text_overflow: function () {
        var height = $('.gyb_title').height();
        $('.gyb_title').each(function (i, obj) {
            var title = $(obj).html();
            var clone = $(obj).clone().css({
                position: 'absolute',
                overflow: 'visible',
                width: $(obj).width(),
                height: 'auto'
            }).hide();
            $(obj).after($(clone));
            while (title.length > 0 && $(clone).height() > height) {
                title = title.substr(0, title.lastIndexOf(' '));
                $(clone).html(title + '&hellip;');
            }
            $(obj).html($(clone).html());
            $(clone).remove();
        });
    },
    _remove_game_from_object: function (wrapID) {
        var tmp = [];
        $.each(GM.data.upsell, function (i, obj) {
            if (i !== GM.gyb._max_gyb) {
                if (obj.wrappingID === wrapID) {
                    if (GM.data.upsell.length > GM.gyb._max_gyb) {
                        tmp.push(GM.data.upsell[GM.gyb._max_gyb]);
                        GM.gyb._replace_index = i;
                    }
                } else {
                    tmp.push(obj);
                }
            }
        });
        GM.data.upsell = tmp;
    },
    get_gyb: function (index, hide, skip_cleaning) {
        var gyb = [];
        this._empty_index = 1;
        if (!skip_cleaning) {
            this.clean_gyb();
        }
        if (GM.data.upsell.length > 0) {
            $.each(GM.data.upsell, function (i, obj) {
                if (!obj) {
                    return false;
                }
                if (!$.ct(index, 'number') || (i === index)) {
                    gyb.push({
                        hide: (hide || false),
                        close: GM.text.not_interested,
                        img: obj.feature,
                        desc: obj.desc,
                        genre: obj.gameGenre,
                        title: obj.gameName,
                        wrapID: obj.wrappingID,
                        buttons: [{
                            size: 'med',
                            color: 'blue',
                            type: 'download',
                            text: GM.text.try_it,
                            wrapID: obj.wrappingID,
                            sourceOfButton: "GYBPage"
                        }, {
                            size: 'med',
                            color: 'green',
                            type: 'buy',
                            text: GM.text.buy,
                            wrapID: obj.wrappingID,
                            blank: true
                        }]
                    });
                    return ((index >= 0) ? false : (i < (GM.gyb._max_gyb - 1)));
                }
                return true;
            });
        } else {
            gyb.push(this._get_empty_gyb(false));
        }
        return gyb;
    }
};
var GM = GM || {};
GM.gybb = {
    _allowed_views: ['sort_az', 'sort_installed', 'sort_played', 'sort_activation', 'queue_download'],
    _max_gyb: 7,
    _first_index: 0,
    render: function (sort_by, force_show) {
        sort_by = (sort_by || GM.data.userData.sort.page);
        if (GM.data.userData.isRetail || !GM.data.userData.isAdmin) {
            return false;
        }
        var is_hidden = ($('#gybb:visible').size() === 0 || $('#gybb:empty').size() > 0 || $('#gybb_games').size() === 0);
        if (force_show || ($.inArray(sort_by, this._allowed_views) > -1 && GM.data.userData.isOnline)) {
            if (is_hidden) {
                this._display();
            }
        } else {
            this._hide();
        }
        return true;
    },
    _display: function () {
        var tmpl = this._get_tmpl();
        if (tmpl.gyb.length > 0) {
            $('#gybb').replaceWith($('#tmpl_gyb_bottom').tmpl(tmpl)).show();
            $('#container').addClass('content_with_gybb');
            GM.gyb.text_overflow();
            GM.render.game_tips();
        } else {
            this._hide();
        }
    },
    _hide: function () {
        $('#gybb').hide().empty();
        $('#container').removeClass('content_with_gybb');
        this._first_index = 0;
    },
    _get_tmpl: function () {
        GM.gyb.clean_gyb();
        var tmpl = {
            title: GM.text.gyb,
            gyb: [],
            more: GM.text.see_more
        };
        $.each(GM.data.upsell, function (i, obj) {
            if (i < GM.gybb._max_gyb) {
                tmpl.gyb.push({
                    img: obj.image_8080,
                    desc: obj.desc,
                    genre: obj.gameGenre,
                    title: obj.gameName,
                    wrapID: obj.wrappingID,
                    buttons: [{
                        size: 'sm',
                        color: 'green',
                        type: 'buy',
                        text: GM.text.buy,
                        wrapID: obj.wrappingID,
                        blank: true
                    }, {
                        size: 'sm',
                        color: 'blue',
                        type: 'download',
                        text: GM.text.try_it,
                        sourceOfButton: "GYBBottomBanner",
                        wrapID: obj.wrappingID
                    }]
                });
                return true;
            } else {
                return false;
            }
        });
        return tmpl;
    },
    next_view: function () {
        var $gyb = $('#gybb .gyb');
        var in_view = Math.floor(($('#gybb_games').outerWidth() / $gyb.outerWidth()));
        var w = $gyb.outerWidth() + parseInt($gyb.css('margin-left'), 10);
        var n = $gyb.size();
        if (this._first_index + in_view <= n) {
            this._first_index += in_view;
            $('#gybb_games_rotate').animate({
                right: String(this._first_index * w) + 'px'
            });
            $('.gybb_prev').removeClass('gybb_disabled');
        }
        if (this._first_index + in_view > n) {
            $('.gybb_next').addClass('gybb_disabled');
        }
    },
    prev_view: function () {
        var $gyb = $('#gybb .gyb');
        var in_view = Math.floor(($('#gybb_games').outerWidth() / $gyb.outerWidth()));
        var w = $gyb.outerWidth() + parseInt($gyb.css('margin-left'), 10);
        this._first_index -= in_view;
        if (this._first_index <= 0) {
            this._first_index = 0;
            $('.gybb_prev').addClass('gybb_disabled');
        }
        $('#gybb_games_rotate').animate({
            right: String(this._first_index * w) + 'px'
        });
        $('.gybb_next').removeClass('gybb_disabled');
    }
};
var GM = GM || {};
GM.recent_activity = {
    _has_gyb: false,
    has_gyb: function () {
        return this._has_gyb;
    },
    draw_recent: function (is_pre_trial, credits_used, is_same_game) {
        var tmpl = this._get_tmpl_obj(is_pre_trial, credits_used, is_same_game);
        if (tmpl.error) {
            $('#content').removeClass().addClass('yellow_bg');
        } else {
            $('#content').removeClass();
            if (!tmpl.activated) {
                $('#content').addClass('blue_bg');
            }
        }
        this._has_gyb = tmpl.has_gyb;
        $('#content').html($('#tmpl_recent_activity').tmpl(tmpl));
    },
    _get_tmpl_obj: function (is_pre_launch, credits_used, is_same_game) {
        var ginfo = GM.game_rows.get_recently_played_game_info();
        if (!ginfo.gameState) {
            ginfo.gameState = {
                errorCode: (GM.data.errorCode > 0 ? GM.data.errorCode : 900)
            }
        }
        if (ginfo.gameState.errorCode && ginfo.gameState.errorCode > 0) {
            var replace = (ginfo.gameState.replace || []);
            return this._get_error_tmpl_obj(ginfo.gameState.errorCode, replace);
        } else {
            var time_left = ginfo.timeLeft;
            var credits = GM.prices.get_credits(ginfo.siteID, ginfo.wrappingID, ginfo.isCollectors);
            if (!is_same_game) {
                GM.ads.get_ad('spotlight', GM.data.userData.siteID);
            }
            var is_limited_user = (!GM.data.userData.isAdmin);
            var tmpl = {
                class_name: (ginfo.activated ? 'recent_activated' : (is_pre_launch ? 'recent_pre_trial' : 'recent_trial')),
                activated: (ginfo.activated || ginfo.isLegacy),
                error: false,
                expired: (!time_left),
                img: ginfo.feature,
                title: ginfo.name,
                used_credits: ($.ct(credits_used, 'number')),
                play_btn: {
                    size: 'med',
                    color: 'blue',
                    type: 'play',
                    wrapID: GM.data.recent,
                    sourceOfButton: "RecentlyPlayed",
                    text: GM.text[$.ct(credits_used) ? 'play_now' : 'play_again']
                },
                buy_btn: {
                    size: 'lg',
                    color: 'green',
                    type: 'buy' + (is_limited_user ? ' btn_disabled' : ''),
                    wrapID: GM.data.recent,
                    sourceOfButton: "RecentlyPlayed",
                    text: GM.text.buy_it
                },
                is_limited: is_limited_user,
                you_own: GM.text.you_own,
                no_limits: GM.text.no_limits,
                forums: GM.urls.get_forums_url(ginfo.wrappingID),
                tip: GM.text.get_tips,
                gift_url: GM.urls.get_gift_url(ginfo.wrappingID),
                gift: GM.text.gift_game,
                share_url: GM.urls.get_share_url(ginfo.wrappingID),
                share: GM.text.share_game,
                time_msg: (time_left > 0 ? GM.text.time_running : GM.text.times_up),
                expired_msg: GM.text.trial_over,
                time_left: ((ginfo.timeLeft > 121) || (ginfo.IGPGame)) ? GM.text.IGP_trial_almost_over : GM.render.str_replace('[TIME]', time_left, (ginfo.timeLeftUnits === 'day' ? (ginfo.timeLeft > 1 ? GM.text.days_left_to_play : GM.text.day_left_to_play) : (ginfo.timeLeft > 1 ? GM.text.minutes_left_to_play : GM.text.minute_left_to_play))),
                wrapID: GM.data.recent,
                play_again: (is_pre_launch ? GM.text.play_now : GM.text.play_again),
                upgrade: GM.text.upgrade_to_full,
                upgrade_forever: GM.text.upgrade_forever,
                own: GM.text.own_for_life,
                reinstall: GM.text.reinstall_whenever,
                spotlight: GM.text.spotlight,
                ad: GM.ads.get_current_ad_html('spotlight', GM.data.userData.siteID),
                already: GM.render.str_replace('<a>', '<a class="reactivate" data-wrapID="' + ginfo.wrappingID + '">', GM.text.already_purchased),
                has_prices: GM.prices.has_prices(ginfo.siteID),
                price: GM.prices.get_gc_price(ginfo.siteID, ginfo.wrappingID, ginfo.isCollectors),
                gc_crown: GM.prices.requires_gc_discount(ginfo.siteID, ginfo.wrappingID),
                strike: GM.prices.get_non_gc_price(ginfo.siteID, ginfo.wrappingID, ginfo.isCollectors),
                or: GM.text.or,
                credits: null,
                isCEGame: ginfo.isCollectors,
                isVGGame: ginfo.VGGame,
                other: GM.text.other_currencies
            };
            tmpl.has_gyb = tmpl.activated;
            if (ginfo.flashFeature) {
                tmpl.flash = JSON.stringify({
                    src: ginfo.flashFeature,
                    width: 175,
                    height: 150
                });
            }
            if (ginfo.activated) {
                if (tmpl.used_credits) {
                    if (credits_used === 0) {
                        tmpl.thank_you = GM.text.thank_you_already;
                        tmpl.just_redeemed = GM.text.redeemed_no_credits;
                    } else {
                        tmpl.thank_you = GM.text.thank_you_purchase;
                        tmpl.just_redeemed = GM.render.str_replace('[NUMBER]', credits_used, GM.text[(credits_used === 1 ? 'redeemed_credit' : 'redeemed_credits')]);
                    }
                    tmpl.game_is_yours = GM.text.game_is_yours;
                }
            }
            if (credits) {
                tmpl.credits = GM.render.str_replace('[NUMBER]', credits, (GM.text[credits > 1 ? 'num_credits' : 'num_credit']));
            }
            return tmpl;
        }
    },
    _get_error_tmpl_obj: function (error, replace) {
        var tmpl = {
            error: true,
            has_gyb: false,
            class_name: 'recent_error',
            whoops: GM.text.err_whoops,
            code: GM.render.str_replace('[CODE]', '<span id="recent_error_code">' + error + '</span>', GM.text.error_code),
            why: GM.text.why_error,
            find_info: GM.text.find_info,
            href: GM.urls.get_url('help') + '?rn=game_manager',
            get_help: GM.text.get_help
        };
        if (GM.text['err_' + error + '_msg']) {
            tmpl.error_msg = GM.render.get_error_text(error, replace, GM.data.recent, true);
        }
        return tmpl;
    }
};
var GM = GM || {};
GM.plugins = {
    _registered: [],
    _enabled: [],
    _process: {},
    _data: {},
    _survey: {},
    _surveyDeferred: {},
    _manifest: {},
    _manifestDeferred: {},
    _started: false,
    _needsInstall: [],
    _needsUpdate: [],
    startup: function () {
        if (GM.plugins._started) {
            return;
        }
        if (typeof GM.controller === 'undefined' || typeof GM.urls === 'undefined' || GM.urls.get_url('pluginManifest') == '#') {
            setTimeout(function () {
                GM.plugins.startup();
            }, 500);
            return;
        }
        var platform = GM.data.userData.platform;
        if (typeof platform === 'undefined' || !platform) {
            setTimeout(function () {
                GM.plugins.startup();
            }, 100);
            return;
        }
        var manifest = GM.plugins.getManifest().done(function () { });
        var survey = GM.plugins.surveyPlugins().done(function () { });
        $.when(manifest, survey).done(function (manifestData, surveyData) {
            GM.plugins.parsePluginConfigs();
        }).fail(function () {
            console.log("Survey and/or manifest processing failed");
        });
        GM.plugins._started = true;
    },
    parsePluginConfigs: function () {
        var platform = GM.data.userData.platform,
            publishedPluginsForPlatform = GM.plugins._manifest.plugins[platform],
            surveyedPlugins = GM.plugins._survey,
            name = '';
        GM.plugins._needsInstall = [];
        GM.plugins._needsUpdate = [];
        for (var publishedPlugin in publishedPluginsForPlatform) {
            if (GM.plugins.needsInstall(publishedPlugin, surveyedPlugins)) {
                GM.plugins._needsInstall.push(publishedPlugin);
            }
        }
        for (var installedPlugin in surveyedPlugins) {
            GM.plugins.addInstalled(installedPlugin);
            if (publishedPluginsForPlatform[installedPlugin] && GM.plugins.needsUpdate(surveyedPlugins[installedPlugin], publishedPluginsForPlatform[installedPlugin])) {
                GM.plugins._needsUpdate.push(installedPlugin);
            }
        }
    },
    surveyPlugins: function () {
        GM.plugins._surveyDeferred = $.Deferred();
        GM.controller.event_to_native('surveyPlugins', {});
        var timeout = setTimeout(function () {
            GM.plugins._surveyDeferred.reject();
        }, 10000);
        GM.plugins._surveyDeferred.done(function () {
            clearTimeout(timeout);
        });
        return GM.plugins._surveyDeferred.promise();
    },
    shutdown: function () {
        var pluginName = '',
            dfd, deferreds = [],
            count = 0;
        process = $.Deferred();
        process.done(function () {
            GM.controller.event_to_native('clientShutdownConfirmation', {});
        });
        for (var i = 0; i < GM.plugins._enabled.length; i++) {
            pluginName = GM.plugins._enabled[i];
            dfd = $.Deferred();
            dfd.done(function () {
                count++;
                if (count == deferreds.length) {
                    process.resolve();
                }
            });
            deferreds.push(dfd);
            GM.plugins._process[pluginName] = GM.plugins.newShutdownMachine();
            GM.plugins._process[pluginName].trigger('shutdown', {
                pluginName: pluginName,
                deferred: dfd
            });
        }
        if (deferreds.length == 0) {
            process.resolve();
        }
    },
    load: function (pluginName) {
        var dfd = $.Deferred();
        dfd.done(function () {
            GM.plugins.addEnabled(pluginName);
        });
        if (!isEmpty(GM.plugins._process)) {
            dfd.reject({
                "message": "Update/Install already in progress"
            });
            return dfd.promise();
        }
        $.when(GM.plugins._surveyDeferred, GM.plugins._manifestDeferred).always(function () {
            GM.plugins._process[pluginName] = GM.plugins.newUpdateMachine();
            GM.plugins._process[pluginName].trigger('use', {
                pluginName: pluginName,
                deferred: dfd
            });
        });
        return dfd.promise();
    },
    getManifest: function () {
        GM.plugins._manifestDeferred = $.Deferred();
        var dataType = "json";
        $.ajax(GM.urls.get_url('pluginManifest'), {
            "dataType": dataType
        }).done(function (data) {
            GM.plugins._manifest = data;
            GM.plugins._manifestDeferred.resolve();
        });
        var timeout = setTimeout(function () {
            GM.plugins._manifestDeferred.reject();
        }, 10000);
        GM.plugins._manifestDeferred.done(function () {
            clearTimeout(timeout);
        });
        return GM.plugins._manifestDeferred.promise();
    },
    showPlugin: function (pluginName, visible) {
        var current = GM.plugins.getData(pluginName, 'visible');
        if (typeof visible === 'undefined') {
            visible = true;
        }
        if (!GM.plugins.isEnabled(pluginName)) {
            return;
        }
        if (current == visible) {
            return;
        }
        GM.plugins.setData(pluginName, 'visible', visible);
        GM.controller.event_to_native('pluginExecute', {
            pluginName: pluginName,
            action: "SetVisibility",
            params: JSON.stringify({
                isVisible: visible
            })
        });
    },
    isEnabled: function (pluginName) {
        return GM.plugins._enabled.indexOf(pluginName) >= 0;
    },
    addEnabled: function (pluginName) {
        if (!GM.plugins.isEnabled(pluginName)) {
            GM.plugins._enabled.push(pluginName);
        }
    },
    removeEnabled: function (pluginName) {
        var index = GM.plugins._enabled.indexOf(pluginName);
        if (index >= 0) {
            GM.plugins._enabled = GM.plugins._enabled.splice(index, 1);
        }
    },
    isInstalled: function (pluginName) {
        return true;
    },
    addInstalled: function (pluginName) {
        if (GM.plugins._registered.indexOf(pluginName) < 0) {
            GM.plugins._registered.push(pluginName);
        }
    },
    removeInstalled: function (pluginName) {
        var index = GM.plugins._registered.indexOf(pluginName);
        if (index >= 0) {
            GM.plugins._registered = GM.plugins._registered.splice(index, 1);
        }
    },
    getRegisteredPlugins: function () {
        return GM.plugins._registered;
    },
    getData: function (pluginName, key) {
        if (typeof GM.plugins._data[pluginName] === 'undefined') {
            return null;
        }
        if (key === undefined) {
            return GM.plugins._data[pluginName];
        }
        return GM.plugins._data[pluginName][key];
    },
    setData: function (pluginName, key, value) {
        if (typeof key === 'object' && value === undefined) {
            GM.plugins._data[pluginName] = key;
            return !!GM.plugins._data[pluginName];
        }
        if (typeof GM.plugins._data[pluginName] == 'undefined') {
            GM.plugins._data[pluginName] = {};
        }
        GM.plugins._data[pluginName][key] = value;
        return !!GM.plugins._data[pluginName][key];
    },
    setStreamingData: function (wrapper) {
        for (var key in wrapper.data) {
            GM.plugins.setData(wrapper.pluginName, key, wrapper.data[key]);
        }
    },
    ucgsDownload: function (wrapper) {
        GM.controller.event_to_native('downloadNewGame', {
            wrappingID: wrapper.wrappingID,
            downloadFullVersion: wrapper.downloadFullVersion
        });
        $('#queue_download').click();
    },
    ucgsBuy: function (wrapper) {
        GM.overlay.open('buy', {
            wrappingID: wrapper.wrappingID
        });
    },
    needsInstall: function (plugin, installedPlugins) {
        return typeof installedPlugins[plugin] === 'undefined';
    },
    needsUpdate: function (installedPlugin, publishedPlugin) {
        return compareVersion(installedPlugin.version, publishedPlugin.metadata.version) !== 0;
    },
    stopStream: function () {
        GM.controller.event_to_native('pluginExecute', {
            pluginName: 'streamingPlugin',
            action: "CloseSession",
            params: JSON.stringify({})
        });
    }
};
GM.plugins.startup();
(function () {
    "use strict";
    if (typeof GM.plugins !== 'object') {
        throw "Error: GM.plugins is not ready!";
    }
    var states = {
        init: {
            events: {
                use: "use"
            }
        },
        use: {
            enter: function (event, data) {
                this.pluginName = data.pluginName;
                if (data.deferred) {
                    this.deferred = data.deferred;
                }
                if (GM.plugins._needsInstall.indexOf(this.pluginName) > -1) {
                    GM.overlay.open('busy', {
                        msg: GM.text.installing_plugin_msg
                    });
                    return this.trigger('install');
                }
                if (GM.plugins._needsUpdate.indexOf(this.pluginName) > -1) {
                    return this.trigger('update');
                }
                if (GM.plugins.isEnabled(this.pluginName)) {
                    return this.trigger('ready');
                }
                return this.trigger('load');
            },
            events: {
                load: "load",
                update: "close",
                install: "download",
                ready: "ready"
            }
        },
        close: {
            enter: function () {
                GM.controller.event_to_native('pluginExecute', {
                    pluginName: this.pluginName,
                    action: "CloseLibrary",
                    params: JSON.stringify({})
                });
            },
            events: {
                error: "update_error",
                unload: "unload"
            }
        },
        unload: {
            enter: function () {
                GM.plugins.removeEnabled(this.pluginName);
                GM.controller.event_to_native('unloadPlugin', {
                    pluginName: this.pluginName
                });
            },
            events: {
                error: "update_error",
                download: "download"
            }
        },
        download: {
            enter: function () {
                var platform = GM.data.userData.platform,
                    allPlugins = GM.plugins._manifest.plugins[platform],
                    url = '';
                for (var key in allPlugins) {
                    if (key === this.pluginName) {
                        url = allPlugins[key].downloadURL;
                    }
                }
                GM.controller.event_to_native('appDataDownload', {
                    appdata_url: url.substring(0, url.lastIndexOf("/")),
                    category: 'Plugins',
                    file_folder: this.pluginName,
                    appdata_key: this.pluginName,
                    file_name: url.substring(url.lastIndexOf("/") + 1)
                });
            },
            events: {
                error: "update_error",
                survey: "survey"
            }
        },
        survey: {
            enter: function () {
                var machine = this;
                GM.plugins.surveyPlugins().done(function () {
                    machine.trigger('check');
                });
            },
            events: {
                error: "update_error",
                check: "check"
            }
        },
        check: {
            enter: function () {
                GM.plugins.parsePluginConfigs();
                var install = GM.plugins._needsInstall.indexOf(this.pluginName) >= 0,
                    update = GM.plugins._needsUpdate.indexOf(this.pluginName) >= 0;
                if (install || update) {
                    return this.trigger('error', {
                        "install": install,
                        "update": update
                    });
                }
                this.trigger('load');
            },
            events: {
                load: "load",
                error: "update_error"
            }
        },
        load: {
            enter: function () {
                GM.user_data.updateStreamingUser();
                var metadata = JSON.stringify({
                    "metaData": {
                        ClientGUID: GM.data.userData.clientGUID,
                        WebUserAgent: GM.data.userData.userAgent,
                        ConsumerVersion: "3.2",
                        ConsumerId: "GM"
                    }
                });
                GM.controller.event_to_native('loadPlugin', {
                    pluginName: this.pluginName,
                    needsParentWindow: true,
                    metaDataString: metadata
                });
            },
            events: {
                error: "update_error",
                ready: "ready"
            }
        },
        ready: {
            enter: function () {
                this.trigger('exit');
                if (this.deferred) {
                    this.deferred.resolve();
                }
            },
            events: {
                exit: "exit"
            }
        },
        update_error: {
            enter: function (event, data) {
                this.trigger('exit');
                if (this.deferred) {
                    this.deferred.reject();
                }
            },
            events: {
                exit: "exit"
            }
        },
        exit: {
            enter: function () {
                delete GM.plugins._process[this.pluginName];
            }
        }
    };
    GM.plugins.newUpdateMachine = function () {
        return new StateMachine(states, 'init');
    };
    GM.plugins.pluginMachine = null;
})();
(function () {
    "use strict";
    if (typeof GM.plugins !== 'object') {
        throw "Error: GM.plugins is not ready!";
    }
    var states = {
        init: {
            events: {
                shutdown: "shutdown"
            }
        },
        shutdown: {
            enter: function (event, data) {
                console.log("*ShutdownMachine shutdown: ", event, data);
                this.pluginName = data.pluginName;
                if (data.deferred) {
                    this.deferred = data.deferred;
                }
                var isStreamingActive = GM.plugins.getData('streamingPlugin', 'streamActive');
                if (isStreamingActive) {
                    return this.trigger('close_session');
                }
                return this.trigger('close');
            },
            events: {
                close_session: "close_session",
                close: "close"
            }
        },
        close_session: {
            enter: function () {
                console.log("*ShutdownMachine close_session: ");
                GM.plugins.stopStream();
            },
            events: {
                close: "close"
            }
        },
        close: {
            enter: function () {
                console.log("*ShutdownMachine close");
                GM.controller.event_to_native('pluginExecute', {
                    pluginName: this.pluginName,
                    action: "CloseLibrary",
                    params: JSON.stringify({})
                });
            },
            events: {
                unload: "unload"
            }
        },
        unload: {
            enter: function () {
                console.log("*ShutdownMachine unload");
                GM.plugins.removeEnabled(this.pluginName);
                GM.controller.event_to_native('unloadPlugin', {
                    pluginName: this.pluginName
                });
            },
            events: {
                download: "exit"
            }
        },
        exit: {
            enter: function () {
                console.log("*ShutdownMachine exit");
                this.deferred.resolve();
                delete GM.plugins._process[this.pluginName];
            }
        }
    };
    GM.plugins.newShutdownMachine = function () {
        return new StateMachine(states, 'init');
    };
})();
var GM = GM || {};
GM.prices = {
    _std: 'STANDARD_GAME',
    _col: 'COLLECTORS_EDITION',
    _dd: 'DAILY',
    _cow: 'WEEKLY',
    _gc: 'GC_MEMBER_MONTHLY',
    _non_gc: 'NON_GC_MEMBER',
    _deal_daily: 'dailyDeal',
    _deal_weekly: 'weeklyDeal',
    set_price_list: function (priceList, ttl) {
        GM.data.priceList = priceList;
        GM.data.priceList.ttl = ttl;
    },
    set_deal_list: function (deal_list) {
        if (deal_list && $.ct(deal_list, 'object')) {
            $.each(deal_list, function (siteID, deals) {
                if (deals) {
                    GM.data.dealList[siteID] = deals.deals;
                    GM.data.dealList[siteID].ttl = deals.ttl;
                }
            });
        }
    },
    check_for_updates: function (siteID, is_future) {
        var updates_requested = {
            priceList: false,
            dealList: false
        };
        var expiry = GM.ads.get_time() + (is_future ? 3600 : 0);
        if (!GM.data.priceList[siteID] || GM.data.priceList.ttl < expiry) {
            GM.controller.event_to_native('getPriceList', {});
            updates_requested.priceList = true;
        }
        if (!GM.data.dealList[siteID] || GM.data.dealList[siteID].ttl < expiry) {
            GM.controller.event_to_native('getDealList', {});
            updates_requested.dealList = true;
        }
        return updates_requested;
    },
    has_prices: function (siteID) {
        if ($.ct(GM.data.priceList[siteID], 'object')) {
            if (!GM.data.priceList[siteID][this._gc] || !GM.data.priceList[siteID][this._gc][this._std] || !GM.data.priceList[siteID][this._gc][this._col] || !GM.data.priceList[siteID][this._non_gc] || !GM.data.priceList[siteID][this._non_gc][this._std] || !GM.data.priceList[siteID][this._non_gc][this._col]) {
                return false;
            }
            var requested = this.check_for_updates(siteID, false);
            return !requested.priceList;
        }
        return false;
    },
    get_gc_price: function (siteID, wrapID, is_collectors) {
        if (!this.has_prices(siteID)) {
            return null;
        }
        var key_name = this._get_key(siteID, wrapID, this._gc);
        return (key_name === this._gc ? GM.data.priceList[siteID][key_name][is_collectors ? this._col : this._std].amount : GM.data.priceList[siteID][this._gc][key_name].amount);
    },
    get_non_gc_price: function (siteID, wrapID, is_collectors) {
        if (!this.has_prices(siteID)) {
            return null;
        }
        return GM.data.priceList[siteID][this._non_gc][is_collectors ? this._col : this._std].amount;
    },
    get_credits: function (siteID, wrapID, is_collectors) {
        if (!this.has_prices(siteID)) {
            return null;
        }
        var key_name = this._get_key(siteID, wrapID, this._gc);
        return (key_name === this._gc ? GM.data.priceList[siteID][key_name][is_collectors ? this._col : this._std].credits : GM.data.priceList[siteID][this._gc][key_name].credits);
    },
    requires_gc_discount: function (siteID, wrapID) {
        if (this._is_cow(siteID, wrapID)) {
            return false;
        }
        return true;
    },
    is_a_deal: function (siteID, wrapID) {
        if (this._is_daily_deal(siteID, wrapID)) {
            return true;
        } else if (this._is_cow(siteID, wrapID)) {
            return true;
        }
        return false;
    },
    _get_key: function (siteID, wrapID, default_key) {
        var key_name = default_key;
        if (this._is_daily_deal(siteID, wrapID)) {
            key_name = this._dd;
        } else if (this._is_cow(siteID, wrapID)) {
            key_name = this._cow;
        }
        return key_name;
    },
    _is_daily_deal: function (siteID, wrapID) {
        var requested = this.check_for_updates(siteID, false);
        if (requested.dealList) {
            return false;
        }
        return (GM.data.dealList[siteID] && GM.data.dealList[siteID][this._deal_daily] && GM.data.dealList[siteID][this._deal_daily].wrappingId === wrapID && GM.data.priceList[siteID][this._gc][this._dd]);
    },
    _is_cow: function (siteID, wrapID) {
        var requested = this.check_for_updates(siteID, false);
        if (requested.dealList) {
            return false;
        }
        return (GM.data.dealList[siteID] && GM.data.dealList[siteID][this._deal_weekly] && GM.data.dealList[siteID][this._deal_weekly].wrappingId === wrapID && GM.data.priceList[siteID][this._gc][this._cow]);
    }
};
var GM = GM || {};

function leftnav_addIconWithText(icon, number_text) {
    if (typeof (icon) == 'undefined') return '';
    number_text = typeof (number_text) !== 'undefined' ? number_text : "";
    return ('<span class="' + icon + '">' + number_text + '</span>');
}
GM.render = {
    _initial_view_drawn: false,
    _redraw_in_progress: false,
    draw_initial_view: function () {
        if (!GM.data.userData.sort.sort) {
            GM.data.userData.sort['sort'] = 'sort_az';
        }
        if (!GM.data.userData.sort.page) {
            GM.data.userData.sort['page'] = 'sort_az';
        }
        this.draw_games(GM.data.userData.sort.sort);
        GM.user_data.updateHeader();
        this._initial_view_drawn = true;
    },
    draw_games: function (sort_by, wrapID, scroll_to_game, sort_change) {
        GM.profiler.start_timer('Drawing games ' + sort_by);
        if (!this._initial_view_drawn && !sort_by) {
            return false;
        }
        if (!sort_by) {
            sort_by = GM.data.userData.sort.page;
        }
        if (sort_by == 'sort_az' && !sort_change) {
            sort_by = GM.data.userData.sort.sort;
        }
        if (GM.data.userData.sort.page == 'recent_game') {
            return false;
        }
        if ($.inArray(sort_by, ['queue_update', 'gyb_page', 'recent_game']) > -1) {
            return false;
        }
        scroll_to_game = (sort_by === 'queue_download' ? false : scroll_to_game);
        GM.game_rows.sort_games(sort_by);
        if (GM.game_rows.get_game_count() > 0) {
            if (!sort_change && wrapID && $('#' + wrapID).size() > 0) {
                if (sort_by === 'queue_download' && GM.data.installedGames[wrapID].gameState.state !== 5) {
                    $('#' + wrapID).replaceWith($('#tmpl_game_rows').tmpl(GM.game_rows.get_dl_queue(wrapID)));
                } else if (sort_by !== 'queue_update') {
                    $('#' + wrapID).replaceWith($(GM.game_rows.game_rows[wrapID]).clone());
                }
            } else if (wrapID && !sort_change) {
                if (sort_by === 'queue_download') {
                    $('#download_queue .dl_q_none').slideUp();
                    var game_row = GM.game_rows.get_dl_queue(wrapID);
                    if (game_row.length > 0) {
                        $('#download_queue').prepend($('#tmpl_game_rows').tmpl(game_row));
                        $('#download_queue .gm_row:first').hide().slideDown();
                    }
                } else if ($.inArray(sort_by, ['sort_az', 'sort_installed', 'sort_played', 'sort_activation']) > -1) {
                    $('#content').removeClass();
                    var has_row = ($('#' + wrapID).size() > 0 && !sort_change);
                    if (has_row) {
                        $('#' + wrapID).replaceWith(GM.game_rows.game_rows[wrapID]);
                    } else {
                        var lastWrappingID = null;
                        $.each(GM.game_rows.sorted[sort_by], function (i, wrappingID) {
                            if (wrappingID === wrapID) {
                                if (lastWrappingID) {
                                    $(GM.game_rows.game_rows[wrappingID].insertAfter('#' + lastWrappingID));
                                } else {
                                    $('#content').prepend(GM.game_rows.game_rows[wrappingID]);
                                }
                                return false;
                            }
                            lastWrappingID = wrappingID;
                            return true;
                        });
                    }
                }
            } else if (sort_by !== 'queue_download') {
                if (this._redraw_in_progress) {
                    return false;
                }
                this._redraw_in_progress = true;
                $('#game_row_sort').show();
                $('#content').removeClass().empty();
                if (GM.game_rows.get_game_count() > 50) {
                    $('#content_outer').addClass('content_loading');
                }
                $.each(GM.game_rows.sorted[sort_by], function (i, wrappingID) {
                    setTimeout(function () {
                        var preventRedrawOn = ['queue_download', 'queue_update', 'gyb_page', 'recent_game'];
                        if (i === 0) {
                            $('#content_outer').removeClass('content_loading');
                        }
                        if (GM.plugins.getData('streamingPlugin', 'visible')) {
                            GM.console.log('returning from timeout');
                            return;
                        }
                        if ($.inArray(GM.data.userData.sort.page, preventRedrawOn) > -1) {
                            return false;
                        }
                        $('#content').append(GM.game_rows.game_rows[wrappingID]);
                        return true;
                    }, 0);
                });
                setTimeout(function () {
                    if (GM.data.overlay === 'gm_start') {
                        GM.overlay.close();
                    }
                    GM.render._redraw_in_progress = false;
                    GM.game_rows.draw_progress();
                    GM.render._simple_tips();
                }, 1);
                this.scroll_to_top();
            }
        } else {
            $('#content').removeClass().html($('#tmpl_no_games_installed').tmpl({
                no_games: GM.render.str_replace('<a>', '<a class="sort_games gyb_page">', GM.text.no_games_installed)
            }));
            if (GM.data.overlay === 'gm_start') {
                GM.overlay.close();
            }
        }
        if (scroll_to_game && wrapID) {
            this.scroll_to_game(wrapID);
        }
        GM.gybb.render(sort_by);
        GM.game_rows.draw_progress();
        GM.content_header.draw_header(sort_by);
        this.draw_left_nav(!this._initial_view_drawn);
        this._simple_tips();
        GM.controller.event_to_qa('draw_games_complete', {
            sort_by: sort_by
        });
        GM.profiler.end_timer('Drawing games ' + sort_by);
        return true;
    },
    draw_streaming: function (streamingPage, options) {
        streamingPage = streamingPage || '';
        options = options || {};
        if (!GM.util.checkIfUserOnline(true))
            return false;
        var dimensions = $('#content_container').dimensions();
        var paddingLeft = parseInt($('#content_container').css('padding-left').replace('px', ''), 10);
        dimensions.left += paddingLeft;
        dimensions.width -= paddingLeft;
        var pluginDeferred = GM.plugins.load('streamingPlugin').done(function () {
            GM.plugins.showPlugin('streamingPlugin');
            GM.controller.event_to_native('pluginExecute', {
                pluginName: 'streamingPlugin',
                action: 'LoadWeb',
                params: JSON.stringify({
                    appConfigUrl: GM.urls.get_url('appConfigUrl'),
                    top: dimensions.top,
                    left: dimensions.left,
                    width: dimensions.width - 10,
                    height: dimensions.height,
                    page: streamingPage,
                    menuHeight: $('#content_header').outerHeight()
                })
            });
            GM.gybb._hide();
            $('#game_row_sort').hide();
            GM.navigation.setActive((options.page || GM.data.userData.sort.page), (options.sort || null));
            GM.render.draw_left_nav();
            GM.content_header.draw_header();
            $('#content').html($.tmpl('', {}));
        });
    },
    refresh_streaming: function () {
        var pluginDeferred = GM.plugins.load('streamingPlugin').done(function () {
            GM.plugins.showPlugin('streamingPlugin');
            GM.controller.event_to_native('pluginExecute', {
                pluginName: 'streamingPlugin',
                action: 'Refresh',
                params: JSON.stringify({})
            });
            GM.gybb._hide();
            $('#game_row_sort').hide();
        });
    },
    draw_left_nav: function (is_initial_view) {
        GM.profiler.start_timer('Draw left nav');
        if (!GM.navigation._inited) {
            GM.navigation.init();
        }
        var menus = {
            "categories": GM.navigation.build()
        };
        $('#left_nav').replaceWith('<div id="left_nav" class=""></div>');
        $('#left_nav').append($('#tmpl_left_nav_cat').tmpl(menus));
        var bottomAd = {
            ad: GM.ads.get_current_ad_html('left_nav', GM.data.userData.siteID)
        };
        $('#left_nav').append($("#tmpl_left_nav_ad").tmpl(bottomAd));
        GM.urls.set_logo_url();
        GM.profiler.end_timer('Draw left nav');
 
		//KD major hack 
		//hide casino nodes and F2p nodes
		//cannot remove these or the game search is broken
		//because it depends on some innerHTML inserted in these nodes
		//probably from http://cdn-games.bigfishsites.com/gm_32/gm_content_32/StandalonePages/catalog.js
		//
        var elem = document.getElementById("f2p_casino");
        if(elem) { elem.style.display = "none"; }
         elem = document.getElementById("left_nav_f2p_list");
        if(elem) { elem.style.display = "none"; }
          elem = document.getElementById("left_nav_header_f2p");
        if(elem) { elem.style.display = "none"; }

    },
    draw_dl_queue: function () {
        $('#game_row_sort').hide();
        $('#content').removeClass();
        GM.data.userData.sort.page = 'queue_download';
        GM.content_header.draw_header('queue_download');
        $('#content').html($('#tmpl_download_queue').tmpl({
            dl_q: GM.game_rows.get_dl_queue(),
            none: GM.text.none_downloading,
            play: {
                size: 'med',
                color: 'blue',
                type: 'plain sort_games ' + GM.data.userData.sort.sort,
                text: GM.text.play_my_games
            }
        }));
        GM.gyb.text_overflow();
        this.scroll_to_top();
        this.draw_left_nav();
        GM.game_rows.draw_progress();
        GM.gybb.render();
        this._simple_tips();
        this.game_tips();
        GM.controller.event_to_qa('draw_dl_queue_complete', {});
    },
    draw_update_queue: function () {
        $('#game_row_sort').hide();
        $('#content').removeClass();
        GM.updates.draw_updates();
        GM.data.userData.sort.page = 'queue_update';
        GM.content_header.draw_header();
        this.scroll_to_top();
        GM.urls.set_logo_url();
        GM.gybb.render();
        this._simple_tips();
        GM.controller.event_to_qa('draw_update_queue_complete', {});
    },
    draw_gyb: function () {
        $('#game_row_sort').hide();
        $('#content').removeClass().addClass('blue_bg');
        GM.data.userData.sort.page = 'gyb_page';
        GM.gyb.draw_gyb_page();
        this.scroll_to_top();
        GM.urls.set_logo_url();
        GM.gybb.render();
        this.game_tips();
        this._simple_tips();
        GM.controller.event_to_qa('draw_gyb_complete', {});
    },
    draw_recent_game: function (is_pre_launch, credits_used, is_same_game) {
        GM.plugins.showPlugin('streamingPlugin', false);
        if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
            GM.plugins.stopStream();
        }
        $('#content_outer').css('margin-top', '0px');
        $('#content_outer').css('height', '100%');
        $('.sort_games').removeClass('sort_active');
        $('.recent_game').addClass('sort_active');
        GM.data.userData.sort.page = 'recent_game';
        GM.content_header.draw_header('recent_game');
        GM.recent_activity.draw_recent(is_pre_launch, credits_used, is_same_game);
        this.scroll_to_top();
        GM.gybb.render('recent_game', GM.recent_activity.has_gyb());
        this.draw_left_nav();
        this._flash();
        this._simple_tips();
        this.game_tips();
        GM.render.draw_left_nav();
        GM.controller.event_to_qa('draw_wrapper_complete', {
            wrappingID: GM.data.recent,
            error: (GM.data.installedGames[GM.data.recent] ? GM.data.installedGames[GM.data.recent].gameState.errorCode : null)
        });
    },
    draw_purchase_history_page: function (sortType) {
        if (!GM.util.checkIfUserOnline(true))
            return false;
        var displayPageContents = true;
        $('#GM_header_spinner').hide();
        GM.data.userData.page = "purchase_history_page";
        GM.data.userData.sort.page = "purchase_history_page";
        $('#container').removeClass('content_with_bar');
        $('#content_outer').scrollTop(0);
        GM.urls.set_logo_url();
        $('.sort_games').removeClass('sort_active');
        $('.purchase_page').addClass('sort_active');
        $('#content').removeClass('yellow_bg').addClass('blue_bg');
        GM.content_header.draw_header();
        if (!GM.data.userData.gameLibrary) {
            displayPageContents = false;
            GM.deferredObjects.purchaseHistoryDeferred = $.Deferred()
            GM.util.getPurchaseHistoryList();
            GM.deferredObjects.purchaseHistoryDeferred.done(function () {
                $('#GM_header_spinner').hide();
                if (GM.data.userData.sort.page == "purchase_history_page") {
                    GM.render.draw_purchase_history_page(sortType);
                }
                GM.deferredObjects.purchaseHistoryDeferred = $.Deferred();
            });
        }
        if (displayPageContents) {
            if (GM.data.userData.gameLibrary.length == 0) {
                $('#content').removeClass().html($('#tmpl_no_games_installed').tmpl({
                    no_games: GM.text.no_purchase_history
                }));
            } else {
                GM.content_header._draw_purchase_sort();
                if (!sortType || sortType == "game_title") {
                    GM.data.userData.gameLibrary.sort(function (a, b) {
                        return a.title.localeCompare(b.title);
                    });
                    $('#game_title').attr('selected', 'selected');
                } else if (sortType == "order_date") {
                    GM.data.userData.gameLibrary.sort(function (a, b) {
                        return b.transactionTimestamp - a.transactionTimestamp;
                    });
                    $('#order_date').attr('selected', 'selected');
                } else if (sortType == "activation_status") {
                    GM.data.userData.gameLibrary.sort(function (a, b) {
                        return a.activationRank - b.activationRank;
                    });
                    $('#activation_status').attr('selected', 'selected');
                };
                var diffPlatformText = (GM.data.userData.platform === 'windows' ? GM.text.purchase_history_win_unsupported : GM.text.purchase_history_mac_unsupported);
                $('#content').html($('#tmpl_purchase_history').tmpl({
                    gamelist: GM.data.userData.gameLibrary,
                    purchasedOn: GM.text.purchasedOn,
                    differentPlatform: diffPlatformText,
                    sourceOfButton: "purchaseHistoryPage"
                }));
                if (GM.tracking) {
                    GM.tracking.sendPageViewEvent({
                        "page": "PurchaseHistory"
                    });
                }
                $('#game_row_sort').show();
            }
        } else {
            $('#game_row_sort').hide();
            $('#GM_header_spinner').show();
            $('#content').html($.tmpl('<div  id="spinning_loader_purchase" class="gm_row" style="border:none; height:600px;" ><span style="display: block;margin:300px auto;" class="icon_spinning"/></div>', {}));
        }
        GM.gybb.render();
    },
    initialize_upsells: function () {
        if (GM.data.userData.sort.page === 'gyb_page') {
            this.draw_gyb();
        } else {
            var force_draw = false;
            if (GM.data.userData.sort.page === 'recent_game' && GM.data.recent && GM.data.installedGames[GM.data.recent] && GM.data.installedGames[GM.data.recent].activated) {
                force_draw = true;
            }
            GM.gybb.render(null, force_draw);
        }
    },
    set_options: function (ops) {
        if (GM.data.overlay === 'options' && GM.data.options) {
            GM.data.options = $.extend(true, {}, GM.data.options, ops);
            if ($('#o_options_about .check_gm_updates:visible').size() > 0 && ops.gmUpdateAvailable && ops.gmUpdateAvailable !== 'unknown') {
                $('#o_options_about .check_gm_updates').hide();
                $('#ops_gm_updates').show();
            }
            var err_txt = GM.text.err_911_msg;
            if ($('#o_options_dl .ops_checking:visible').size() > 0) {
                var n = GM.data.options.gameUpdatesAvailable;
                $('#o_options_dl .ops_checking').hide();
                if (n === 'error') {
                    if (GM.data.options.gameUpdatesError) {
                        if (GM.data.options.gameUpdatesError == 768) {
                            err_txt = GM.text.err_1768_msg;
                        }
                        $('#ops_game_update_error').html(err_txt);
                        $('#ops_game_update_error_wrapper').show();
                    }
                } else {
                    $('#ops_update_man_result').html(GM.render.str_replace('[NUMBER]', n, GM.text[(n === 0 ? 'o_options_dl_no_updates' : (n > 1 ? 'o_options_dl_gt1_updates' : 'o_options_dl_eq1_update'))])).addClass('success').show();
                    if (n > 0) {
                        $('.check_game_updates_install').show();
                    }
                }
            } else if ($('#ops_gm_updates:visible').size() > 0) {
                var up = GM.data.options.gmUpdateAvailable;
                var css = null;
                switch (up) {
                    case 'yes':
                        css = 'update_found';
                        $('.check_gm_updates_install').show();
                        break;
                    case 'no':
                        css = 'current_gm';
                        break;
                    case 'downloading':
                        css = 'downloading_gm';
                        $('.check_gm_updates_install').hide();
                        break;
                    case 'installing':
                        css = 'installing_gm';
                        break;
                    case 'applied':
                        css = 'update_applied';
                        break;
                    case 'error':
                        if (GM.data.options.gmUpdateError == 768) {
                            err_txt = GM.text.err_1768_msg;
                        }
                        css = 'update_error';
                        $('#ops_update_error').html(err_txt);
                        break;
                }
                if (css) {
                    $('#ops_gm_updates').removeClass().addClass(css);
                }
            }
            if ($.ct(ops.gameInstallPathHistory, 'array') && !$.is_empty(ops.gameInstallPathHistory)) {
                $('#o_options_browse').val(ops.gameInstallPathHistory[0]);
            }
        } else {
            if ($.ct(ops.gameInstallPathHistory, 'array') && !$.is_empty(ops.gameInstallPathHistory)) {
                $('#o_wizard_location').val(ops.gameInstallPathHistory[0]);
            }
            GM.data.options = $.extend(true, {}, GM.data.options, ops);
        }
    },
    show_overlay: function (overlayID, params) {
        GM.overlay.open(overlayID, params);
    },
    close_overlay: function () {
        GM.overlay.close();
    },
    _simple_tips: function () {
        $('#simple_tip').hide();
        $.simple_tip('.tip', {
            follow: true
        });
    },
    game_tips: function () {
        $('#ptip').hide();
        $.pointy_tips.game_links('.pointy_tips');
    },
    get_error_text: function (code, replace, wrappingID, has_links) {
        var err_msg = '',
            game = (wrappingID && GM.data.installedGames[wrappingID] ? GM.data.installedGames[wrappingID].name : ''),
            siteID = (game ? GM.data.installedGames[wrappingID].siteID : GM.data.userData.siteID);
        if (!GM.text['err_' + code + '_msg']) {
            return err_msg;
        }
        err_msg = GM.text['err_' + code + '_msg'];
        replace = replace || [];
        $.each(replace, function (i, r) {
            err_msg = err_msg.replace(new RegExp('%' + (i + 1), 'g'), r);
        });
        err_msg = err_msg.replace(/\[CODE\]/g, '<strong>' + (GM.text.err_code.replace('[CODE]', code)) + '</strong>');
        err_msg = err_msg.replace(/\[GAME\]/g, game);
        if (has_links) {
            err_msg = err_msg.replace(/\[CONTACT\]/g, '<a href="' + GM.urls.get_url('help') + '?rn=ask&rn_data={category:game_manager,error_code:' + code + '}" target="_blank">' + GM.text.err_contact + '</a>');
            err_msg = err_msg.replace(/\[HELP\]/g, '<a href="' + GM.urls.get_url('help') + '?rn=game_manager#' + code + '" target="_blank">' + GM.text.err_help + '</a>');
            err_msg = err_msg.replace(/\[GYB\]/g, '<a class="sort_games gyb_page overlay_close">' + GM.text.gyb + '</a>');
            err_msg = err_msg.replace(/\[PURCHASE_CLICK]/g, '<a href="' + GM.urls.get_buy_url(siteID, wrappingID) + '" target="_blank">' + GM.text.err_purchase_click + '</a>');
            err_msg = err_msg.replace(/\[PLAY\]/g, '<a class="btn_play" data-wrapID="' + wrappingID + '">' + GM.text.err_play + '</a>');
        } else {
            err_msg = err_msg.replace(/\[CONTACT\]/g, GM.text.err_contact);
            err_msg = err_msg.replace(/\[HELP\]/g, GM.text.err_help);
            err_msg = err_msg.replace(/\[GYB\]/g, GM.text.gyb);
            err_msg = err_msg.replace(/\[PURCHASE_CLICK]/g, '<a href="' + GM.urls.get_buy_url(siteID, wrappingID) + '" target="_blank">' + GM.text.err_purchase_click + '</a>');
            err_msg = err_msg.replace(/\[PLAY\]/g, GM.text.err_play);
        }
        return err_msg;
    },
    str_replace: function (search, replace, string) {
        if ($.ct(search, 'array') && $.ct(replace, 'array') && search.length === replace.length) {
            $.each(search, function (i, s) {
                string = string.replace(s, replace[i]);
            });
        } else {
            string = string.replace(search, replace);
        }
        return string;
    },
    scroll_to_top: function () {
        $('#content_outer').scrollTop(0);
    },
    _flash: function () {
        if (GM.data.options.showGameVideos) {
            $.each($('[data-flash]'), function () {
                var fdata = $.parseJSON($(this).attr('data-flash'));
                if (!fdata.AllowScriptAccess) {
                    fdata.AllowScriptAccess = 'always';
                }
                $(this).flash(fdata);
            });
        }
    },
    scroll_to_game: function (wrapID) {
        var w = $('#' + wrapID);
        if ($(w).size() === 1) {
            var top_pad = parseInt($('#content').css('paddingTop').replace('px', ''), 10);
            $('#content_outer').animate({
                scrollTop: ($(w).offset().top - $('#content').offset().top - top_pad)
            });
        }
    }
};
var GM = GM || {};
GM.urls = {
    set_urls: function (urls) {
        GM.data.urls = urls;
    },
    get_url: function (type, siteID) {
        if (typeof siteID === 'undefined' && typeof GM.data.userData.siteID === 'undefined') {
            return '#';
        }
        siteID = (siteID || GM.data.userData.siteID);
        if (typeof GM.data.urls[siteID] === 'undefined') {
            return '#';
        }
        if (typeof (GM.data.urls[siteID].extraUrls) === 'string') {
            GM.data.urls[siteID].extraUrls = JSON.parse(GM.data.urls[siteID].extraUrls);
        }
        var urls = {
            "activate": GM.data.urls[siteID].store + '/source/gm/activate',
            "cart": GM.data.urls[siteID].store + '/source/gm/cart',
            "forums": GM.data.urls[siteID].site + '/usher/?loc=forums',
            "gyb": GM.data.urls[siteID].site + '/usher/?loc=gyb&amp;os=' + GM.data.userData.platform,
            "help": GM.data.urls[siteID].site + '/help/',
            "passwordHelp": GM.data.urls[siteID].site + '/help/index.html?rn=password',
            "share": GM.data.urls[siteID].site + '/usher/?loc=share',
            "site": GM.data.urls[siteID].site + '/',
            "susi": GM.data.urls[siteID].susi + '/',
            "streaming": GM.data.urls[siteID].streaming + '/',
            "strm_subscribe": GM.data.urls[siteID].store + '/source/gm?bfus=1',
            "checkLogin": GM.data.urls[siteID].streaming + '/user/check.json',
            "onlineCheck": GM.data.urls[siteID].site + '/server_time.php',
            "activation": GM.data.urls[siteID].store + '/api/v1/activation',
            "purchaseHistory": GM.data.urls[siteID].store + '/api/v1/gamelibrary',
            "gmTracking": GM.data.urls[siteID].extraUrls.gmTracking,
            "onlineGameBase": GM.data.urls[siteID].site + '/standalone/online-games/'
        };
        if (GM.data.urls[siteID].extraUrls[type]) {
            return GM.data.urls[siteID].extraUrls[type];
        }
        if (GM.data.urls[siteID]) {
            return urls[type] || '#';
        }
        return '#';
    },
    get_buy_url: function (siteID, wrappingID, is_gyb) {
        var url = this.get_url('cart', siteID) + '?wrapID=' + wrappingID;
        var page = this.get_tracking_page();
        var npc = 'gm';
        var npv1 = page;
        var npv2 = 'unknown';
        var npv3 = wrappingID;
        var npv4 = '';
        if (is_gyb) {
            npv2 = 'im';
            $.each(GM.data.upsell, function (i, obj) {
                if (obj.wrappingID === wrappingID) {
                    if (obj.algorithmID) {
                        npv4 = obj.algorithmID;
                    } else if (obj.npv1) {
                        npv4 = obj.npv1;
                    }
                }
            });
        } else if (wrappingID && GM.data.installedGames[wrappingID]) {
            var ginfo = GM.data.installedGames[wrappingID];
            if (ginfo.tracking) {
                if (ginfo.tracking.page) {
                    npv1 = page;
                }
                if (ginfo.tracking.algorithmID) {
                    npv4 = ginfo.tracking.algorithmID;
                } else if (ginfo.tracking.npv1) {
                    npv4 = ginfo.tracking.npv1;
                }
            }
        }
        var npi = npv1 + npv2 + npv3 + npv4;
        url += '&npc=' + npc + '&npv1=' + npv1 + '&npv2=' + npv2 + '&npv3=' + npv3 + (npv4 ? ('&npv4=' + npv4) : '') + '&npi=' + npi;
        return url;
    },
    get_forums_url: function (wrappingID) {
        var url = null;
        if (GM.data.userData.siteID === '1' && GM.data.installedGames[wrappingID] && GM.data.installedGames[wrappingID].siteID === '1') {
            url = this.get_url('forums', 1);
            if (url === '#') {
                return null;
            }
            url += '&amp;wid=' + wrappingID;
        }
        return url;
    },
    get_gift_url: function (wrappingID) {
        var url = null;
        if (GM.data.installedGames[wrappingID]) {
            url = this.get_url('cart', GM.data.installedGames[wrappingID].siteID);
            if (url === '#') {
                return null;
            }
            url += '?productID=1&amp;tryGame=' + wrappingID;
        }
        return url;
    },
    get_share_url: function (wrappingID) {
        var url = null;
        if (GM.data.userData.siteID === '1' && GM.data.installedGames[wrappingID]) {
            url = this.get_url('share', GM.data.installedGames[wrappingID].siteID);
            if (url === '#') {
                return null;
            }
            url += '&amp;wid=' + wrappingID;
        }
        return url;
    },
    get_site_url: function (siteID, type) {
        var url = this.get_url('site', siteID);
        if (url === '#') {
            return null;
        }
        var routes = {
            "privacy": 'company/privacy.html',
            "terms": 'company/terms.html'
        };
        url += routes[type] || '';
        return url;
    },
    get_susi_url: function (siteID, type) {
        var url = this.get_url('susi', siteID);
        if (url === '#') {
            return null;
        }
        var extra = {
            "forgot": '?forgot=true',
            "salliGForgot": "sallig/forgotpass/post?action=forgot_pass&email_forgot=[EMAIL]",
            "salliGLogin": "sallig/signin/post?&action=login&email_login=[EMAIL]&pass=[PASSWD]&persistent=yes&appID=gm&platform=[PLATFORM]",
            "salliGSignup": "sallig/signup/post?action=reg&reg_email=[EMAIL]&reg_pass=[PASSWD]&reg_pass_confirm=[PASSWD2]&reg_persistent=yes&reg_accept_tc=yes[NEWSLETTER]&ol=y_U4NnIdT_L9sahAdg-Hpg&appID=gm&platform=[PLATFORM]",
            "logout": "salli/signout/post"
        };
        return url + extra[type];
    },
    get_tracking_page: function () {
        var trackingPages = {
            "queue_download": "download",
            "queue_update": "updates",
            "gyb_page": "gyl",
            "recent_game": ($('#recent_activity').hasClass('recent_pre_trial') ? 'pretrial' : 'wrapper')
        };
        return trackingPages[GM.data.userData.sort.page] || 'mygames';
    },
    get_activate_url: function (siteID, wrappingID, is_gyb) {
        var url = GM.urls.get_url('activate', siteID) + '?wrapID=' + wrappingID;
        if (!GM.data.userData.hardwareID) {
            GM.util.missingHardwareIDForActivation();
            return "";
        } else {
            return url + "&hardwareID=" + GM.data.userData.hardwareID + "&gameIndex=1&downloadID=" + GM.data.installedGames[wrappingID].downloadID;
        }
    },
    set_logo_url: function () {
        var url = GM.data.urls[GM.data.userData.siteID];
        if (url) {
            var page = this.get_tracking_page();
            url = url.site;
            url += '?npc=gm&npv1=' + page + '&npv2=logo&npi=' + page + 'logo';
            $('#logo').attr('href', url);
        }
    }
};
var GM = GM || {};
GM.overlay = {
    _events_set: false,
    _easy_close: ['ad', 'activating', 'error', 'found_games', 'help', 'options', 'tour', 'uac_notification', 'login'],
    _non_interruptible: ['buy', 'login'],
    defaults: {
        has_close_btn: true,
        has_close_text: false,
        close_text: GM.text.close,
        content_header: true,
        is_ed: true,
        disable_easy_close: false
    },
    _wizard_ops: {
        createDesktopShortcut: false,
        createQuickLaunchShortcut: false,
        gameInstallPathHistory: [],
        email: '',
        getDeals: true
    },
    attachStreamingReload: function () {
        var dfd = GM.deferredObjects.overlayCloseDeferred;
        var deferredReady = typeof dfd === 'object' && dfd.promise && !dfd.isRejected() && !dfd.isResolved();
        if (!deferredReady) {
            GM.deferredObjects.overlayCloseDeferred = $.Deferred();
        }
        GM.deferredObjects.overlayCloseDeferred.done(function (overlay) {
            GM.plugins.showPlugin('streamingPlugin');
            GM.data.userData.sort.page = "";
            GM.render.draw_streaming("", {
                page: ""
            });
            GM.deferredObjects.overlayCloseDeferred = $.Deferred();
        });
    },
    ad: function (params) {
        if (GM.data.userData.isRetail) {
            return {};
        }
        var obj = {
            content_header: false
        };
        if (params.html) {
            obj.content = params.html;
        } else if (params.adType) {
            obj.content = GM.ads.get_current_ad_overlay(params.adType, GM.data.userData.siteID);
        }
        return obj;
    },
    activating: function (params) {
        var obj = {
            wrapper_class: 'o_waiting',
            has_close_btn: false,
            content_header: false
        };
        if (params.wrappingID && GM.data.installedGames[params.wrappingID]) {
            obj.activating = GM.render.str_replace('[GAME_NAME]', GM.data.installedGames[params.wrappingID].name, GM.text.o_activating_title);
        }
        return obj;
    },
    busy: function (params) {
        obj = {
            is_ed: true,
            msg: params.msg,
            wrapper_class: 'o_waiting',
            has_close_btn: false,
            content_header: false
        }
        return obj;
    },
    buy: function (params) {
        if (!GM.util.checkIfUserOnline(true))
            return false;
        var obj = {};
        var wrappingID = params.wrappingID;
        var purchaseURL = null;
        if (wrappingID && GM.data.installedGames[wrappingID]) {
            var p = GM.data.installedGames[wrappingID];
            siteID = p.siteID;
            credits = GM.prices.get_credits(siteID, wrappingID, p.isCollectors);
            purchaseURL = GM.urls.get_buy_url(p.siteID, wrappingID, false);
            is_demo = (p.trialType === 1);
        } else if (typeof params.urlKey !== 'undefined' && params.urlKey == 'strm_subscribe') {
            if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
                GM.plugins.stopStream();
            }
            purchaseURL = GM.urls.get_url('strm_subscribe');
            if (typeof params.productID !== 'undefined' && params.productID) {
                purchaseURL += '&productID=' + params.productID;
            }
        } else if (wrappingID) {
            for (var i = 0; i < GM.data.upsell.length; i++) {
                if (wrappingID === GM.data.upsell[i]["wrappingID"]) {
                    siteID = GM.data.upsell[i]["siteID"];
                    purchaseURL = GM.urls.get_buy_url(GM.data.upsell[i]["siteID"], wrappingID, true);
                }
                if (purchaseURL == null) {
                    purchaseURL = GM.urls.get_buy_url(GM.data.userData.siteID, wrappingID, false);
                }
            }
        } else if (typeof params.giftID !== 'undefined' && params.giftID) {
            var tracking = '&npc=gm&npv1=' + GM.urls.get_tracking_page() + '&npv2=unknown&npv3=' + params.giftID + '&npv4=&npi=gm' + GM.urls.get_tracking_page() + 'unknown' + params.giftID;
            if (params.trackingString) {
                tracking = params.trackingString;
            }
            purchaseURL = GM.urls.get_url('cart') + "?productID=1&tryGame=" + params.giftID + tracking;
        } else {
            purchaseURL = GM.urls.get_url('cart');
        }
        if (GM.data.purchaseURLOverrides && GM.data.purchaseURLOverrides[wrappingID]) {
            purchaseURL = GM.data.purchaseURLOverrides[wrappingID];
        }
        if (typeof params.wrappingIDList !== 'undefined' && params.wrappingIDList) {
            var tracking = '&npc=gm&npv1=' + GM.urls.get_tracking_page() + '&npv2=unknown&npv3=' + params.wrappingIDList.replace(/,/g, "") + '&npv4=&npi=gm' + GM.urls.get_tracking_page() + 'unknown' + params.wrappingIDList.replace(/,/g, "");
            if (params.trackingString) {
                tracking = params.trackingString;
            }
            purchaseURL = GM.urls.get_url('cart') + "?wrapID=" + params.wrappingIDList + tracking;
        }
        if (typeof params.couponCode !== 'undefined' && params.couponCode) {
            purchaseURL += '&discount=' + params.couponCode;
        }
        if (purchaseURL == null) {
            GM.overlay.open("error", {
                wrappingID: wrappingID,
                errorCode: 1403
            });
            return;
        }
        var store_iframe_wrapper = $('<div>').attr("id", "spinning_loader_store").addClass("icon_spinning").css({
            "background-position": "center",
            "height": "690px",
            "width": "980px",
            "margin": "5px",
            "border": "0"
        });
        var store_iframe = $("<iframe>").attr("id", "gm_unified_store").attr("name", "gm_unified_store").attr("src", purchaseURL).addClass("hide").css({
            "height": "100%",
            "width": "100%",
            "border": "0"
        });
        var html_content = $('<div>').append(store_iframe_wrapper.append(store_iframe).clone()).html();
        GM.overlay.open('store', {
            html: html_content
        });
        $('#gm_unified_store').one('load', function () {
            $('#gm_unified_store').fadeIn('fast');
        }).closest('.simplemodal-wrap').css('overflow', 'hidden');
        return false;
    },
    error: function (params) {
        var obj = {},
            wrappingID = params.wrappingID,
            replace = params.replace || [],
            headerReplacement = GM.text['err_whoops'],
            code = null;
        if (wrappingID && GM.data.installedGames[wrappingID] && GM.data.installedGames[wrappingID].gameState.errorCode && GM.data.installedGames[wrappingID].gameState.errorCode > 0) {
            code = GM.data.installedGames[wrappingID].gameState.errorCode;
        } else if (params.errorCode) {
            code = params.errorCode;
        } else if (GM.data.errorCode) {
            code = GM.data.errorCode;
        }
        code = code.toString();
        GM.util.updateUIBasedOnError(code);
        if (params.headerText) {
            headerReplacement = params.headerText;
        } else if (GM.text['err_' + code + '_header']) {
            headerReplacement = GM.text['err_' + code + '_header'];
        }
        console.log(GM.text['err_' + code + '_msg']);
        if (code && GM.text['err_' + code + '_msg']) {
            obj = {
                is_ed: false,
                h2: headerReplacement,
                msg: GM.render.get_error_text(code, replace, wrappingID, (code === '764')),
                "code": GM.render.str_replace('[CODE]', code, GM.text.err_code_o),
                btn: [{
                    color: 'blue',
                    size: 'med',
                    type: 'plain overlay_close',
                    text: GM.text.o_ok
                }]
            };
            if (GM.text['err_' + code + '_prompt']) {
                obj.err_prompt = GM.text['err_' + code + '_prompt'];
            }
            if (GM.text['err_' + code + '_blue'] && GM.text['err_' + code + '_gray']) {
                obj.has_close_btn = false;
                obj.disable_easy_close = true;
                obj.btn = [{
                    color: 'gray',
                    size: 'med',
                    type: 'plain error_confirm',
                    text: GM.text['err_' + code + '_gray']
                }, {
                    color: 'blue',
                    size: 'med',
                    type: 'plain overlay_close',
                    text: GM.text['err_' + code + '_blue']
                }];
            }
        } else {
            var message = GM.render.get_error_text(3, [], null, false);
            message = GM.render.str_replace('[ACTUALCODE]', GM.render.str_replace('[CODE]', code, GM.text.err_code_o), message);
            obj = {
                is_ed: false,
                h2: headerReplacement,
                msg: message,
                "code": GM.render.str_replace('[CODE]', code, GM.text.err_code_o),
                btn: [{
                    color: 'blue',
                    size: 'med',
                    type: 'plain overlay_close',
                    text: GM.text.o_ok
                }]
            };
        }
        return obj;
    },
    general: function (params) {
        var btn_type = 'plain overlay_close';
        if (params.btn_type) {
            btn_type = 'plain ' + params.btn_type
        }
        var btn_text = GM.text.o_ok;
        if (params.btn_text) {
            btn_text = params.btn_text;
        }
        var obj = {
            id: "general",
            is_ed: false,
            h2: "header",
            msg: "message",
            err_prompt: "prompt",
            btn: [{
                size: 'sm',
                color: 'blue',
                text: btn_text,
                type: btn_type
            }]
        };
        obj = $.extend({}, obj, params);
        return obj;
    },
    find_games: function () {
        var obj = {
            is_ed: false,
            has_close_btn: false,
            h2: GM.text.o_find_h2,
            look: GM.text.o_find_look,
            locations: GM.data.options.gameInstallPathHistory,
            buttons: [{
                color: 'blue',
                size: 'sm',
                text: GM.text.o_find_search,
                type: 'plain find_games'
            }, {
                color: 'gray',
                size: 'sm',
                text: GM.text.o_cancel,
                type: 'plain overlay_open',
                overlayID: 'options',
                overlayTab: 'dl'
            }]
        };
        return obj;
    },
    finding_games: {
        wrapper_class: 'o_waiting',
        has_close_btn: false,
        content_header: false,
        finding: GM.text.o_finding_h3
    },
    found_games: function (params) {
        var obj = {};
        if ($.ct(params.gameCount, 'number')) {
            var n = params.gameCount;
            obj = {
                content_header: false,
                has_close_btn: false,
                found: GM.render.str_replace('[NUMBER]', n, GM.text.o_found_games),
                ok: {
                    size: 'sm',
                    color: 'blue',
                    text: GM.text.o_ok,
                    type: 'plain overlay_close'
                }
            };
            if (n > 0) {
                GM.game_rows.reset_sorted_lists();
                obj.appear = GM.text.o_found_appear;
            }
        }
        return obj;
    },
    gm_exit: {
        has_close_btn: false,
        content_header: false,
        closing: GM.text.o_gm_exit_h3,
        txt: GM.text.o_gm_exit_txt
    },
    gm_start: {
        has_close_btn: false,
        content_header: false,
        starting: GM.text.o_gm_start_h3,
        txt: GM.text.o_gm_start_txt
    },
    gm_update_required: {
        is_ed: false,
        has_close_btn: false,
        h2: GM.text.o_upreq_h2,
        text: GM.text.o_upreq_text,
        confirm: GM.text.o_upreq_confirm,
        btns: [{
            size: 'med',
            color: 'gray',
            text: GM.text.o_no,
            type: 'plain overlay_close'
        }, {
            size: 'med',
            color: 'blue',
            text: GM.text.o_yes,
            type: 'plain overlay_open',
            overlayID: 'options',
            overlayTab: 'about'
        }]
    },
    help: function () {
        var obj = {
            has_close_text: true,
            h2: GM.text.o_help_h2,
            help: [{
                icon: 'help',
                a: GM.text.o_help_need_help,
                txt: GM.text.o_help_visit,
                href: GM.urls.get_url('help')
            }, {
                icon: 'info',
                a: GM.text.o_help_learn,
                txt: GM.text.o_help_tour,
                tour_link: true
            }]
        };
        return obj;
    },
    loading_games: {
        wrapper_class: 'o_waiting',
        has_close_btn: false,
        content_header: false,
        loading: GM.text.o_loading_h3
    },
    login: function (params) {
        if (!GM.util.checkIfUserOnline(true))
            return false;
        var obj = {
            h2: GM.text.o_login_h2,
            is_ed: false,
            secure: GM.text.o_login_secure,
            err: params.error_text,
            email: GM.text.o_login_email,
            password: GM.text.o_login_password,
            password2: GM.text.o_signup_password2,
            newToBigFish: GM.text.o_signin_new,
            alreadyHave: GM.text.o_signin_already,
            tos: GM.render.str_replace(['<a1>', '<a2>', '[BUTTONNAME]'], ['<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'terms') + '" target="_blank">', '<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'privacy') + '" target="_blank">', GM.text.o_signup_create], GM.text.o_generic_tos),
            respect: GM.text.o_generic_respect,
            forgotTitle: GM.text.o_forgot_forgotTitle,
            forgotText: GM.render.str_replace('<a>', '<a href="' + GM.urls.get_url('passwordHelp') + '" target="_blank">', GM.text.o_forgot_forgotText),
            btn: {
                size: 'med',
                color: 'blue',
                text: GM.text.o_login_btn,
                type: 'plain btn_login'
            },
            backbtn: {
                size: 'med',
                color: 'blue',
                text: GM.text.o_forgot_back,
                type: 'plain btn_login'
            },
            signupbtn: {
                size: 'med',
                color: 'blue',
                text: GM.text.o_signup_create,
                type: 'plain btn_login'
            },
            forgotbtn: {
                size: 'med',
                color: 'blue',
                text: GM.text.o_forgot_next,
                type: 'plain btn_login'
            },
            persistent: GM.text.o_login_persistent,
            no_account: GM.text.o_login_no_account,
            forgot: GM.text.o_login_forgot_pass,
            site: GM.data.userData.siteID,
            newsletter: GM.text.o_signup_newsletter,
            mustAccept: GM.render.str_replace(['<a1>', '<a2>'], ['<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'terms') + '" target="_blank">', '<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'privacy') + '" target="_blank">'], GM.text.o_signup_must_accept),
        };
        return obj;
    },
    options: function (params) {
        var o = GM.data.options;
        var tab = (params.overlayTab && $.inArray(params.overlayTab, ['gen', 'dl', 'adv', 'ext', 'about']) > -1 ? params.overlayTab : 'gen');
        var is_pc = (GM.data.userData.platform === 'windows');
        var update_class = 'hide';
        var check_hide = true;
        var install_hide = true;
        switch (o.gmUpdateAvailable) {
            case 'yes':
                update_class = 'update_found';
                install_hide = false;
                break;
            case 'no':
                update_class = 'current_gm';
                break;
            case 'downloading':
                update_class = 'downloading_gm';
                $('.check_gm_updates_install').hide();
                break;
            case 'installing':
                update_class = 'installing_gm';
                break;
            case 'applied':
                update_class = 'update_applied';
                break;
            default:
                check_hide = false;
                break;
        }
        var ops = {
            h2: GM.text.o_options_h2,
            version: GM.render.str_replace('[VERSION]', GM.data.userData.version, GM.text.o_options_version),
            checking: GM.text.o_options_checking,
            is_ed: false,
            has_close_btn: false,
            tab: tab,
            tabs: [{
                tab: GM.text.o_options_gen_tab,
                related: 'gen',
                active: (tab === 'gen'),
                show_tab: true
            }, {
                tab: GM.text.o_options_dl_tab,
                related: 'dl',
                active: (tab === 'dl'),
                show_tab: true,
                border: true
            }, {
                tab: GM.text.o_options_adv_tab,
                related: 'adv',
                active: (tab === 'adv'),
                show_tab: is_pc,
                border: true
            }, {
                tab: GM.text.o_options_about_tab,
                related: 'about',
                active: (tab === 'about'),
                show_tab: true,
                border: true
            }],
            gen: [{
                id: 'sound',
                h4: GM.text.o_options_gen_sound_h4,
                checkbox: 'ops_sound',
                checked: o.soundEnabled,
                label: GM.text.o_options_gen_sound_label
            }, {
                id: 'exit',
                h4: GM.text.o_options_gen_exit_h4,
                checkbox: 'ops_exit',
                checked: o.quickExit,
                label: GM.text.o_options_gen_exit_label
            }, {
                id: 'video',
                h4: GM.text.o_options_gen_video_h4,
                checkbox: 'ops_video',
                checked: o.showGameVideos,
                label: GM.text.o_options_gen_video_label
            }, {
                id: 'imp',
                h4: GM.text.o_options_gen_imp_h4,
                checkbox: 'ops_imp',
                checked: o.eventLoggingActive,
                label: GM.render.str_replace('<a>', '<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'privacy') + '" target="_blank">', GM.text.o_options_gen_imp_label)
            }],
            updates_h4: GM.text.o_options_dl_updates,
            updates_when: GM.text.o_options_dl_choose_updates,
            auto: GM.text.o_options_dl_auto,
            auto_ck: o.autoGameUpdates,
            manual: GM.text.o_options_dl_manual,
            manual_ck: !o.autoGameUpdates,
            check: {
                size: 'sm',
                color: 'gray',
                text: GM.text.o_options_dl_check,
                type: 'plain check_game_updates' + (o.autoGameUpdates ? ' hide' : '')
            },
            install: {
                size: 'sm',
                color: 'gray',
                text: GM.text.o_options_dl_install,
                type: 'plain check_game_updates_install overlay_close sort_games queue_update hide'
            },
            find_h4: GM.text.o_options_dl_find,
            find_search: GM.text.o_options_dl_search,
            see_help: GM.render.str_replace('<a>', '<a href="' + GM.urls.get_url('help') + '?rn=search" target="_blank">', GM.text.o_options_dl_help),
            start: {
                size: 'sm',
                color: 'gray',
                text: GM.text.o_options_dl_start,
                type: 'plain o_options_start overlay_open'
            },
            install_h4: GM.text.o_options_dl_loc,
            install_loc: o.gameInstallPathHistory[0],
            install_choose: GM.text.o_options_dl_choose_loc,
            wont_move: GM.text.o_options_dl_wont_move,
            browse: {
                size: 'sm',
                color: 'gray',
                text: GM.text.o_browse,
                type: 'plain o_options_browse browse_for_games'
            },
            adv_h4: GM.text.o_options_adv_network,
            adv_default: GM.text.o_options_adv_default,
            adv_conn_def: !o.useAlternateConnectionMethod,
            adv_alt: GM.text.o_options_adv_alt,
            adv_conn_alt: o.useAlternateConnectionMethod,
            adv_info: GM.render.str_replace('<a>', '<a href="' + GM.urls.get_url('help') + '?rn=network" target="_blank">', GM.text.o_options_adv_info),
            about_h4: GM.text.o_options_about_gm,
            about_version: GM.render.str_replace('[VERSION]', GM.data.userData.version, GM.text.o_options_about_version),
            update_class: update_class,
            found: GM.text.o_options_about_found,
            current: GM.text.o_options_about_latest,
            downloading: GM.text.o_options_about_downloading,
            installing: GM.text.o_options_about_installing,
            restart: GM.text.o_options_about_installing_restart,
            complete: GM.text.o_options_about_complete,
            check_updates: [{
                size: 'sm',
                color: 'gray',
                text: GM.text.o_options_about_updates,
                type: 'plain check_gm_updates' + (check_hide ? ' hide' : '')
            }, {
                size: 'sm',
                color: 'gray',
                text: GM.text.o_options_about_get_update,
                type: 'plain check_gm_updates_install' + (install_hide ? ' hide' : '')
            }],
            copyright: GM.render.str_replace('[YEAR]', new Date().getFullYear(), GM.text.o_options_about_copyright),
            btns: [{
                size: 'med',
                color: 'blue',
                text: GM.text.o_ok,
                type: 'plain o_options_submit'
            }]
        };
        return ops;
    },
    purchasing: {
        wrapper_class: 'o_waiting',
        has_close_btn: false,
        content_header: false,
        purchasing: GM.text.o_purchasing_h3
    },
    sample: function (params) {
        var obj = {};
        if ($.ct(params.wrappingID, 'string') && GM.data.installedGames[params.wrappingID]) {
            obj = {
                is_ed: false,
                has_close_text: true,
                h2: GM.text.o_sample_h2,
                confirm: GM.render.str_replace('[GAME]', GM.data.installedGames[params.wrappingID].name, GM.text.o_sample_confirm),
                buttons: [{
                    size: 'med',
                    color: 'gray',
                    text: GM.text.o_no,
                    type: 'plain overlay_close'
                }, {
                    size: 'med',
                    color: 'blue',
                    text: GM.text.o_yes,
                    type: 'plain uninstall_confirm',
                    wrapID: params.wrappingID
                }]
            };
        }
        return obj;
    },
    show_download_pause: function () {
        GM.deferredObjects.overlayCloseDeferred = $.Deferred();
        GM.overlay.open('general', {
            id: 'downloadPause',
            h2: GM.text.paused_download_header,
            msg: GM.text.paused_download_text,
            err_prompt: GM.text.paused_download_hide,
            btn_type: "OKToPause"
        });
        GM.deferredObjects.overlayCloseDeferred.done(function (overlay) {
            GM.controller.event_to_native('pluginExecute', {
                pluginName: 'streamingPlugin',
                action: 'Event',
                params: JSON.stringify({
                    eventType: 101
                })
            });
            GM.render.draw_dl_queue();
            GM.deferredObjects.overlayCloseDeferred = $.Deferred();
        });
    },
    store: function (params) {
        if (GM.data.userData.isRetail) {
            return {};
        }
        var obj = {
            content_header: false,
            disable_easy_close: true,
            has_close_text: true
        };
        if (params.html) {
            obj.content = params.html;
        }
        return obj;
    },
    tour: {
        has_close_text: true,
        h2: GM.text.o_tour_h2,
        feedbackText: GM.text.o_tour_feedback_text,
        learnMoreText: GM.text.o_tour_learn_more_text,
        closeText: GM.text.close,
        tour: [{
            name: 'new',
            li: GM.text.o_tour_new_li,
            is_selected: true
        }, {
            name: 'play',
            li: GM.text.o_tour_play_li
        }, {
            name: 'organize',
            li: GM.text.o_tour_organize_li
        }, {
            name: 'discover',
            li: GM.text.o_tour_discover_li
        }],
        content: [{
            type: 'new',
            is_selected: true,
            h3: GM.text.o_tour_new_h3,
            dl: [{
                type: 'new_look',
                txt: GM.text.o_tour_new_look
            }, {
                type: 'resizable',
                txt: GM.text.o_tour_new_resize
            }, {
                type: 'collectors',
                txt: GM.text.o_tour_new_ce
            }, {
                type: 'gyb',
                txt: GM.text.o_tour_new_gyb
            }]
        }, {
            type: 'play',
            is_selected: false,
            h3: GM.text.o_tour_play_h3,
            txt: GM.text.o_tour_play_txt
        }, {
            type: 'organize',
            is_selected: false,
            h3: GM.text.o_tour_organize_h3,
            txt: GM.text.o_tour_organize_txt
        }, {
            type: 'discover',
            is_selected: false,
            h3: GM.text.o_tour_discover_h3,
            txt: GM.text.o_tour_discover_txt
        }]
    },
    uac_notification: function (params) {
        var obj = {};
        if (params.wrappingID && GM.data.installedGames[params.wrappingID] && (typeof GM.data.installedGames[params.wrappingID].installProgress === 'undefined' || GM.data.installedGames[params.wrappingID].installProgress === 0)) {
            var rn = {
                '1': 1838,
                '2': 1840,
                '4': 1841,
                '5': 1839,
                '6': 1842,
                '15': 1845,
                '16': 1847,
                '17': 1846,
                '18': 1844,
                '19': 1843
            };
            obj = {
                is_ed: true,
                has_close_btn: true,
                has_close_text: false,
                content_header: false,
                h2: GM.text.o_uac_accept_h2,
                txt: GM.text.o_uac_accept_txt
            };
            GM.data.userData.billboardsShown.push('uac_notification');
            GM.controller.event_to_native('setBillboardShown', {
                billboardID: 'uac_notification'
            });
        }
        return obj;
    },
    uninstall: function (params) {
        var obj = {};
        if ($.ct(params.wrappingID, 'string') && GM.data.installedGames[params.wrappingID]) {
            obj = {
                is_ed: false,
                has_close_text: true,
                h2: GM.text.o_uninstall_h2,
                game: GM.render.str_replace('[GAME]', GM.data.installedGames[params.wrappingID].name, GM.text.o_uninstall_game),
                confirm: GM.text.o_uninstall_confirm,
                buttons: [{
                    size: 'med',
                    color: 'gray',
                    text: GM.text.o_no,
                    type: 'plain overlay_close'
                }, {
                    size: 'med',
                    color: 'blue',
                    text: GM.text.o_yes,
                    type: 'plain uninstall_confirm',
                    wrapID: params.wrappingID
                }]
            };
        }
        return obj;
    },
    uninstalling: {
        wrapper_class: 'o_waiting',
        has_close_btn: false,
        content_header: false,
        text: GM.text.o_uninstalling_h3
    },
    wizard: function (parameters) {
        var is_mac = GM.data.userData.platform === 'mac';
        var is_default = ($.isEmptyObject(GM.data.userData.wizardFeatImage) || $.isEmptyObject(GM.data.userData.wizardSS1));
        var wizard_ops = this._get_wizard_options();
        obj = {
            title_text: is_default ? GM.text.o_wizard_3_h3 : GM.text.o_wizard_3_h3_specific,
            content_header: false,
            is_mac: is_mac,
            provide: GM.text.o_wizard_3_email,
            splash: GM.text.o_wizard_3_newsletter,
            splash_checked: wizard_ops.getDeals,
            email: wizard_ops.email,
            game_image: is_default ? '../images/m/overlay/wizard_redesign.png' : GM.config.URLS.CDNLocation + GM.data.userData.wizardSS1,
            game_icon: is_default ? '../images/m/overlay/bfg_logo_xlg.png' : GM.config.URLS.CDNLocation + GM.data.userData.wizardFeatImage,
            finish_button: GM.text.o_wizard_finish,
            o_wizard_3_required: GM.text.o_wizard_3_required,
            tos: GM.render.str_replace(['<a1>', '<a2>', '[BUTTONNAME]'], ['<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'terms') + '" target="_blank">', '<a href="' + GM.urls.get_site_url(GM.data.userData.siteID, 'privacy') + '" target="_blank">', GM.text.o_wizard_finish], GM.text.o_generic_tos),
            respect: GM.text.o_generic_respect,
            site: GM.data.userData.siteID,
        };
        return obj;
    },
    wizard_cancel: {
        content_header: false,
        has_close_btn: false,
        h2: GM.text.o_wizard_cancel_h2,
        text: GM.text.o_wizard_cancel_text,
        buttons: [{
            size: 'med',
            color: 'gray',
            text: GM.text.o_yes,
            type: 'plain overlay_close'
        }, {
            size: 'med',
            color: 'blue',
            text: GM.text.o_no,
            type: 'plain overlay_open',
            overlayID: 'wizard'
        }]
    },
    open: function (type, params) {
        GM.console.log('overlay.open', arguments);
        if ((GM.data.overlay) && (GM.data.overlay != 'gm_exit') && ($.inArray(GM.data.overlay, this._non_interruptible) > -1)) {
            return false;
        }
        GM.util.hideAllActivePlugins();
        if (typeof type === 'object' && typeof params === 'undefined') {
            params = type;
            type = 'general';
        }
        GM.profiler.start_timer('Overlay: ' + type);
        if (!this._events_set) {
            this._set_events();
        }
        this.close("openingAnotherOverlay", type);
        if (this[type]) {
            var obj = {};
            if (this[type]) {
                params = params || {};
                obj = (typeof this[type] === 'function' ? this[type](params) : this[type]);
            }
            if (!$.is_empty(obj)) {
                obj = $.extend({}, this.defaults, obj);
                obj.id = type;
                if (type === 'gm_start') {
                    GM.user_data.updateHeader();
                }
                var overlay = $('#tmpl_overlay').tmpl(obj);
                var ops = {};
                if ($.inArray(type, this._easy_close) > -1 && !obj.disable_easy_close) {
                    ops.overlayClose = true;
                    ops.onClose = GM.overlay.close;
                } else {
                    ops.escClose = false;
                }
                $(overlay).modal(ops);
            }
            GM.data.overlay = type;
            GM.controller.event_to_qa('overlay_open', {
                overlayID: type
            });
            if (GM.data.overlay) {
                GM.deferredObjects.overlayOpenDeferred.resolve(GM.data.overlay);
            }
        }
        GM.profiler.end_timer('Overlay: ' + type);
    },
    close: function (overlay_from_click, overlay_about_to_open) {
        GM.profiler.start_timer('Overlay close');
        var overlayID = GM.data.overlay;
        if (overlay_from_click === 'wizard') {
            this._get_wizard_options();
            GM.overlay.open('wizard_cancel');
            return false;
        }
        if (GM.data.overlay) {
            GM.deferredObjects.overlayCloseDeferred.resolve(GM.data.overlay);
            GM.deferredObjects.overlayCloseDeferred = $.Deferred();
        }
        if ((GM.data.overlay) && (GM.data.userData.sort) && (GM.data.userData.sort.page) && (GM.data.userData.sort.page.search(/ucgs_/) >= 0) && (overlay_from_click !== "openingAnotherOverlay")) {
            GM.plugins.showPlugin('streamingPlugin');
        }
        GM.data.overlay = null;
        $.modal.close();
        if (overlay_from_click === 'wizard_cancel') {
            if (GM.tracking) {
                GM.tracking.sendWizardEvent();
            }
            GM.controller.event_to_native('wizardCancel', {});
            GM.controller.event_to_qa('wizard_cancel', {});
            return false;
        } else if (overlayID === 'options' && GM.data.options) {
            if ($.inArray(GM.data.options.gmUpdateAvailable, ['downloading', 'installing']) > -1) {
                GM.controller.event_to_native('cancelGMUpdateInstall', {});
            }
        }
        GM.controller.event_to_qa('overlay_close', {});
        GM.profiler.end_timer('Overlay close');
        return false;
    },
    closeSpecific: function (overlay_to_close) {
        if (GM.data.overlay === overlay_to_close) {
            GM.overlay.close();
        }
    },
    _set_events: function () {
        $('#overlay .tab_control').live('click', function (e) {
            e.preventDefault();
            var related = $(this).attr('data-related');
            if (related) {
                $('.tab_control').removeClass('selected');
                $(this).addClass('selected');
                $('.tab_content').hide();
                $('#' + related).show();
            }
        });
        $('#o_tour_list li').live('click', function (e) {
            e.preventDefault();
            $('#o_tour_list li').removeClass('o_tour_selected');
            $(this).addClass('o_tour_selected');
            var related = $(this).attr('data-related');
            if (related) {
                $('.o_tour_content').hide();
                $('#' + related).show();
            }
        });
        $('.o_wizard_control').live('click', function (e) {
            if ($(this).hasClass('o_wizard_1')) {
                GM.overlay._wizard_tab = '1';
                GM.data.userData.wizardStep = 1;
                $('#o_wizard').removeClass('o_wizard_pg_2 o_wizard_pg_3').addClass('o_wizard_pg_1');
            } else if ($(this).hasClass('o_wizard_2')) {
                GM.overlay._wizard_tab = '2';
                GM.data.userData.wizardStep = 2;
                $('#o_wizard').removeClass('o_wizard_pg_1 o_wizard_pg_3').addClass('o_wizard_pg_2');
            } else if ($(this).hasClass('o_wizard_3')) {
                GM.overlay._wizard_tab = '3';
                GM.data.userData.wizardStep = 3;
                $('#o_wizard').removeClass('o_wizard_pg_1 o_wizard_pg_2').addClass('o_wizard_pg_3');
            } else if ($(this).hasClass('o_wizard_finish')) {
                GM.data.userData.wizardStep = 4;
                if (!GM.validator.is_valid_email($('#o_wizard_email').val())) {
                    $('#o_wizard_email').parent().addClass('error');
                    return false;
                }
                $('#o_wizard_email').parent().removeClass('error');
                var wizard_ops = GM.overlay._get_wizard_options();
                GM.overlay.open('gm_start');
                if (GM.tracking) {
                    GM.tracking.sendWizardEvent();
                }
                setTimeout(function () {
                    GM.controller.event_to_native('wizardFinish', wizard_ops);
                }, 200);
            }
            return false;
        });
        $('#o_gm_update_required .overlay_open').live('click', function (e) {
            e.preventDefault();
            GM.controller.event_to_native('installGMUpdate', {});
        });
        this._options_events();
        this._events_set = true;
    },
    _get_wizard_options: function () {
        var wizard_ops = this._wizard_ops;
        wizard_ops.gameInstallPathHistory = GM.data.options.gameInstallPathHistory;
        if (GM.data.overlay === 'wizard') {
            wizard_ops.createDesktopShortcut = true;
            wizard_ops.createQuickLaunchShortcut = false;
            wizard_ops.email = $('#o_wizard_email').val();
            if (GM.data.userData.siteID == 5 || GM.data.userData.siteID == 2 || GM.data.userData.siteID == 6) {
                wizard_ops.getDeals = ($('#o_wizard_splash').prop('checked'));
            } else {
                if (GM.data.userData.siteID == 1) {
                    wizard_ops.getDeals = true;
                } else {
                    wizard_ops.getDeals = false;
                }
            }
            GM.data.userData.WizardOps = wizard_ops;
        }
        this._wizard_ops = wizard_ops;
        return this._wizard_ops;
    },
    _options_events: function () {
        $('#o_options input').live('change', GM.overlay._options_submit);
        $('#ops_updates_auto, #ops_updates_man').live('change', function () {
            if ($('#o_options_dl').find('input[type=radio]:checked').attr('id') == 'ops_updates_auto') {
                $('.check_game_updates').hide();
                $('.ops_checking').hide();
                $('#ops_update_man_result').hide();
                $('.check_game_updates_install').hide();
                $('#ops_game_update_error_wrapper').hide();
            } else {
                $('.check_game_updates').show();
            }
        });
        $('.o_options_submit, .o_options_start').live('click', GM.overlay._options_submit);
    },
    _options_submit: function () {
        var ops = GM.data.options;
        ops.soundEnabled = ($('#ops_sound').prop('checked'));
        ops.quickExit = ($('#ops_exit').prop('checked'));
        ops.showGameVideos = ($('#ops_video').prop('checked'));
        ops.eventLoggingActive = ($('#ops_imp').prop('checked'));
        ops.autoGameUpdates = ($('#ops_updates_auto').prop('checked'));
        ops.useAlternateConnectionMethod = (!$('#ops_connection_default').prop('checked'));
        GM.controller.event_to_native('setOptions', ops);
        GM.data.options = ops;
        if ($(this).hasClass('o_options_start')) {
            GM.overlay.open('find_games');
        } else if ($(this).hasClass('o_options_submit')) {
            GM.overlay.close();
        }
    },
    activate: function (params) {
        var wrappingID = params.wrappingID;
        var purchaseURL = null;
        if (wrappingID && GM.data.installedGames[wrappingID]) {
            var p = GM.data.installedGames[wrappingID];
            siteID = p.siteID;
            credits = GM.prices.get_credits(siteID, wrappingID, p.isCollectors);
            purchaseURL = GM.urls.get_activate_url(p.siteID, wrappingID, false);
            is_demo = (p.trialType === 1);
        } else {
            $.each(GM.data.upsell, function (i, v) {
                if (v.wrappingID === wrappingID) {
                    siteID = v.siteID;
                    credits = GM.prices.get_credits(siteID, wrappingID, v.isCollectors);
                    is_upsell = true;
                    purchaseURL = GM.urls.get_activate_url(v.siteID, wrappingID, true);
                    return false;
                }
                return true;
            });
        }
        $.bfg.bus.startUnifiedPurchaseFlow(purchaseURL);
    }
};
var GM = GM || {};
GM.validator = {
    is_valid_email: function (email) {
        if (!$.ct(email, 'string')) {
            return false;
        }
        var at = email.indexOf('@');
        if (at > 0) {
            var domain = email.indexOf('.', at + 2);
            if (domain > 0 && (domain + 1 < email.length)) {
                return true;
            }
        }
        return false;
    },
    is_valid_password: function (pwd) {
        if (!$.ct(pwd, 'string')) {
            return false;
        }
        if (pwd.length >= 5 && pwd.length <= 12) {
            return true;
        }
        return false;
    }
};
var GM = GM || {};
GM.user_data = {
    update_user_data: function (params) {
        var updateReason = (typeof (params.updateReason) != 'undefined') ? params.updateReason : null;
        var source = (typeof (GM.data.userData.loginSource) != 'undefined') ? GM.data.userData.loginSource : null;
        GM.data.userData = $.extend({}, GM.data.userData, params);
        if (!GM.data.userData.sort) {
            GM.data.userData.sort = {};
        } else if (typeof GM.data.userData.sort !== 'object') {
            try {
                GM.data.userData.sort = JSON.parse(GM.data.userData.sort);
            } catch (error) {
                GM.data.userData.sort = {};
            }
        }
        delete GM.data.userData['updateReason'];
        delete GM.data.userData['loginSource'];
        GM.user_data.updateHeader();
        switch (updateReason) {
            case 'login':
                GM.user_data.updateAfterAuth(source);
                if (GM.tracking) {
                    GM.tracking.sendPageViewEvent({
                        "page": "LOGIN"
                    });
                }
                break;
            case 'logout':
                GM.user_data.updateAfterLogout();
                if (GM.tracking) {
                    GM.tracking.sendPageViewEvent({
                        "page": "LOGOUT"
                    });
                }
                GM.util.refreshBFGSess();
                break;
            case 'refresh':
                GM.user_data.updateStreamingUser();
                break;
            case 'startup':
                if (!GM.data.userData.email || !GM.data.userData.usertoken) {
                    GM.controller.event_to_native('logout', {});
                } else {
                    GM.util.refreshBFGSess();
                }
        }
    },
    updateHeader: function () {
        $('body').removeClass().addClass(GM.data.userData.platform);
        if (!GM.data.userData.isAdmin) {
            $('body').addClass('hide_non_admin');
            $('.btn_buy').addClass('btn_disabled');
            $('#container').removeClass('content_with_gybb');
        }
        if (GM.data.userData.isRetail) {
            $('body').addClass('hide_retail');
            $('#container').removeClass('content_with_gybb');
        }
        if (GM.data.userData.isLoggedIn) {
            if (GM.data.userData.email) {
                $('.email').html(GM.data.userData.email);
            }
            $('.sign_out').show();
            $('.sign_in').hide();
        } else {
            $('.email').html('&nbsp;');
            $('.sign_out').hide();
            $('.sign_in').show();
        }
    },
    updateStreamingUser: function (callback) {
        return;
    },
    updateAfterAuth: function (source) {
        source = source || null;
        var currentPage = GM.data.userData.sort.page;
        var callback = function () {
            if ((currentPage.search(/ucgs_/) >= 0) && (source !== 'ucgs')) {
                var streamingOptions = {
                    "page": "ucgs_"
                };
                if (GM.data.overlay) {
                    var used = (GM.deferredObjects.overlayCloseDeferred.isResolved() || GM.deferredObjects.overlayCloseDeferred.isRejected());
                    if (used || typeof (GM.deferredObjects.overlayCloseDeferred) != 'object') {
                        GM.deferredObjects.overlayCloseDeferred = $.Deferred();
                    }
                    GM.deferredObjects.overlayCloseDeferred.done(function (overlay) {
                        if ((overlay === 'buy') || (overlay === 'login')) {
                            GM.render.draw_streaming(null, streamingOptions);
                        }
                    });
                } else {
                    GM.render.draw_streaming(null, streamingOptions);
                }
            }
        };
    },
    updateAfterLogout: function () {
        if (GM.data.userData.gameLibrary) {
            GM.data.userData.gameLibrary = null;
        }
        if (GM.data.userData.sort.page == "purchase_history_page") {
            $(".sort_az").click();
        }
        GM.plugins.setData('streamingPlugin', 'recentlyplayed', []);
        GM.user_data.updateAfterAuth();
    }
};
var GM = GM || {};
GM.clicks = {
    _key_codes: {
        65: 'a',
        66: 'b',
        67: 'c',
        68: 'd',
        69: 'e',
        70: 'f',
        71: 'g',
        72: 'h',
        73: 'i',
        74: 'j',
        75: 'k',
        76: 'l',
        77: 'm',
        78: 'n',
        79: 'o',
        80: 'p',
        81: 'q',
        82: 'r',
        83: 's',
        84: 't',
        85: 'u',
        86: 'v',
        87: 'w',
        88: 'x',
        89: 'y',
        90: 'z'
    },
    init: function () {
        this._disable_text_selection();
        $('.native-command').live('click', function () {
            var $self = $(this),
                data = $self.data();
            if ($self.val()) {
                data.value = $self.val();
            }
            if (data.commandType == 'js') {
                GM.controller.event_to_js(data.command, data);
            } else {
                GM.controller.event_to_native(data.command, data);
            }
        });
        $('.plain-header').live('click', function () {
            e.stopPropogation();
            e.preventDefault();
        });
        $('#left_nav_downloads_list').live('click', function () {
            if ($(this).hasClass('.plain-header')) {
                return;
            }
            GM.plugins.showPlugin('streamingPlugin', false);
            if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
                GM.plugins.stopStream();
            }
            GM.render.draw_left_nav();
        });
        $('#content').delegate('.btn_play', 'click', function (e) {
            e.preventDefault();
            if (!$(this).hasClass('btn_disabled')) {
                GM.clicks.play_click(this);
            }
        });
        $('#container').delegate('.btn_buy', 'click', function (e) {
            e.preventDefault();
            var wrapID = ($(this).attr('data-wrapID') || $(this).closest('.gm_row').attr('id'));
            if ($(this).closest('.gyb').size() > 0) {
                GM.gyb.try_game(wrapID, this, false);
            }
            var buyPayload = {};
            if (wrapID) {
                buyPayload.wrappingID = wrapID;
            }
            if ($(this).attr('data-giftID')) {
                buyPayload.giftID = $(this).attr('data-giftID');
            }
            if ($(this).attr('data-couponCode')) {
                buyPayload.couponCode = $(this).attr('data-couponCode');
            }
            if ($(this).attr('data-wrappingIDList')) {
                buyPayload.wrappingIDList = $(this).attr('data-wrappingIDList');
            }
            if ($(this).attr('data-trackingString')) {
                buyPayload.trackingString = $(this).attr('data-trackingString');
            }
            if (!$(this).hasClass('btn_disabled')) {
                GM.overlay.open('buy', buyPayload);
            }
        });
        $('#content').delegate('.btn_pause', 'click', function (e) {
            e.preventDefault();
            if ($(this).closest('.gm_row')) {
                GM.controller.event_to_native('pauseGameDownload', {
                    wrappingID: $(this).closest('.gm_row').attr('id')
                });
            }
        });
        $('#content').delegate('.resume_download', 'click', function (e) {
            e.preventDefault();
            if ($(this).closest('.gm_row')) {
                GM.controller.event_to_native('downloadGame', {
                    wrappingID: $(this).closest('.gm_row').attr('id')
                });
            }
        });
        $('.install_game').live('click', function (e) {
            e.preventDefault();
            if ($(this).closest('.gm_row')) {
                GM.controller.event_to_native('installGame', {
                    wrappingID: $(this).closest('.gm_row').attr('id')
                });
            }
        });
        $('.btn_download').live('click', function (e) {
            e.preventDefault();
            var buttonSourceID = $(this).attr('data-source');
            if (buttonSourceID && buttonSourceID.toLowerCase().indexOf("convert") > -1) {
                buttonSourceID = GM.data.userData.sort.page;
            }
            var wrapID = $(this).attr('data-wrapID');
            var forPurchase = false;
            if ($(this).attr('data-forPurchase')) {
                forPurchase = true;
            }
            if (wrapID) {
                if (!buttonSourceID) {
                    buttonSourceID = "NoButtonSourceGiven";
                }
                GM.tracking.sendGameDownloadInitEvent(wrapID, buttonSourceID);
                for (var i = 0; i < GM.data.upsell.length; i++) {
                    if (GM.data.upsell[i] == wrapID) {
                        GM.gyb.try_game(wrapID, GM.data.upsell[i], true);
                        return;
                    }
                }
                GM.controller.event_to_native('downloadNewGame', {
                    wrappingID: wrapID,
                    downloadFullVersion: forPurchase
                });
                GM.render.draw_dl_queue();
            }
        });
        $('.btn_reactivate').live('click', function (e) {
            var wrapID = $(this).attr('data-wrapID');
            console.log("reactivate click", wrapID);
            if (wrapID) {
                GM.util.activateSingleGame(wrapID);
            }
        });
        $('.use_credit').live('click', function (e) {
            e.preventDefault();
            var wrapID = $(this).attr('data-wrapID');
            if (wrapID) {
                GM.controller.event_to_native('useCredit', {
                    wrappingID: wrapID
                });
            }
        });
        $('#overlay .OKToNotLogOut').live('click', function (e) {
            e.preventDefault();
            GM.overlay.close();
        });
        $('#logOutConfirmationLink').live('click', function (e) {
            e.preventDefault();
            GM.sallig.logout();
            GM.overlay.close();
        });
        $('.sign_in a').live('click', function (e) {
            e.preventDefault();
            var $self = $(this);
            setTimeout(function () {
                var allow = ($self.closest('.disabled').size() === 0) && GM.util.checkIfUserOnline(true);
                if (allow) {
                    GM.deferredObjects.signInDeferred = $.Deferred();
                    GM.deferredObjects.overlayOpenDeferred = $.Deferred();
                    GM.overlay.open('login', {});
                    GM.deferredObjects.overlayOpenDeferred.done(function (whichOverlay) {
                        if (whichOverlay == "login") {
                            setTimeout(function () {
                                $('#o_login_email').focus();
                            }, 500);
                            GM.deferredObjects.overlayOpenDeferred = $.Deferred();
                        }
                    });
                    $('#simplemodal-container').css("top", "100px");
                }
            }, 250);
        });
        $('.sign_out a').live('click', function (e) {
            e.preventDefault();
            GM.util.checkIfUserOnline(true)
            if (!GM.data.isUserOnline) {
                return
            }
							  
/*
            if (GM.data.userData.casino && GM.data.userData.casino.active) {
                GM.overlay.open('general', {
                    id: 'CasinoLogoutWarning',
                    err_prompt: '',
                    h2: "Sign Out",
                    msg: "You are signed into a game that is currently running. Please close that game to completely sign out.",
                    btn_type: "",
                    btn_text: GM.text.ok
                });
            }
 */
            var $self = $(this);
            setTimeout(function () {
                if ($self.closest('.disabled').size() === 0) {
                    GM.sallig.logout();
                }
            }, 250);
        });
        $('#content').delegate('.gm_row .btn_trash', 'click', function (e) {
            e.preventDefault();
            if ($(this).attr('data-wrapID')) {
                GM.overlay.open('uninstall', {
                    wrappingID: $(this).attr('data-wrapID')
                });
            }
        });
        $('#content').delegate('.gm_row .btn_pseudoTrash', 'click', function (e) {
            e.preventDefault();
            if ($(this).attr('data-wrapID')) {
                GM.pseudoGameUtils.removeGame($(this).attr('data-wrapID'));
            }
        });
        $('#content').delegate('.gm_row .btn_remove', 'click', function (e) {
            e.preventDefault();
            var wrapID = $(this).attr('data-wrapID');
            if (wrapID) {
                if ($(this).hasClass('btn_sample')) {
                    GM.overlay.open('sample', {
                        wrappingID: wrapID
                    });
                } else {
                    GM.controller.event_to_native('uninstallGame', {
                        wrappingID: wrapID
                    });
                    if (GM.tracking) {
                        GM.tracking.sendGameUninstallEvent(wrapID);
                    }
                }
            }
        });
        $('.uninstall_confirm').live('click', function (e) {
            GM.overlay.close();
            var wrapID = $(this).attr('data-wrapID');
            if (wrapID) {
                GM.controller.event_to_native('uninstallGame', {
                    wrappingID: wrapID
                });
                if (GM.tracking) {
                    GM.tracking.sendGameUninstallEvent(wrapID);
                }
            }
        });
        $('.sort_games').live('click', function (e) {
            e.preventDefault();
            if (!$(this).hasClass('sort_active')) {
                GM.clicks._sort_click(this);
            }
        });
        $('#sort_games_selector').live('change', function (e) {
            e.preventDefault();
            GM.clicks._sort_change($(this).val());
        });
        $('#purchase_sort_selector').live('change', function (e) {
            e.preventDefault();
            GM.render.draw_purchase_history_page($(this).val());
        });
        $('.instant-games').live('click', function (e) {
            var $self = $(this),
                timeout = 0;
            if ($self.hasClass('sort_active')) {
                return;
            }
            if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
                timeout += 4000;
                GM.plugins.stopStream();
                $('#left_nav_streaming_list').addClass('disabled');
            }
            setTimeout(function () {
                $('#left_nav_streaming_list').removeClass('disabled');
                GM.render.draw_streaming($self.data('page'), {
                    "page": $self.attr('id')
                });
            }, timeout);
        });
        $('.gm_update .icon_update').live('click', function (e) {
            e.preventDefault();
            $('#left_nav .queue_update').trigger('click');
        });
        $('.gyb_close').live('click', function (e) {
            e.preventDefault();
            GM.gyb.remove_game($(this).closest('.gyb').attr('id'));
        });
        $('.btn_checkbox').live('click', function (e) {
            e.preventDefault();
            $(this).toggleClass('checked');
        });
        $('#update_queue .btn_checkbox').live('click', function (e) {
            e.preventDefault();
            GM.updates.update_btn(this);
        });
        $('.update_close').live('click', function (e) {
            e.preventDefault();
            GM.updates.remove_update(this);
        });
        $('#update_install .btn').live('click', function (e) {
            e.preventDefault();
            GM.updates.install();
        });
        $('.overlay_open').live('click', function (e) {
            e.preventDefault();
            var type = $(this).attr('data-overlay');
            if (type) {
                var params = {};
                if ($(this).attr('data-overlayTab')) {
                    params.overlayTab = $(this).attr('data-overlayTab');
                }
                GM.overlay.open(type, params);
            } else if ($(this).closest('[data-ad_type]').size() > 0) {
                var ad_type = $(this).closest('[data-ad_type]').attr('data-ad_type');
                GM.overlay.open('ad', {
                    adType: ad_type
                });
            }
        });
        $('.overlay_close').live('click', function (e) {
            if (GM.data.overlay == 'error') {
                if (GM.data.errorCode == 905) {
                    GM.controller.event_to_native('clientShutdownCancellation', {});
                }
            }
            if (GM.data.overlay === 'buy') {
                if (!$(this).attr('href')) {
                    GM.gyb.cancel_buy();
                }
            } else {
                e.preventDefault();
            }
            if (GM.data.overlay === 'login' && GM.controller._pending_callback) {
                GM.controller._pending_callback = null;
            }
            GM.overlay.close(GM.data.overlay);
        });
        $('#o_login_signup').live('click', function (e) {
            $('#o_login_section').hide();
            $('#o_forgot_section').hide();
            $('#o_login_errors').hide();
            $('#o_signup_section').show();
            $('#o_login_selection').show();
            $('#o_signup_email').focus();
        });
        $('#o_login_signin').live('click', function (e) {
            $('#o_signup_section').hide();
            $('#o_forgot_section').hide();
            $('#o_login_errors').hide();
            $('#o_login_section').show();
            $('#o_login_selection').show();
            $('#o_login_email').focus();
        });
        $('.o_forgot_password').live('click', function (e) {
            e.preventDefault();
            if ($('#o_login_email').val()) {
                $('#o_forgot_email').val($('#o_login_email').val());
            }
            $('#o_login_section').hide();
            $('#o_login_selection').hide();
            $('#o_signup_section').hide();
            $('#o_login_errors').hide();
            $('#o_forgot_section').show();
            $('#o_forgot_email').focus();
        });
        $('#o_forgot_back .btn').live('click', function (e) {
            e.preventDefault();
            GM.deferredObjects.overlayOpenDeferred = $.Deferred();
            GM.overlay.open('login', {});
            GM.deferredObjects.overlayOpenDeferred.done(function (whichOverlay) {
                if (whichOverlay == "login") {
                    setTimeout("$('#o_login_email').focus();", 500);
                    GM.deferredObjects.overlayOpenDeferred = $.Deferred();
                }
            });
        });
        $('#o_forgot_submit .btn').live('click', function (e) {
            e.preventDefault();
            $('#o_forgot_submit .btn_login').before('<span class="icon_spinning" id="temp_spinner" style="float:left"></span>');
            $('#o_forgot_submit .btn_login').css('visibility', 'hidden');
            GM.sallig.forgot($('#o_forgot_email').val());
        });
        $('#o_login_submit .btn').live('click', function (e) {
            e.preventDefault();
            $('#o_login_submit .btn_login').before('<span class="icon_spinning" id="temp_spinner" style="float:left"></span>');
            $('#o_login_submit .btn_login').css('visibility', 'hidden');
            GM.sallig.login($('#o_login_email').val(), $('#o_login_password').val(), $('#o_login_persistent').is(':checked'));
        });
        $('#o_signup_submit .btn').live('click', function (e) {
            e.preventDefault();
            $('#o_signup_submit .btn_login').before('<span class="icon_spinning" id="temp_spinner" style="float:left"></span>');
            $('#o_signup_submit .btn_login').css('visibility', 'hidden');
            GM.sallig.signup($('#o_signup_email').val(), $('#o_signup_password').val(), $('#o_signup_password2').val(), $('#o_signup_persistent').prop('checked'), $('#o_signup_newsletter').prop('checked'), $('#o_signup_must').prop('checked'));
        });
        $('.reactivate').live('click', function (e) {
            e.preventDefault();
            var wrapID = $(this).attr('data-wrapID');
            GM.util.activateSingleGame(wrapID);
        });
        $('.find_games').live('click', function (e) {
            e.preventDefault();
            GM.overlay.open('finding_games');
            setTimeout(function () {
                GM.controller.event_to_native('findGames', {});
            }, 200);
        });
        $('.browse_for_games').live('click', function (e) {
            e.preventDefault();
            var ops = {};
            if (GM.data.options.gameInstallPathHistory) {
                ops.selectedPath = GM.data.options.gameInstallPathHistory[0];
            }
            GM.controller.event_to_native('browseForGameInstallationPath', ops);
        });
        $('.check_game_updates').live('click', function (e) {
            e.preventDefault();
            $('.checking_game_updates').show();
            $('.check_game_updates').hide();
            GM.controller.event_to_native('checkForGameUpdates', {});
        });
        $('.check_gm_updates').live('click', function (e) {
            e.preventDefault();
            $('#ops_gm_updates').addClass('checking_updates').show();
            $('.check_gm_updates').hide();
            GM.controller.event_to_native('checkForGMUpdates', {});
        });
        $('.check_gm_updates_install').live('click', function (e) {
            e.preventDefault();
            $(this).hide();
            GM.controller.event_to_native('installGMUpdate', {});
        });
        $('.gybb_prev').live('click', function (e) {
            e.preventDefault();
            if (!$(this).hasClass('gybb_disabled')) {
                GM.gybb.prev_view();
            }
        });
        $('.gybb_next').live('click', function (e) {
            e.preventDefault();
            if (!$(this).hasClass('gybb_disabled')) {
                GM.gybb.next_view();
            }
        });
        $('.error_confirm').live('click', function (e) {
            e.preventDefault();
            if (GM.data.errorCode == 905) {
                GM.util.shutGMDownForReals();
            }
        });
        $('#purchase_history_page').live('click', function (e) {
            if (GM.data.isUserOnline === undefined) {
                if (!GM.util.checkIfUserOnline(true)) {
                    return;
                }
            }
            if (GM.data.isUserOnline) {
                if (GM.data.userData.isLoggedIn) {
                    GM.render.draw_purchase_history_page();
                } else {
                    GM.deferredObjects.signInDeferred = $.Deferred();
                    GM.deferredObjects.signInDeferred.done(function (result) {
                        if (result) {
                            GM.render.draw_purchase_history_page();
                            GM.deferredObjects.signInDeferred = $.Deferred();
                        }
                    });
                    GM.deferredObjects.overlayCloseDeferred.done(function (overlay) {
                        if (overlay == 'login') {
                            $('#sort_az').removeClass('sort_active');
                        }
                    });
                    GM.overlay.open('login', {});
                }
            } else {
                GM.data.errorCode = 1400;
                GM.overlay.open('error', {});
            }
        });
        $('#content_header_purchase_refresh').live('click', function (e) {
            delete GM.data.userData.gameLibrary;
            $('#purchase_history_page').trigger('click');
        });
        $('#overlay .OKToPause').live('click', function (e) {
            GM.deferredObjects.overlayCloseDeferred = $.Deferred();
            $('#overlay .OKToPause').replaceWith('<span class="icon_spinning"></span>');
            if ($("#auto_download_pause").is(':checked')) {
                console.log("user clicked on hide auto download pause alert");
                GM.util.setDatabaseValue("persistent_db", "", "showDLP", "false");
                GM.persistedData.showDLP = false;
            }
            GM.util.pauseAllGameDownloads();
            GM.overlay.closeSpecific("general");
            GM.plugins.showPlugin('streamingPlugin');
            GM.controller.event_to_native('pluginExecute', {
                pluginName: 'streamingPlugin',
                action: 'Event',
                params: JSON.stringify({
                    eventType: 100
                })
            });
        });
        $('.to_js').live('click', function (e) {
            e.preventDefault();
            var action = $(this).attr('data-action');
            if (action) {
                var params = $(this).attr('data-params');
                if (params) {
                    params = $.parseJSON(params);
                } else {
                    params = {};
                }
                GM.controller.event_to_js({
                    action: action,
                    params: params
                });
            }
        });
        $('#container a[href], #overlay a[href]').live('click', function (e) {
            var url = $(this).attr('href');
            e.preventDefault();
            if (url !== '#') {
                GM.controller.event_to_native('openUrl', {
                    url: url
                });
            }
            return false;
        });
        if (GM.data.userData.mode === 'production') {
            $('html').live('contextmenu', function () {
                return false;
            });
        }
        $('.left_nav_category h4').live('click', function (e) {
            var $this = $(this),
                $container = $this.closest('div.left_nav_category'),
                id = $this.attr('id').replace('left_nav_header_', '');
            if ($container.hasClass('open')) {
                $container.find('ul').slideUp(250, function () {
                    $container.removeClass('open').addClass('closed');
                    GM.navigation._groups[id].state = 'closed';
                });
            } else {
                $container.find('ul').slideDown(250, function () {
                    $container.removeClass('closed').addClass('open');
                    GM.navigation._groups[id].state = 'open';
                });
            }
        });
        $('.link_label').live('click', function (e) {
            e.preventDefault();
            var targetID = '#' + $(this).attr('data-linkedLabel');
            $(targetID).click();
        });
        $('.helpArticleLink').live('click', function (e) {
            e.preventDefault();
            var articleID = $(this).attr('data-helpArticle');
            if (articleID) {
                GM.controller.event_to_native('openUrl', {
                    url: GM.urls.get_url('help') + '?rn=' + GM.text[articleID.toString()]
                });
            }
        });
        $('.strm_subscribe').live('click', function (e) {
            e.preventDefault();
            GM.overlay.buy({
                urlKey: 'strm_subscribe'
            });
            GM.overlay.attachStreamingReload();
        });
        $(document).keydown(function (e) {
            if (GM.data.overlay && GM.data.overlay == 'login' && e.which == 13) {
                if ($('#o_forgot_submit').is(':visible')) {
                    $('#o_forgot_submit .btn').click();
                } else if ($('#o_login_submit').is(":visible")) {
                    $('#o_login_submit .btn').click();
                } else if ($('#o_signup_submit').is(":visible")) {
                    $('#o_signup_submit .btn').click();
                }
            }
            if (!GM.data.overlay && GM.data.userData.sort.page === 'sort_az' && e.which && GM.clicks._key_codes[e.which]) {
                if (!e.metaKey && !e.altKey && !e.ctrkKey) {
                    $.each(GM.game_rows.sorted[GM.data.userData.sort.sort], function (i, wrappingID) {
                        if (GM.data.installedGames[wrappingID].name.substring(0, 1).toLowerCase() === GM.clicks._key_codes[e.which]) {
                            GM.render.scroll_to_game(wrappingID);
                            return false;
                        }
                        return true;
                    });
                }
            }
        });
	/*$('.casino_launcher').live('click', function(e) {
            e.preventDefault();
            GM.extendedFunctions.showCasino();
							   });*/
    },
    play_click: function (obj) {
        var wrapID = ($(obj).attr('data-wrapID') || $(obj).closest('.gm_row').attr('id'));
        var buttonSourceID = ($(obj).attr('data-source'));
        if (buttonSourceID && buttonSourceID.toLowerCase().indexOf("convert") > -1) {
            buttonSourceID = GM.data.userData.sort.page;
        }
        if (GM.extendedFunctions && GM.extendedFunctions.playGame) {
            GM.extendedFunctions.playGame(wrapID, buttonSourceID);
        }
    },
    _sort_click: function (obj) {
        var sort = 'sort_az';
        var page = 'sort_az';
        GM.data.userData.prev_page = GM.data.userData.sort.page;
        if ($(obj).hasClass('sort_az')) {
            sort = GM.data.userData.sort.sort || 'sort_az';
        } else if ($(obj).hasClass('recent_game')) {
            sort = null;
            page = 'recent_game';
            GM.render.draw_recent_game();
        } else if ($(obj).hasClass('gyb_page')) {
            sort = null;
            page = 'gyb_page';
            GM.render.draw_gyb();
        } else if ($(obj).hasClass('queue_download')) {
            sort = null;
            page = 'queue_download';
            GM.render.draw_dl_queue();
        } else if ($(obj).hasClass('queue_update')) {
            sort = null;
            page = 'queue_update';
            GM.render.draw_update_queue();
        } else if ($(obj).hasClass('ignore_sort')) {
            sort = null;
        }
        $('.sort_games').removeClass('sort_active');
        $('.' + page).addClass('sort_active');
        GM.ads.get_ad('left_nav', GM.data.userData.siteID);
        GM.data.userData.sort.page = page;
        if (sort) {
            var wrapID = ($(obj).attr('data-wrapID') || null);
            var scroll_to = (wrapID ? true : false);
            var sort_change = ($(obj).hasClass('sort_change') ? true : false);
            GM.render.draw_games(sort, wrapID, scroll_to, sort_change);
            GM.controller.event_to_native('saveUserData', {
                sort: JSON.stringify({
                    sort: sort,
                    page: page
                })
            });
        } else {
            $('#left_nav_ad').html(GM.ads.get_current_ad_html('left_nav', GM.data.userData.siteID));
        }
    },
    _sort_change: function (sort_type) {
        var sort_types = {
            sort_installed: "sort_installed",
            sort_played: "sort_played",
            sort_activation: "sort_activation"
        };
        var sort = sort_types[sort_type] || 'sort_az';
        var page = 'sort_az';
        GM.data.userData.prev_page = GM.data.userData.sort.page;
        GM.ads.get_ad('left_nav', GM.data.userData.siteID);
        GM.data.userData.sort.page = page;
		GM.render.draw_games(sort, null, false, false);
        GM.controller.event_to_native('saveUserData', {
            sort: JSON.stringify({
                sort: sort,
                page: page
            })
        });
    },
    _disable_text_selection: function () {
        document.onselectstart = function () {
            return false;
        };
    }
};
GM.clicks.init();
var GM = GM || {};
var event_to_js = function (stringified_json) {
    GM.controller.event_to_js(JSON.parse(stringified_json));
};
var javascriptToNative = function (json) {
    try {
        var native_handler;
        if (window.cef && window.cef.bigfish) {
            native_handler = window.cef.bigfish.native_handler();
        } else {
            native_handler = window.external;
            json = JSON.stringify(json);
        }
        native_handler.javascriptToNative(json);
    } catch (e) {
        GM.profiler.log('FAILED JStoNative: ' + json);
    }
};
GM.deferredObjects = {
    signInDeferred: $.Deferred(),
    hardwareIDDeferred: $.Deferred(),
    downloadDeferred: $.Deferred(),
    activateDeferred: $.Deferred(),
    purchaseHistoryDeferred: $.Deferred(),
    overlayCloseDeferred: $.Deferred(),
    overlayOpenDeferred: $.Deferred(),
    toolInstallDeferred: $.Deferred(),
    databaseQueryResult: $.Deferred(),
    priceListResult: $.Deferred(),
    dealListResult: $.Deferred(),
    gameUpdatesResult: $.Deferred(),
    FTPPageResult: $.Deferred()
};
GM.controller = {
    _pending_callback: null,
    event_to_native: function (action, params, use_pending_callback) {
        GM.console.log("        TO Native", action, params);
        if (use_pending_callback) {
            params.callback = this._pending_callback;
            this._pending_callback = null;
        }
        if (action == 'unloadPlugin') {
            setTimeout(function () {
                javascriptToNative({
                    action: action,
                    params: params
                });
            }, 10);
            return;
        }
        javascriptToNative({
            action: action,
            params: params
        });
    },
    event_to_js: function (json_data) {
        GM.console.log("    FROM Native", json_data.action, json_data.params);
        var callbacks = {
            close_overlay: function () {
                if (($.inArray(GM.data.overlay, GM.overlay._non_interruptible) > -1)) {
                    return;
                }
                GM.render.close_overlay();
            },
            draw_everything: function () {
                GM.render.draw_initial_view();
            },
            download_paused_overlay: function () {
                GM.overlay.open({
                    h2: GM.text.downloading_header,
                    msg: GM.text.downloading_msg,
                    err_prompt: GM.text.downloading_prompt
                });
            },
            cant_install_overlay: function () {
                GM.overlay.open({
                    h2: GM.text.installing_header,
                    msg: GM.text.installing_msg
                });
            },
            surveyPluginsResponse: function (data) {
                var platform = GM.data.userData.platform,
                    platformData = data.params.plugins[platform];
                if (typeof data.params.errorCode !== 'undefined' && data.params.errorCode !== 0) { }
                for (var surveyResult in platformData) {
                    if (typeof platformData[surveyResult] === 'string') {
                        platformData[surveyResult] = JSON.parse(platformData[surveyResult]);
                    }
                    GM.plugins._survey[surveyResult] = platformData[surveyResult];
                }
                GM.plugins._surveyDeferred.resolve();
            },
            unloadPluginResponse: function (data) {
                if (typeof data.params.errorCode !== 'undefined' && data.params.errorCode !== 0 && data.params.errorCode !== 1505) {
                    return GM.plugins._process[data.params.pluginName].trigger('error');
                }
                if ($.inArray(data.params.pluginName, GM.plugins._needsUpdate) > -1) {
                    GM.overlay.open('busy', {
                        msg: GM.text.installing_plugin_msg
                    });
                }
                GM.plugins._process[data.params.pluginName].trigger('download');
            },
            appDataDownloadResponse: function (data) {
                GM.overlay.close();
                if (typeof data.params.error !== 'undefined' && data.params.error !== 0) {
                    if ($.inArray(data.params.appDataKeyValue, GM.plugins._needsUpdate) > -1) {
                        return GM.plugins._process[data.params.appDataKeyValue].trigger('error');
                    }
                }
                if (($.inArray(data.params.appDataKeyValue, GM.plugins._needsUpdate) > -1) || ($.inArray(data.params.appDataKeyValue, GM.plugins._needsInstall) > -1)) {
                    GM.plugins._process[data.params.appDataKeyValue].trigger('survey');
                }
            },
            downloadAndExtractResponse: function (data) {
                if (typeof data.params.errorCode !== 'undefined' && data.params.errorCode !== 0) {
                    return GM.plugins._process[data.params.pluginName].trigger('error');
                }
                GM.plugins._process[data.params.downloadContext].trigger('survey');
            },
            loadPluginResponse: function (data) {
                if (typeof data.params.errorCode !== 'undefined' && data.params.errorCode !== 0) {
                    return GM.plugins._process[data.params.pluginName].trigger('error');
                }
                GM.plugins._process[data.params.pluginName].trigger('ready');
            },
            draw_left_nav: function () {
                GM.render.draw_left_nav();
            },
            ErrorMessage: function (data) {
                if (typeof data.params.errorCode === 'undefined') {
                    GM.console.log("ErrorMessage did not contain data.params.errorCode or it was a string, not processing error");
                    return;
                }
                var noInternetErrors = [7602, 7601, 7800, 7603];
                if ($.inArray(data.params.errorCode, noInternetErrors) >= 0) {
                    GM.console.log("No Internet Error Reached!");
                    GM.data.userData.isOnline = false;
                    data.params.errorCode = 1400;
                }
                var streamingNoMessageErrors = [2060, 2070, 5001, 7102, 7010, 7011, 7012, 7013, 7050, 7051, 7109, 7158, 7159, 7160, 7161, 7162, 7170, 9102];
                if ($.inArray(data.params.errorCode, streamingNoMessageErrors) >= 0) {
                    GM.console.log("Error message was among the chosen that do not have customer facing messages.");
                    return;
                }
                GM.overlay.open("error", {
                    errorCode: data.params.errorCode
                });
            },
            Content: function (data) {
                if (typeof data.params.data == "string") {
                    data.params.payload = JSON.parse(data.params.data);
                }
                var payload = data.params.payload,
                    command, module = '',
                    method = '',
                    params = [];
                for (var i = 0; i < payload.length; i++) {
                    command = payload[i];
                    module = command.module;
                    method = command.method;
                    params = typeof command.params !== 'undefined' ? command.params : [];
                    if (typeof GM[module] === 'object' && typeof GM[module][method] === 'function') {
                        GM[module][method](params);
                        if (params.urlKey === "strm_subscribe") {
                            GM.overlay.attachStreamingReload();
                        }
                    }
                }
                GM.content_header.draw_header();
                GM.render.draw_left_nav();
            },
            clientShutdownInitiation: function (data) {
                if (GM.util.isGameInstallInProgress()) {
                    GM.data.errorCode = 905;
                    GM.overlay.open("error", {
                        errorCode: 905
                    });
                    return;
                }
                GM.console.log("shuttin' it down there,luke");
                GM.util.shutGMDownForReals();
            }
        };
        if (json_data.action === 'composite_action' && json_data.params && $.ct(json_data.params, 'array')) {
            $.each(json_data.params, function (i, obj) {
                GM.controller.event_to_js(obj);
            });
            return;
        }
        if (json_data.action && $.ct(json_data.action, 'string') && json_data.params && $.ct(json_data.params, 'object')) {
            var p = json_data.params;
            if (typeof json_data.params.errorCode === "string") {
                var temp = parseInt(json_data.params.errorCode, 10);
                if (!isNaN(temp)) {
                    json_data.params.errorCode = temp;
                }
            }
            if (p.callback) {
                this._pending_callback = p.callback;
            }
            GM.profiler.log(json_data);
            if (typeof callbacks[json_data.action] === 'function') {
                return callbacks[json_data.action].call(null, json_data);
            }
            switch (json_data.action) {
                case 'purchaseComplete':
                    if (p.wrappingIDs) {
                        GM.util.handleActivationForWrappingIDList(p.wrappingIDs, "GMUnifiedStore");
                    }
                    break;
                case 'PrepareToStream':
                    if (GM.util.isGameInstallInProgress()) {
                        GM.deferredObjects.overlayCloseDeferred = $.Deferred();
                        GM.overlay.open('general', {
                            h2: GM.text.streaming_games_installing_header,
                            msg: GM.text.streaming_games_installing_text,
                            err_prompt: null
                        });
                        GM.deferredObjects.overlayCloseDeferred.done(function (result) {
                            GM.controller.event_to_native('pluginExecute', {
                                pluginName: 'streamingPlugin',
                                action: 'Event',
                                params: JSON.stringify({
                                    eventType: 101
                                })
                            });
                            GM.render.draw_dl_queue();
                        });
                    } else if (GM.util.isGameDownloadInProgress()) {
                        GM.util.pauseAllGameDownloads();
                        if (GM.persistedData.showDLP === -1) {
                            GM.deferredObjects.databaseQueryResult = $.Deferred();
                            GM.deferredObjects.databaseQueryResult.done(function (result) {
                                if (result) {
                                    var fetchedValue = "error";
                                    if (typeof result === 'string') {
                                        fetchedValue = JSON.parse(result).params.value;
                                    }
                                    if (fetchedValue === "false") {
                                        GM.persistedData.showDLP = false;
                                        GM.util.setDatabaseValue("persistent_db", "", "showDLP", "false");
                                        GM.plugins.showPlugin('streamingPlugin');
                                        GM.controller.event_to_native('pluginExecute', {
                                            pluginName: 'streamingPlugin',
                                            action: 'Event',
                                            params: JSON.stringify({
                                                eventType: 100
                                            })
                                        });
                                    } else {
                                        GM.persistedData.showDLP = true;
                                        GM.util.setDatabaseValue("persistent_db", "", "showDLP", "true");
                                        GM.overlay.show_download_pause();
                                    }
                                    console.log("fresh showDLP value, lets get the value from the db: " + GM.persistedData.showDLP);
                                }
                            });
                            GM.util.getDatabaseValue("persistent_db", "", "showDLP");
                        } else if (GM.persistedData.showDLP) {
                            GM.overlay.show_download_pause();
                        } else {
                            GM.plugins.showPlugin('streamingPlugin');
                            GM.controller.event_to_native('pluginExecute', {
                                pluginName: 'streamingPlugin',
                                action: 'Event',
                                params: JSON.stringify({
                                    eventType: 100
                                })
                            });
                        }
                    } else {
                        $('#header .float_right').addClass('disabled');
                        $('#left_nav .left_nav_category').addClass('disabled');
                        GM.plugins.showPlugin('streamingPlugin');
                        GM.controller.event_to_native('pluginExecute', {
                            pluginName: 'streamingPlugin',
                            action: 'Event',
                            params: JSON.stringify({
                                eventType: 100
                            })
                        });
                    }
                    break;
                case 'DisplayWait':
                    if (p.COMMAND_GM_PARAM_SHOW_WAIT == "true") {
                        $('#GM_header_spinner').show();
                    } else {
                        $('#GM_header_spinner').hide();
                    }
                    break;
                case 'pluginEvent':
                    if (typeof p.errorCode !== 'undefined' && p.errorCode !== 0) { }
                    if (p.eventType) {
                        if (typeof p.eventType != 'number') {
                            p.eventType = parseInt(p.eventType, 10);
                        }
                        if (isNaN(p.eventType)) {
                            GM.console.log("EVENT TYPE WAS NOT A NUMBER");
                            return;
                        }
                        if (p.eventType == 200) {
                            GM.console.log("LoadWebComplete");
                        } else if (p.eventType == 201) {
                            console.log("CloseLibraryComplete");
                            GM.plugins._process[p.pluginName].trigger('unload');
                        } else if (p.eventType == 202) {
                            GM.console.log("CloseSessionComplete");
                        } else if (p.eventType == 203) {
                            GM.console.log("PlayGameComplete");
                            if (!GM.plugins.getData('streamingPlugin', 'visible')) {
                                GM.plugins.stopStream();
                            }
                        } else if (p.eventType == 204) {
                            if (GM.data.overlay) {
                                GM.plugins.showPlugin('streamingPlugin', false);
                            }
                            GM.data.userData.isOnline = true;
                        } else if (p.eventType == 205) {
                            GM.data.userData.isStreamingOnline = true;
                        } else if (p.eventType == 206) { } else if (p.eventType == 207) { } else if (p.eventType == 208) {
                            if (!GM.plugins.getData('streamingPlugin', 'visible')) {
                                GM.plugins.stopStream();
                                return;
                            }
                            GM.plugins.setData('streamingPlugin', 'streamActive', true);
                            $('#header .float_right').addClass('disabled');
                            $('#left_nav .left_nav_category').removeClass('disabled');
                        } else if (p.eventType == 209) {
                            $('#header .float_right').removeClass('disabled');
                            $('#left_nav .left_nav_category').removeClass('disabled');
                            GM.util.resumePausedGameDownloadsIfNeeded();
                        } else if (p.eventType == 210) {
                            GM.plugins.setData('streamingPlugin', 'streamActive', false);
                            if (typeof GM.plugins._process[p.pluginName] !== 'undefined') {
                                GM.plugins._process[p.pluginName].trigger('close');
                            }
                            $('#header .float_right').removeClass('disabled');
                            $('#left_nav .left_nav_category').removeClass('disabled');
                            GM.util.resumePausedGameDownloadsIfNeeded();
                        } else {
                            console.log("Unsupported plugin eventType: " + p.eventType);
                        }
                    }
                    break;
                case 'pluginExecuteResponse':
                    if (p.errorCode && p.pluginName) {
                        if (p.errorCode == 1505) {
                            GM.plugins._process[p.pluginName].trigger('unload');
                        } else {
                            GM.overlay.open('error', {
                                errorCode: p.error
                            });
                        }
                    } else if (p.errorCode && p.errorCode !== 0) {
                        GM.overlay.open('error', {
                            errorCode: p.errorCode
                        });
                    }
                    break;
                case 'Refresh':
                    GM.user_data.update_user_data({
                        "updateReason": "refresh"
                    });
                    break;
                case 'resume':
                    GM.render.close_overlay();
                    break;
                case 'draw_everything':
                    GM.render.draw_initial_view();
                    break;
                case 'update_download_progress':
                    if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
                        GM.console.log("Streaming session active - pausing started download");
                        GM.util.pauseAllGameDownloads();
                    }
                    if (p.wrappingID && p.downloadProgress) {
                        GM.game_rows.update_progress(p.wrappingID, p.downloadProgress, p.downloadSize);
                    }
                    if (p.wrappingID && p.downloadID && GM.data.installedGames[p.wrappingID] && !GM.data.installedGames[p.wrappingID].sentSST && (p.downloadProgress == p.downloadSize)) {
                        fetchURL(GM.urls.get_url('gmTracking') + "?downloadid=" + p.downloadID, function (data) {
                            GM.data.installedGames[p.wrappingID].sentSST = true;
                            if (GM.tracking) {
                                GM.tracking.sendGameDownloadEvent(p.wrappingID);
                            }
                        });
                    }
                    break;
                case 'update_game_data':
                    if (p.installedGames) {
                        GM.game_rows.set_games(p.installedGames);
                    } else if (p.wrappingID) {
                        GM.game_rows.update_data_by_wrapID(p.wrappingID, p);
                        if (GM.data.userData.billboardsShown && ($.inArray('uac_notification', GM.data.userData.billboardsShown) < 0) && (GM.data.userData.platformDetails.name !== "XP")) {
                            if (p.gameState && p.gameState.state && parseInt(p.gameState.state, 10) === 6) {
                                GM.game_rows.set_uac_timeout(p.wrappingID);
                            }
                        }
                    }
                    if (p.drawView) {
                        GM.render.draw_initial_view();
                    }
                    GM.controller.event_to_qa('update_game_data', p);
                    break;
                case 'update_install_progress':
                    if (p.wrappingID && p.installProgress) {
                        GM.game_rows.update_progress(p.wrappingID, p.installProgress, p.downloadSize, true);
                    }
                    break;
                case 'update_user_data':
                    GM.user_data.update_user_data(p);
                    break;
                case 'redraw_game_rows':
                    if (p.wrappingID) {
                        var scroll_to = (p.scrollTo || false);
                        GM.render.draw_games(null, p.wrappingID, scroll_to);
                    } else {
                        GM.render.draw_games();
                    }
                    break;
                case 'remove_game':
                    if (p.wrappingID) {
                        GM.game_rows.remove_game(p.wrappingID);
                        GM.data.installedGamesCount--;
                    }
                    break;
                case 'remove_game_update':
                    if (p.wrappingID) {
                        GM.updates.remove_game_update(p.wrappingID);
                    }
                    break;
                case 'set_ads':
                    if ($.ct(p, 'object')) {
                        GM.ads.set_ads(p);
                    }
                    break;
                case 'set_deal_list':
                    GM.prices.set_deal_list(p);
                    if (GM.deferredObjects.dealListResult) {
                        GM.deferredObjects.dealListResult.resolve();
                    }
                    break;
                case 'set_game_updates':
                    if (p.wrappingID) {
                        GM.updates.set_single_game_update(p.wrappingID, p);
                    } else if ($.ct(p, 'array')) {
                        GM.updates.set_game_updates(p);
                    }
                    if (GM.deferredObjects.gameUpdatesResult) {
                        GM.deferredObjects.gameUpdatesResult.resolve();
                    }
                    break;
                case 'set_global_error_code':
                    if (p.errorCode) {
                        GM.data.errorCode = p.errorCode;
                    }
                    break;
                case 'set_login_error_code':
                    if (p.errorCode) {
                        GM.overlay.handle_login_error(p.errorCode);
                    }
                    break;
                case 'set_options':
                    GM.render.set_options(p);
                    break;
                case 'set_price_list':
                    if (p.priceList && p.ttl) {
                        GM.prices.set_price_list(p.priceList, p.ttl);
                        if (GM.deferredObjects.priceListResult) {
                            GM.deferredObjects.priceListResult.resolve();
                        }
                    }
                    break;
                case 'set_recently_played_game':
                    if (p.wrappingID) {
                        var is_same_game = (GM.data.recent === p.wrappingID);
                        GM.data.recent = p.wrappingID;
                        GM.render.draw_left_nav();
                        if (GM.data.userData.sort.page === 'recent_game') {
                            GM.render.draw_recent_game(false, null, is_same_game);
                        }
                        if (GM.data.userData.version.indexOf("3.3.") == 0 && (parseFloat(GM.data.installedGames[p.wrappingID].SDKVersion.match(/\d.\d/)) >= 2.0)) {
                            GM.controller.event_to_native('mergeSDKCookie', {});
                            GM.controller.event_to_native('flushCookieManager', {});
                        }
                    }
                    break;
                case 'set_upsells':
                    if (p.upsells) {
                        GM.data.upsell = p.upsells;
                        GM.render.initialize_upsells();
                    }
                    break;
                case 'set_urls':
                    GM.urls.set_urls(p);
                    break;
                case 'show_download_queue':
                    GM.render.draw_dl_queue();
                    break;
                case 'show_overlay':
                    if (p.overlayID) {
                        GM.render.show_overlay(p.overlayID, p);
                    }
                    break;
                case 'show_wrapper_screen':
                    if ((p.wrappingID) && (p.wrappingID == GM.extendedFunctions.casinoDLID)) {
					//GM.extendedFunctions.showCasino(true);
                        return;
                    }
                    if (GM.config.toolWrappingIDOverrideList.indexOf(p.wrappingID) != -1) {
                        return;
                    }
                    if (p.wrappingID) {
                        GM.data.recent = p.wrappingID;
                    }
                    if (p.errorCode || p.errorCode === 0) {
                        if (GM.data.recent && GM.data.installedGames[GM.data.recent]) {
                            GM.data.installedGames[GM.data.recent].gameState.errorCode = p.errorCode;
                        } else {
                            GM.data.errorCode = p.errorCode;
                        }
                    }
                    var is_pre_launch = p.isPreLaunch || false;
                    GM.render.draw_recent_game(is_pre_launch, p.creditsUsed);
                    break;
                case 'hardwareIDUpdate':
                    if (p.hardwareID) {
                        GM.data.userData.hardwareID = p.hardwareID;
                        GM.deferredObjects.hardwareIDDeferred.resolve(GM.data.userData.hardwareID);
                    }
                    break;
                case 'gameReadyToActivate':
                    if ((p.wrappingID) && (p.downloadID)) {
                        if (!GM.data.userData.hardwareID) {
                            GM.util.missingHardwareIDForActivation(p.wrappingID);
                        } else {
                            GM.util.retrieveActivationKey(p.downloadID, p.wrappingID, GM.data.userData.hardwareID, "1")
                        }
                    }
                    break;
                case 'stub':
                    if (p.purchaseID) {
                        if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
                            GM.console.log("Streaming session active - Purchase ignored");
                            return;
                        }
                        if (GM.data.userData.gameLibrary) {
                            var wrappingIDList = [];
                            $.each(GM.data.userData.gameLibrary, function (gameKey, gameValue) {
                                if (gameValue.transactionID == p.purchaseID) {
                                    wrappingIDList.push(gameValue.wrappingID);
                                }
                            });
                            if (wrappingIDList.length == 0) {
                                delete GM.data.userData.gameLibrary;
                            }
                        }
                        GM.util.installGamesFromPurchaseStub(p.purchaseID);
                    }
                    if (p.streamingGameID) {
                        if (typeof GM.data.userData.WizardOps !== 'undefined') {
                            GM.util.getManifestForStreamingGameStub(GM.data.userData.WizardOps);
                        }
                        if (GM.plugins.getData('streamingPlugin', 'streamActive')) {
                            GM.console.log("Streaming session active - Streaming request ignored");
                            return;
                        }
                        var streamingPage = "catalog/" + p.streamingGameID + "/info"
                        var streamingPageValue = "ucgs_catalog_" + p.streamingGameID + "_play";
                        GM.data.userData.sort.page = streamingPageValue;
                        GM.render.draw_streaming(streamingPage, {
                            page: streamingPage
                        });
                    }
				/*if (p.m) {
                        if (p.m == GM.extendedFunctions.casinoID) {
                            GM.extendedFunctions.showCasino(true);
                        }
                    }
                    if (p.gameID == GM.extendedFunctions.casinoDLID) {
                        if (p.downloadID) {
                            fetchURL(GM.urls.get_url('gmTracking') + "?downloadid=" + p.downloadID);
                        }
                        GM.extendedFunctions.showCasino();
                        GM.pseudoGameUtils.moveGameToInstallList(GM.extendedFunctions.casinoID);
				}*/
                    if ((p.gameID && !GM.data.installedGames[p.gameID]) || (p.gameID && GM.data.installedGames && GM.data.installedGames[p.gameID] && GM.data.installedGames[p.gameID].gameState.state != 5)) {
                        GM.tracking.sendGameDownloadInitEvent(p.gameID, "DownloadStub", p.downloadID);
                    }
                    break;
                case 'js_callback':
                    if (p.params) {
                        var pkg = p.params;
                        if (pkg.callback_id) {
                            var evalStr = pkg.callback_id + "( '{ " + '"action" : "' + p.action + '", "params" : ';
                            delete pkg.callback_id;
                            var params = JSON.stringify(pkg);
                            evalStr += params + " }' );";
                            eval(evalStr);
                        }
                    }
                    break;
                case 'first_run_stub':
                    if (p.gameID) {
                        if (GM.util.checkIfUserOnline(false)) {
                            var familyID = GM.tools.convertWrapIDToFamilyID(p.gameID);
                            var promiseGetTitle = $.ajax(GM.config.URLS.titleService + familyID);
                            var langID = p.gameID.match(/\d+(?=$)/);
                            promiseGetTitle.success(function (data) {
                                if (!$.isEmptyObject(data) && !$.isEmptyObject(data.families[familyID]) && !$.isEmptyObject(data.families[familyID].languages[langID]) && !$.isEmptyObject(data.families[familyID].languages[langID].ss1Image) && !$.isEmptyObject(data.families[familyID].languages[langID].featureImage)) {
                                    GM.data.userData.wizardSS1 = data.families[familyID].languages[langID].ss1Image;
                                    GM.data.userData.wizardFeatImage = data.families[familyID].languages[langID].featureImage;
                                    GM.overlay.open('wizard', {
                                        "overlayID": "wizard"
                                    });
                                }
                            });
                            promiseGetTitle.fail(function (data) { });
                        }
                    }
                    break;
                default:
                    GM.profiler.log('FAILED native_to_JS: ' + json_data);
            }
        }
    },
    event_to_qa: function (action, params) {
        $('body').trigger('automation', {
            action: action,
            params: params
        });
    }
};
window.onerror = function (msg, url, linenumber) {
    if (GM && GM.data && GM.data.userData && GM.data.userData.mode === 'development') {
        var message = "Whoops!  We just experienced an error!\n\n\n" + msg + "\n\nFile: " + url + ' (line ' + linenumber + ')';
        if (GM.data.userData.platform == 'mac') {
            console.log(message);
        } else {
            alert(message);
        }
    }
    return true;
};
var GM = GM || {};
GM.ads = {
    _billboard_triggered: false,
    _last_shown: {
        billboard: null,
        left_nav: null,
        spotlight: null
    },
    _key_map: {
        billboard: 'GMBillBoard',
        left_nav: 'GMLeftNav',
        spotlight: 'GMSpotlight'
    },
    get_time: function () {
        var date = new Date();
        if (GM.data.userData.mode === 'development' && GM.data.custom_time && GM.data.custom_time > 0) {
            date.setTime(GM.data.custom_time);
        }
        return Math.round(date.getTime() / 1000);
    },
    _set_urls: function (ad) {
        var date = new Date();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        month = (month < 10 ? '0' + month : month).toString();
        day = (day < 10 ? '0' + day : day).toString();
        var date_text = date.getFullYear().toString() + month + day;
        if (ad.HTML) {
            ad.HTML = ad.HTML.replace(/\[DATE\]/g, date_text);
        }
        if (ad.overlayHTML) {
            ad.overlayHTML = ad.overlayHTML.replace(/\[DATE\]/g, date_text);
        }
        return ad;
    },
    get_ad: function (type, siteID) {
        var gm_type = this._key_map[type];
        if (!gm_type) {
            return null;
        }
        if (GM.data.ads && GM.data.ads[gm_type] && GM.data.ads[gm_type][siteID]) {
            var last_shown = this._last_shown[type];
            if (last_shown) {
                var last_obj = GM.data.ads[gm_type][siteID][last_shown];
                if (last_obj && last_obj.isSticky && this._is_valid(last_obj)) {
                    return this._set_urls(last_obj);
                }
            }
            var billboards_shown = (GM.data.userData.billboardsShown && type === 'billboard' ? GM.data.userData.billboardsShown : []);
            var validity = [];
            var last_index = -1;
            var i = 0;
            $.each(GM.data.ads[gm_type][siteID], function (k, v) {
                if (k === GM.ads._last_shown[type]) {
                    last_index = i;
                }
                var is_valid = GM.ads._is_valid(v);
                if ($.inArray(k, billboards_shown) > -1) {
                    is_valid = false;
                }
                validity.push(is_valid ? k : 0);
                i++;
            });
            var j = last_index + 1;
            for (j; j < i; j++) {
                if (validity[j] !== 0) {
                    this._last_shown[type] = validity[j];
                    return this._set_urls(GM.data.ads[gm_type][siteID][validity[j]]);
                }
            }
            for (j = 0; j <= last_index; j++) {
                if (validity[j] !== 0) {
                    this._last_shown[type] = validity[j];
                    return this._set_urls(GM.data.ads[gm_type][siteID][validity[j]]);
                }
            }
        }
        return null;
    },
    get_current_ad_nickname: function (type) {
        return this._last_shown[type];
    },
    get_current_ad_html: function (type, siteID) {
        var ad = this._get_current_ad(type, siteID);
        if (!ad) {
            return null;
        }
        return ad.HTML;
    },
    get_current_ad_overlay: function (type, siteID) {
        var ad = this._get_current_ad(type, siteID);
        if (!ad) {
            return null;
        }
        return ad.overlayHTML;
    },
    set_ads: function (ad_manifest) {
        GM.data.ads = ad_manifest;
        this._last_shown.billboard = null;
        this._last_shown.left_nav = null;
        this._last_shown.spotlight = null;
        GM.render.draw_left_nav();
    },
    show_billboard: function () {
        if (GM.data.userData.isRetail || !GM.data.userData.isAdmin) {
            this._billboard_triggered = true;
        }
        if (!this._billboard_triggered) {
            var ad = this.get_ad('billboard', GM.data.userData.siteID);
            if (ad) {
                GM.overlay.open('ad', {
                    html: ad.overlayHTML
                });
                GM.controller.event_to_native('setBillboardShown', {
                    billboardID: GM.ads.get_current_ad_nickname('billboard')
                });
                this._billboard_triggered = true;
            }
        }
    },
    _get_current_ad: function (type, siteID) {
        var gm_type = this._key_map[type];
        if (!gm_type) {
            return null;
        }
        var ad = null;
        if (this._last_shown[type]) {
            ad = GM.data.ads[gm_type][siteID][this._last_shown[type]];
        } else {
            ad = this.get_ad(type, siteID);
        }
        return ad;
    },
    _is_valid: function (ad) {
        var time = this.get_time();
        if (ad.startTime > time || ad.endTime <= time) {
            return false;
        }
        var is_valid = true;
        $.each(ad.condition, function (k, v) {
            if (k === 'gameNotInstalled') {
                is_valid = ($.ct(GM.data.installedGames[v], 'object') ? is_valid : false);
            } else if (k === 'gameData' && $.ct(v, 'object') && GM.data.recent) {
                var ginfo = GM.data.installedGames[GM.data.recent];
                if (ginfo) {
                    $.each(v, function (k1, v1) {
                        if (typeof ginfo[k1] === 'undefined') {
                            is_valid = false;
                        } else if ($.ct(v1, 'string') && $.inArray(v1.substr(0, 1), ['<', '>']) > -1) {
                            var v2 = v1.substr(1);
                            is_valid = ((v1.substr(0, 1) === '<' ? (ginfo[k1] < v2) : (ginfo[k1] > v2)) ? is_valid : false);
                        } else if ($.ct(v1, 'array')) {
                            is_valid = ($.inArray(ginfo[k1], v1) > -1 ? is_valid : false);
                        } else if (ginfo[k1] !== v1) {
                            is_valid = false;
                        }
                    });
                }
            } else {
                if ((typeof GM.data.userData[k] === 'undefined') || (GM.data.userData[k] !== v)) {
                    is_valid = false;
                }
            }
        });
        return is_valid;
    }
};
var GM = GM || {};
GM.profiler = {
    _timers: {},
    _get_time: function () {
        return new Date().getTime();
    },
    start_timer: function (name) {
        this._timers[name] = this._get_time();
    },
    end_timer: function (name) {
        if (GM.data.userData.mode !== 'development') {
            return true;
        }
        var now = this._get_time();
        if (this._timers[name]) {
            var diff = now - this._timers[name];
            delete this._timers[name];
            this.log(name + ': ' + String(diff) + 'ms' + (diff > 75 ? ' <--------------------------------' : ''), true);
        }
        return true;
    },
    log: function (message, is_timer) {
        if (GM.data.userData.mode !== 'development' || !GM.data.userData.ui_logging_active) {
            return true;
        }
        var bfgLog_msg = (is_timer ? 'CLIENT_PERF_EVENT::' : 'CLIENT_ACTION::') + message;
        GM.controller.event_to_native('bfgLog', {
            message: bfgLog_msg
        });
        if (typeof console !== 'undefined') {
            console.log(message);
        }
        return true;
    }
};
var GM = GM || {};
GM.sallig = {
    handleSignup: function (data) {
       GM.util.lastLoginCache.time = 0;
 
       if(GM.data.userData.platform == 'windows') {
            try {
     	       var responseText = data.responseText;
        	    responseText = responseText.replace("(", "");
            	responseText = responseText.replace(")", "");
            	responseText = responseText.replace(";", "");
        	}
        	catch (e) {
            	console.log("handleSignup error = " + e.message);
        	}

        	var json = {};
        	try {
            	json = JSON.parse(responseText);
        	}
        	catch (e) {
            	console.log(e.message);
        	}

        	data = json;
        }
                
        if (data.success) {
            GM.controller.event_to_native('loginComplete', {
                email: data.useremail,
                usertoken: data.usertoken
            });
            GM.data.userData.isLoggedIn = true;
            GM.util.refreshBFGSess();
            setTimeout("GM.deferredObjects.signInDeferred.resolve(true);GM.overlay.close();", GM.sallig.timeoutWaitTime);
        } else {
            $('#o_signup_submit #temp_spinner').remove();
            $('#o_signup_submit .btn_login').css('visibility', 'visible');
            $('#o_login_errors').show();
            $('#o_login_info').hide();
            GM.data.userData.isLoggedIn = false;
            var errors = "";
            if ((data.reg_email) && (data.reg_email.msg)) {
                errors += data.reg_email.msg;
                errors += "<BR>";
            }
            if ((data.reg_pass) && (data.reg_pass.msg)) {
                errors += data.reg_pass.msg;
                errors += "<BR>";
            }
            if ((data.reg_pass_confirm) && (data.reg_pass_confirm.msg)) {
                errors += data.reg_pass_confirm.msg;
                errors += "<BR>";
            }
            if ((data.reg_username) && (data.reg_username.msg)) {
                errors += data.reg_username.msg;
                errors += "<BR>";
            }
            if ((data.persistent) && (data.persistent.msg)) {
                errors += data.persistent.msg;
                errors += "<BR>";
            }
            if ((data.unknown) && (data.unknown.msg)) {
                errors += data.unknown.msg;
                errors += "<BR>";
            }
            $('#o_login_error_text').html(errors);
        }
    },
    
 
    sdkLoginFunction: function (data) {
        GM.sallig.handleLogin(data);
    },

    handleLogin: function (data) {
  
       GM.util.lastLoginCache.time = 0;

        try
        {
            if (data.success) {

                if (data.useremail == null || data.usertoken == null) {
                    GM.overlay.open('error', {
                        errorCode: 1405
                    });
                    return;
                }
                GM.controller.event_to_native('loginComplete', {
                    email: data.useremail,
                    usertoken: data.usertoken
                });

                GM.data.userData.isLoggedIn = true;
                GM.util.refreshBFGSess();
                setTimeout("GM.deferredObjects.signInDeferred.resolve(true);GM.overlay.close();", GM.sallig.timeoutWaitTime);
            } else {

                GM.data.userData.isLoggedIn = false;

     
                var errors = "";
                if ((data.email_login) && (data.email_login.msg)) {
                    errors += data.email_login.msg;
                    errors += "<BR>";
                }
                if ((data.pass) && (data.pass.msg)) {
                    errors += data.pass.msg;
                    errors += "<BR>";
                }
                if ((data.persistent) && (data.persistent.msg)) {
                    errors += data.persistent.msg;
                    errors += "<BR>";
                }
                if ((data.unknown) && (data.unknown.msg)) {
                    errors += data.unknown.msg;
                    errors += "<BR>";
                }

               $('#o_login_submit #temp_spinner').remove();
               $('#o_login_submit .btn_login').css('visibility', 'visible');
               $('#o_login_errors').show();
               $('#o_login_info').hide();
               $('#o_login_error_text').html(errors);
            }
        }
        catch (e) {
            console.log(e.message);
        }
    },
    handleForgot: function (data) {
        $('#o_forgot_submit #temp_spinner').remove();
        $('#o_forgot_submit .btn_login').css('visibility', 'visible');
        if (data.success) {
            var email = $('#o_forgot_email').val();
            $('#o_login_info').show();
            $('#o_login_info_text').html(data.msg);
            $('#o_login_errors').hide();
            $('#o_signup_section').hide();
            $('#o_forgot_section').hide();
            $('#o_login_section').show();
            $('#o_login_selection').show();
            $('#o_login_email').val(email);
        } else {
            $('#o_login_errors').show();
            $('#o_login_error_text').html(data.email_forgot.msg);
        }
    },
    forgot: function (email) {
        var url = GM.urls.get_susi_url(GM.data.userData.siteID, "salliGForgot");
        url = url.replace("[EMAIL]", email);
        fetchURL(url, function (data) {
            GM.sallig.handleForgot(data);
        });
    },
    // KD windows now different
    login: function (email, passwd, persist) {
        var url = GM.urls.get_susi_url(GM.data.userData.siteID, "salliGLogin");
        var persistVal = '';
        if (persist) {
            persistVal = 'yes';
        }
        var platform = GM.data.userData.platform == 'windows' ? 'pc' : 'mac';
        url = url.replace("[EMAIL]", encodeURIComponent(email));
        url = url.replace("[PASSWD]", encodeURIComponent(passwd));
        url = url.replace("[PERSIST]", encodeURIComponent(persistVal));
        url = url.replace("[PLATFORM]", encodeURIComponent(platform));
        
        if(platform == 'pc') { //Windows

            var data = GM.util.fetchURLBlocking(url, null);

            var responseText = data;
            responseText = responseText.replace("(", "");
            responseText = responseText.replace(")", "");
            responseText = responseText.replace(";", "");

            var json = {};
            try {
                json = JSON.parse(responseText);
            }
            catch (e) {
                console.log(e.message);
            }

            try {
                GM.sallig.handleLogin(json);
            }
            catch (e) {
                console.log(e.message);
            }
        } else {   //Mac
            fetchURL(url, function (data) {
                GM.sallig.handleLogin(data);
            });
         }
    },
 

    logout: function () {
        var url = GM.urls.get_susi_url(GM.data.userData.siteID, "logout");
        $.ajax({
            url: url,
            dataType: 'jsonp',
            async: false
        }).done(function () {
            GM.util.lastLoginCache.time = 0;
            GM.controller.event_to_native('logout', {});
            if (GM.tracking) {
                GM.tracking.sendPageViewEvent({
                    "page": "SIGNOUT"
                });
            }
        });
    },
    signup: function (email, passwd, passwd2, persist, newsletter, mustAccept) {
        if (!mustAccept) {
            $('#o_login_errors').show();
            $('#o_login_info').hide();
            $('#o_login_error_text').html(GM.text.o_signup_must_accept_error_text);
            $('#o_signup_submit #temp_spinner').remove();
            $('#o_signup_submit .btn_login').css('visibility', 'visible');
            return;
        }
        var url = GM.urls.get_susi_url(GM.data.userData.siteID, "salliGSignup");
        var newsVal = '';
        if (newsletter) {
            optout_no_sites = ["5", "2", "4"];
            optout_yes_sites = ["6", "15", "16", "17", "18", "19"];
            if ($.inArray(GM.data.userData.siteID, optout_no_sites) >= 0) {
                newsVal = '&reg_optout_nl=no';
            } else if ($.inArray(GM.data.userData.siteID, optout_yes_sites) >= 0) {
                newsVal = '&reg_optout_nl=yes';
            }
        }
        var platform = GM.data.userData.platform == 'windows' ? 'pc' : 'mac';
        url = url.replace("[EMAIL]", encodeURIComponent(email));
        url = url.replace("[PASSWD]", encodeURIComponent(passwd));
        url = url.replace("[PASSWD2]", encodeURIComponent(passwd2));
        url = url.replace("[PERSIST]", 'yes');
        url = url.replace("[NEWSLETTER]", newsVal);
        url = url.replace("[PLATFORM]", encodeURIComponent(platform));

        if (platform == 'pc') { //Windows
            var data = GM.util.fetchURLBlocking(url, null);

            var responseText = data; //.responseText;
            responseText = responseText.replace("(", "");
            responseText = responseText.replace(")", "");
            responseText = responseText.replace(";", "");

            var json = {};
            try {
                json = JSON.parse(responseText);
            }
            catch (e) {
                console.log(e.message);
            }
            try {
                GM.sallig.handleSignup(json);
            }
            catch (e) {
                console.log(e.message);
            }
        } else {
            fetchURL(url, function (data) {
                GM.sallig.handleSignup(data);
            });
        }
    }
};
var GM = GM || {};
GM.util = {
    lastLoginCache: {
        time: 0,
        data: {}
    },
    checkLogin: function (options) {
        var now = Date.now(),
            data, defaults = {
                useCache: true,
                blockUI: false,
                allowRetry: true,
                threshold: 60 * 1000,
                success: function () { },
                error: function () { },
                complete: function () { },
                timeout: 15 * 1000
            };
        var disableNav = function () {
            if (typeof GM.navigation._groups['streaming'] == "undefined") {
                return;
            }
            GM.navigation._groups['streaming'].build = function (self) {
                self.listClasses = 'disabled';
                self.after = '<span class="spinner"><img src="../images/s/icons/spinner_on_dark_bg2.gif"></span>';
                self.category_class = '';
                return self;
            };
            $('#GM_header_spinner').show();
            GM.render.draw_left_nav();
        };
        var enableNav = function () {
            if (typeof GM.navigation._groups['streaming'] == 'object') {
                GM.navigation._groups['streaming'].build = function (self) {
                    return self;
                };
            }
            $('#GM_header_spinner').hide();
            GM.render.draw_left_nav();
        };
        options = $.extend({}, defaults, options);
        if (GM.urls.get_url('checkLogin') == '#') {
            if (typeof options.error === 'function') {
                options.error.call();
            }
            return false;
        }
        disableNav();
        if (!options.useCache || now - GM.util.lastLoginCache.time > options.threshold) {
            if (options.blockUI) {
                data = GM.util.fetchURLBlocking(GM.urls.get_url('checkLogin'), options);
                GM.util.lastLoginCache = {
                    time: now,
                    data: data
                };
                GM.util.setLoginStatus(data);
                enableNav();
            } else {
                GM.util.fetchURL(GM.urls.get_url('checkLogin'), options, function (data) {
                    GM.util.lastLoginCache = {
                        time: Date.now(),
                        data: data
                    };
                    GM.util.setLoginStatus(data);
                }).done(function () {
                    enableNav();
                }).fail(function (xhr, status, message) {
                    if (options.allowRetry && (status == 'timeout' || status == 'parsererror')) {
                        options.useCache = false;
                        options.allowRetry = false;
                        GM.util.checkLogin(options);
                    }
                });
            }
        }
        return GM.util.getLoginStatus();
    },
    shutGMDownForReals: function () {
        GM.overlay.open('gm_exit');
        GM.util.pauseAllGameDownloads();
        GM.plugins.shutdown();
    },
    getManifestForStreamingGameStub: function (options) {
        email = options.email;
        wrappingID = "F619T1L1";
        siteID = 1;
        langID = 1;
        optIn = 0;
        if (options.getDeals) {
            optIn = 1;
        }
        var url = GM.urls.get_url("gameService", siteID);
        if (url == '#') {
            return;
        }
        var dataString = '<';
        dataString += '?xml version="1.0" encoding="iso-8859-1"?><methodCall><methodName>gms.getGameInfo</methodName><params><param><value><struct><member><name>email</name><value><string>';
        dataString += email + "</string></value></member><member><name>gameWID</name><value><string>";
        dataString += wrappingID + "</string></value></member><member><name>siteID</name><value><int>";
        dataString += siteID + "</int></value></member><member><name>languageID</name><value><int>";
        dataString += langID + "</int></value></member><member><name>optIn</name><value><int>";
        dataString += optIn + "</int></value></member><member><name>downloadID</name><value><int>0</int></value></member></struct></value></param></params></methodCall>";
        $.ajax(url, {
            processData: false,
            data: dataString,
            type: "post",
            dataType: "xml",
            contentType: "text/xml"
        });
    },
    setLoginStatus: function (data) {
        GM.data.userData.streamingData = data;
        if ('undefined' != typeof (data.segment)) {
            GM.data.userData.streamingSegment = data.segment;
        }
        if ('undefined' != typeof (data.basic)) {
            GM.data.userData.basicStreamingUser = data.basic;
        }
    },
    getLoginStatus: function () {
        return GM.data.userData.isLoggedIn;
    },

    checkIfUserOnline: function (showErrorIfOffline) {
        var result = GM.util.fetchURLBlocking(GM.urls.get_url('onlineCheck'));
        if (result) {
            GM.data.isUserOnline = true;
        } else {
            GM.data.isUserOnline = false;
            if (showErrorIfOffline) {
                GM.overlay.open('error', {
                    errorCode: 1400
                });
                GM.util.errorLog("Error 1400 - User if offline. Checking " + GM.urls.get_url('onlineCheck'));
            }
        }
        return GM.data.isUserOnline;
    },
    isGameInstallInProgress: function () {
        var installCount = 0;
        var installingStates = [4, 6, 11];
        $.each(GM.data.installedGames, function (game, gameData) {
            if ($.inArray(gameData.gameState.state, installingStates) > -1) {
                installCount++;
            }
        });
        return (0 < installCount);
    },
    isGameDownloadInProgress: function () {
        var downloadingStates = [1, 16];
        var downloadCount = 0;
        $.each(GM.data.installedGames, function (game, gameData) {
            if ($.inArray(gameData.gameState.state, downloadingStates) > -1) {
                downloadCount++;
            }
        });
        return (0 < downloadCount);
    },
    pauseAllGameDownloads: function () {
        var downloadingStates = [1, 16];
        if (typeof GM.data.forcedPausedDownloads === 'undefined') {
            GM.data.forcedPausedDownloads = [];
        }
        $.each(GM.data.installedGames, function (game, gameData) {
            if ($.inArray(gameData.gameState.state, downloadingStates) > -1) {
                GM.controller.event_to_native('pauseGameDownload', {
                    wrappingID: gameData.wrappingID
                });
                if (gameData.gameState.state == 1) {
                    GM.data.forcedPausedDownloads.unshift(gameData.wrappingID);
                } else {
                    GM.data.forcedPausedDownloads.push(gameData.wrappingID);
                }
            }
        });
    },
    resumePausedGameDownloadsIfNeeded: function () {
        if ((!GM.data.forcedPausedDownloads) || (GM.data.forcedPausedDownloads.length == 0)) {
            return;
        }
        $.each(GM.data.forcedPausedDownloads, function (index, wrapID) {
            if ((GM.data.installedGames[wrapID].gameState) && (GM.data.installedGames[wrapID].gameState.state == 10)) {
                GM.controller.event_to_native('downloadGame', {
                    wrappingID: wrapID
                });
            }
        });
        GM.data.forcedPausedDownloads = [];
    },
    fetchURLBlocking: function(url, options, callback) {
		var defaults;
        var outputdata = "";
        var request;
        var options;
		
     	if (GM.data.userData.platform == 'windows') { 
        	defaults = {
        	    async: false,
            	dataType: 'text',
            	type: 'GET'
        	};

        	options = $.extend({}, defaults, options);

    	    request = GM.util.fetchURL(url, options, callback);
           	request.always(function (data) {
               	outputdata = data;
           	});

     	} else {
        	defaults = {
            	async: false,
            	dataType: 'json',
            	type: 'GET'
        	};

        	options = $.extend({}, defaults, options);

            request = GM.util.fetchURL(url, options);
        	request.done(function(data) {
            	outputdata = data;
       		 });
     	}
        return outputdata;
    },
    fetchURL: function(url, options, callback) {
		var request, params;
       	if (typeof options === 'function' && typeof callback === 'undefined') {
            callback = options;
            options = {};
        }

       	if (GM.data.userData.platform == 'windows') { //windows
	       	params = {};
        } else {
	        params = {
    	        dataType: 'jsonp'
        	};
        }    
        	params = $.extend({}, params, options);
        	request = $.ajax(url, params);
        	request.always(function(data) {
    	        if (typeof callback === 'function') {
        	        callback.call(null, data);
	        	    }
        		});
        	return request;
    },
    
     getDatabaseValue: function (databaseType, table, key, callback) {
        if (!callback) {
            callback = "GM.deferredObjects.databaseQueryResult.resolve";
        }
        GM.controller.event_to_native(databaseType, {
            "action": "getkeyvalue",
            "table": table,
            "key": key,
            "value": "",
            "callback_id": callback
        });
    },
    setDatabaseValue: function (databaseType, table, key, value, callback) {
        if (!callback) {
            callback = "GM.deferredObjects.databaseQueryResult.resolve";
        }
        GM.controller.event_to_native(databaseType, {
            "action": "setkeyvalue",
            "table": table,
            "key": key,
            "value": value,
            "callback_id": callback
        });
    },
    removeDatabaseValue: function (databaseType, table, key, callback) {
        if (!callback) {
            callback = "GM.deferredObjects.databaseQueryResult.resolve";
        }
        GM.controller.event_to_native(databaseType, {
            "action": "removekeyvalue",
            "table": table,
            "key": key,
            "value": "",
            "callback_id": callback
        });
    },
    retrieveActivationKey: function (downloadID, wrappingID, hardwareID, gameIndex) {
        if ((typeof downloadID === 'undefined') || (downloadID === null)) {
            downloadID = "0";
        }
        if (!GM.data.userData.isLoggedIn) {
            GM.deferredObjects.signInDeferred = $.Deferred();
            GM.deferredObjects.signInDeferred.done(function (result) {
                if (result) {
                    GM.util.retrieveActivationKey(downloadID, wrappingID, hardwareID, gameIndex);
                    GM.deferredObjects.signInDeferred = $.Deferred();
                }
            });
            GM.overlay.open('login', {});
            return;
        }
        var postData = [{
            "wrappingID": wrappingID,
            "downloadID": downloadID,
            "hardwareID": hardwareID,
            "gameIndex": gameIndex
        }];
        if (typeof GM.data.installedGames[wrappingID] == 'undefined') {
            GM.console.log("We are trying to activate a game that we don't own.");
            return;
        }
        var site = GM.data.installedGames[wrappingID].siteID;
        var url = GM.urls.get_url('activation', site);
        GM.data.activationWrappingID = wrappingID
        var xhr = $.ajax(url, {
            type: "POST",
            headers: {
                'user-token': GM.data.userData.usertoken
            },
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(postData)
        }).done(function (data) {
            GM.controller.event_to_native('activateGame', {
                'activationKey': data.activations[0].activationKey,
                'email': data.activations[0].email,
                'wrappingID': data.activations[0].wrappingID
            });
            GM.data.recent = wrappingID;
            GM.data.activationWrappingID = "";
            GM.render.draw_recent_game(false, false, false);
        }).error(function (data) {
            var errorCode = 1402;
            if (data.status == 500) {
                var errorJSON;
                try {
                    errorJSON = JSON.parse(data.responseText);
                } catch (error) {
                    errorCode = 1402;
                }
                if (errorJSON) {
                    if (errorJSON.faultCode == 406) {
                        errorCode = 208;
                        if (GM.data.activationWrappingID) {
                            var gameData = {
                                "gameState": {
                                    "state": 8,
                                    "errorCode": 208
                                }
                            };
                            GM.game_rows.update_data_by_wrapID(GM.data.activationWrappingID, gameData);
                            GM.render.draw_dl_queue();
                        }
                    } else {
                        errorCode = "1402-" + errorJSON.faultCode;
                    }
                }
            }
            GM.overlay.open('error', {
                errorCode: errorCode
            });
            GM.sallig.logout();
            GM.util.errorLog("Error" + errorCode + " - Problem obtaining the activation key for " + wrappingID);
            GM.data.activationWrappingID = "";
        });
    },
    retrieveHardwareID: function () {
        GM.controller.event_to_native('hardwareIDRequest', {});
    },
    getPurchaseHistoryList: function () {
        var url = GM.urls.get_url('purchaseHistory');
        $.ajax(url, {
            headers: {
                'user-token': GM.data.userData.usertoken
            },
            contentType: "application/json; charset=utf-8"
        }).always(function (data) {
            if (data.gameLibrary) {
                GM.data.userData.gameLibrary = [];
                $.each(data.gameLibrary, function (gameKey, gameValue) {
                    gameValue.button = {
                        size: 'sm',
                        color: 'blue',
                        wrapID: gameValue.wrappingID,
                        sourceOfButton: "PurchaseHistory"
                    };
                    gameValue.activationRank = 5;
                    if (gameValue.typeID != GM.data.gameType) {
                        gameValue.button.name = "wrongPlatform";
                    } else if (!GM.data.installedGames[gameValue.wrappingID]) {
                        gameValue.activationRank = 1;
                        gameValue.button.name = "download";
                        gameValue.button.type = "download";
                        gameValue.button.forPurchase = true;
                        gameValue.button.text = GM.text.download;
                        gameValue.button.blank = true;
                    } else if (GM.data.installedGames[gameValue.wrappingID].activated) {
                        gameValue.activationRank = 2;
                        gameValue.button.name = "play";
                        gameValue.button.type = "play";
                        gameValue.button.text = GM.text.play;
                    } else if (gameValue.activationAvailable && (GM.data.installedGames[gameValue.wrappingID].gameState.state == 5)) {
                        gameValue.activationRank = 0;
                        gameValue.button.name = "activate";
                        gameValue.button.type = "reactivate";
                        gameValue.button.text = GM.text.activate;
                    } else if (GM.data.installedGames[gameValue.wrappingID].gameState.state != 5) {
                        gameValue.activationRank = 3;
                        gameValue.button.name = 'nonPlayable';
                    }
                    if ((gameValue.revokeTimestamp == 0) && (gameValue.refundTimestamp == 0)) {
                        GM.data.userData.gameLibrary.push(gameValue);
                    }
                });
                GM.deferredObjects.purchaseHistoryDeferred.resolve();
            } else {
                GM.util.errorLog("Error - We got an error retrieving the purchase history list.");
                if (GM.data.userData.page == "purchase_history_page") {
                    GM.overlay.open('error', {
                        errorCode: 1404
                    });
                    GM.sallig.logout();
                    $(".sort_az").click();
                }
            }
        });
    },
    installGamesFromPurchaseStub: function (purchaseID) {
        if (!GM.data.userData.isLoggedIn) {
            GM.deferredObjects.signInDeferred = $.Deferred();
            GM.deferredObjects.signInDeferred.done(function (result) {
                if (result) {
                    GM.util.installGamesFromPurchaseStub(purchaseID);
                    GM.deferredObjects.signInDeferred = $.Deferred();
                }
            });
            GM.overlay.open('login', {});
        } else if (!GM.data.userData.gameLibrary) {
            GM.deferredObjects.purchaseHistoryDeferred = $.Deferred();
            GM.util.getPurchaseHistoryList();
            GM.deferredObjects.purchaseHistoryDeferred.done(function () {
                GM.util.installGamesFromPurchaseStub(purchaseID);
                GM.deferredObjects.purchaseHistoryDeferred = $.Deferred();
            });
        } else {
            var wrappingIDList = [];
            $.each(GM.data.userData.gameLibrary, function (gameKey, gameValue) {
                if (gameValue.transactionID == purchaseID) {
                    wrappingIDList.push(gameValue.wrappingID);
                    console.log(wrappingIDList);
                }
            });
            if (wrappingIDList.length <= 0) {
                GM.overlay.open('error', {
                    errorCode: 208
                });
                GM.util.errorLog("Error 208 - Could not find any games associated with that user's account in their purchase history");
            } else {
                GM.util.handleActivationForWrappingIDList(wrappingIDList, "PurchaseStub");
            }
        }
    },
    handleActivationForWrappingIDList: function (wrappingIDList, sourceOfList) {
        for (i = 0; i < wrappingIDList.length; i++) {
            var shouldDownloadGame = true;
            wrappingID = wrappingIDList[i];
            var downloadingStates = [1, 16];
            if (typeof GM.data.installedGames[wrappingID] != 'undefined') {
                if ($.inArray(GM.data.installedGames[wrappingID].gameState.state, downloadingStates) > -1) {
                    shouldDownloadGame = false;
                } else if (GM.data.installedGames[wrappingID].gameState.state == 10) {
                    shouldDownloadGame = false;
                    GM.controller.event_to_native('downloadGame', {
                        wrappingID: wrappingID
                    });
                }
            }
            if (shouldDownloadGame) {
                var sourceOfEvent = "wrappingIDList";
                if (sourceOfList) {
                    sourceOfEvent = sourceOfList;
                }
                GM.tracking.sendGameDownloadInitEvent(wrappingIDList[i], sourceOfEvent);
                GM.util.activateSingleGame(wrappingIDList[i]);
            }
        }
    },
    activateSingleGame: function (wrappingID) {
        console.log("activating ", wrappingID);
        if (GM.data.installedGames[wrappingID]) {
            if (!GM.data.userData.hardwareID) {
                GM.util.missingHardwareIDForActivation(wrappingID);
            } else {
                if (GM.data.installedGames[wrappingID].trialType === 1) {
                    $("#download_queue").click();
                    GM.util.upgradeDemoToFull(wrappingID);
                } else {
                    GM.util.retrieveActivationKey(GM.data.installedGames[wrappingID].downloadID, wrappingID, GM.data.userData.hardwareID, "1");
                }
            }
        } else {
            GM.controller.event_to_native('downloadNewGame', {
                wrappingID: wrappingID,
                downloadFullVersion: true
            });
            GM.render.draw_dl_queue();
        }
    },
    hideAllActivePlugins: function () {
        $.each(GM.data.pluginsRequiringHide, function (index, pluginName) {
            if (GM.plugins.isEnabled(pluginName)) {
                GM.plugins.showPlugin(pluginName, false);
            }
        });
    },
    updatePagesAfterAuth: function (params) {
        params = params || {};
        if (typeof params.susiData !== 'undefined') {
            GM.data.userData['loginSource'] = 'ucgs';
            GM.controller.event_to_native('loginComplete', {
                email: params.susiData.useremail,
                usertoken: params.susiData.usertoken
            });
        }
    },
    missingHardwareIDForActivation: function (wrappingID) {
        GM.util.retrieveHardwareID();
        GM.overlay.open('error', {
            errorCode: 1401
        });
        GM.util.errorLog("Error 1401 - Unable to find the hardwareID");
        if (wrappingID) {
            var gameData = {
                "gameState": {
                    "state": 8,
                    "errorCode": 1401
                }
            };
            GM.game_rows.update_data_by_wrapID(wrappingID, gameData);
        }
    },
    upgradeDemoToFull: function (wrappingID) {
        var installingStates = [4, 6, 11];
        if ($.inArray(GM.data.installedGames[wrappingID].gameState.state, installingStates) > -1) {
            GM.util.errorLog("Attempted to upgrade demo to full while it was installing/activating");
            GM.render.draw_dl_queue();
            return;
        }
        var downloadingStates = [1, 16];
        if ($.inArray(GM.data.installedGames[wrappingID].gameState.state, downloadingStates) > -1) {
            GM.util.errorLog("Attempted to upgrade demo to full while it was downloading");
            GM.render.draw_dl_queue();
            return;
        }
        GM.controller.event_to_native("demoToFullUpgrade", {
            wrappingID: wrappingID
        });
    },
    refreshBFGSess: function () {
        if (!GM.util.checkIfUserOnline(false)) {
            return;
        }
        if (GM.data.userData.version.indexOf("3.3.") == 0) {
            GM.controller.event_to_native('flushCookieManager', {});
            return;
        } else {
            if (GM.data.userData.isLoggedIn) {
                $.ajax({
                    url: GM.urls.get_site_url()
                }).success(function (data, response, xhr) {
                    var bfgsessRegex = new RegExp('bfgsess' + '=(.*?)(?:;|$)', 'i');
                    var domainRegex = new RegExp('bfgsess' + '=(.*?)(?:;|$)*domain=(.*?)(?:;|$)', 'i');
                    var bfgsessregexMatch = xhr.getResponseHeader('Set-Cookie').match(bfgsessRegex);
                    if (!bfgsessregexMatch && GM.data.userData.isLoggedIn) {
                        GM.console.log("We don't have a bfgsess but we think we are logged in? whaaaaa? let's log out");
                        GM.sallig.logout();
                        return;
                    }
                    GM.data.userData.bfgsess = bfgsessregexMatch[1];
                    GM.data.userData.cookieDomain = xhr.getResponseHeader('Set-Cookie').match(domainRegex)[2];
                });
            } else {
                GM.console.log('not logged in');
                GM.data.userData.bfgsess = '';
            }
        }
    },
    updateUIBasedOnError: function (errorCode) {
        var views_to_skip = ['f2p_casino'];
        if (errorCode == 1400) {
            if ($.inArray(GM.data.userData.sort.page, views_to_skip) == -1) {
                $(".sort_az").click();
            }
        }
    },
    errorLog: function (message) {
        var bfgLog_msg = 'CLIENT_ERROR::' + message;
        GM.controller.event_to_native('bfgLog', {
            message: bfgLog_msg
        });
    },
    truncate: function (text, maxLength, ellipsis) {
        if ((typeof (text) != 'string') || (typeof (maxLength) != 'number') || (text.length <= maxLength)) {
            return text;
        }
        maxLength = ellipsis ? (maxLength - 3) : maxLength;
        return (text.slice(0, maxLength) + (ellipsis ? '...' : null));
}
};
$.fn['dimensions'] = function () {
    var $self = $(this);
    return {
        'elem': this,
        'top': $self.offset().top,
        'left': $self.offset().left,
        'width': $self.outerWidth(),
        'height': $self.outerHeight()
    };
};

function fetchURL(url, callback) {
    GM.util.fetchURL(url, callback);
}
if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function (searchElement) {
        "use strict";
        if (this === null) {
            throw new TypeError();
        }
        var t = Object(this);
        var len = t.length >>> 0;
        if (len === 0) {
            return -1;
        }
        var n = 0;
        if (arguments.length > 1) {
            n = Number(arguments[1]);
            if (n != n) {
                n = 0;
            } else if (n !== 0 && n != Infinity && n != -Infinity) {
                n = (n > 0 || -1) * Math.floor(Math.abs(n));
            }
        }
        if (n >= len) {
            return -1;
        }
        var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
        for (; k < len; k++) {
            if (k in t && t[k] === searchElement) {
                return k;
            }
        }
        return -1;
    };
}
var isEmpty = function (obj) {
    if (obj === null) {
        return true;
    }
    if (obj.length && obj.length > 0) {
        return false;
    }
    if (obj.length === 0) {
        return true;
    }
    for (var key in obj) {
        if (obj.hasOwnProperty(key)) {
            return false;
        }
    }
    return true;
};
var compareVersion = function (v1, v2) {
    var compare = function (i, j) {
        i = parseInt(i, 10) || 0;
        j = parseInt(j, 10) || 0;
        if (i < j) {
            return -1;
        } else if (i > j) {
            return 1;
        }
        return 0;
    },
        i = 0,
        c;
    v1 = v1.split('.');
    v2 = v2.split('.');
    while ((c = compare(v1[i], v2[i])) === 0) {
        if (typeof v1[i] === 'undefined' && typeof v2[i] === 'undefined') {
            break;
        }
        i++;
    }
    return c;
};
